<?php
//
// Payloom PHP Code based upon Linklok from Vibralogix, with permission from Vibralogix.
// http://www.vibralogix.com
// The code has been heavily customized and will not work with other Vibralogix products, not even Linklok.
//
// You are licensed to use this product with Payloom 3 RapidWeaver Plugin only.
// Payloom v. %version%
// Published on: %publish-date%
//

// Timestamp: [[ 2016-04-21 14:16:27 +0000 by Mike Yrabedra (mikeyrab) ]]


// ! DEBUG MODE ?
$Debug = %debug-mode%;
if($Debug) {
    echo "# DEBUG IS ON<br>".PHP_EOL;
    @error_reporting(E_ERROR | E_WARNING | E_PARSE);
    @ini_set('display_errors', 1);
}else{
    @error_reporting(E_ERROR);
}

// Get Stripe Library Loaded
require_once('../%rw_common-path%/Stripe/init.php');

    
// !START SESSION
session_start();
    
    
// ! PRODUCTS
%products%
    
// ! START VARS

// URL of the linlok.php page on your site
$PayloomURL = '%payloom-url%';
    
// PRIMARY Paypal email address
$PaypalEmail = '%paypal-business%';

// Your company name
$SellerCompany = '%seller-company%';

// Your email address for order enquiries
// Reply-To, From address
$SellerEmail = '%seller-email%';

// Your website URL
$SellerURL = '%seller-url%';

// Receive copy of order emails
$CopyEmail = '%copy-email%';

// Encryption key for download links
$LinkKey = '%link-key%';

// Currency
$DefaultCurrency = '%default-currency%';

// Auto Return PDT token from paypal-profile-website payment preferences
$PDTtoken='%pdt-token%';

// Password for manual order entry. "" to disable                    
$ManualPassword = '%manual-password%';

// Set to Y to delay eCheck orders until cleared.
$DelayEchecks = "N";

// Optional Email Template in either .txt or .html format
// Sent to Customer
$EmailTemplate = "payloom_order_email.html";

// Optional Email Template used on Manual Orders
$ManualEmailTemplate = "payloom_manual_email.html";

// Optional download (return page) page template
$DownloadTemplate = "payloom_return.html"; /// themed page

// Optional Error page template
$ErrorTemplate = "payloom_error.html"; // themed page

// Order Notification Email + Template ( need both )
// Sent to the Seller
$NotifyTemplate = "payloom_notify_email.html";
$NotifyEmail = '%notify-email%'; // can be comma separated emails

// Set to Y to use HTML formatted emails or N to send in plain-text
$HTMLEmail = '%html-email%';

// Check payment warning email template
$WarningTemplate = "";

// Check payment warning thankyou page template
$WarningTemplatePage= "";

// Use Sandbox
$UseSandbox = 0;

// Testing?
$Test = "";

// Use phpMailer ( no SMTP yet )
$UsePHPmailer = 1;
$EmailUsername = "";
$EmailPassword = "";
$EmailServer = "";
$EmailPort = "";
$EmailAuth = "";

// Advanced Form
$AdvancedForm = 0; // Allows you to add options in manual form

// Debug Email
// Leave blank to not send.
$DebugEmail = '%debug-email%';
// Error Email
// Leave blank to not send.
$ErrorEmail = '%error-email%';

//Be notified each time a download link is used.
// Leave blank to not send.
$NotifyDownloadEmail='%notify-download-email%';

// Display Page During Download
// leave blank to disable
$DownloadBackground="payloom_bkgrd_download.html"; //themed page

// MYSQL Settings
$DbHostPayloom='%mysql-host%';
$DbUserPayloom='%mysql-username%';
$DbPasswordPayloom='%mysql-password%';
$DbNamePayloom='%mysql-db%';
$DbTableNameOrders='%mysql-table%';

// Optional to stop possible multiple calls from IPN
$Txnid = ($DbHostPayloom != "") ? "mysql" : "" ;

// Block Downloads ( not ordering )
%blocked-emails%
    
// Block IP Addresses
%blocked-ips%
    
// Blocked Message Page
$BlockEmailUrl='%block-email-url%';

// Skip PayPal and process order.
$directorder = %direct-order%;
    
// Stripe Enabled.
$stripeorder = true;
$stripeToken = '';
$stripeEmail = '';
$stripeSecretKey = '%stripe-secret-key%';
$stripeDescription = '%stripe-description%';

// Checkout Method?
$checkoutMethod = "paypal"; // comes from the form submitted
$notPayPal=false;


// Error Text
$DefaultProErrorText = '%default-error%';
$WrongAmountText = '%wrong-amount%';
$TransactionNotCompleteText = '%transaction-not-complete%';
$LinkExpiredText = '%link-expired%';
$DownloadPermissionDeniedText = '%download-permission-denied%';
    
// Custom Titles
$custom1Title = '%custom1-title%';
$custom2Title = '%custom2-title%';
$custom3Title = '%custom3-title%';
$custom4Title = '%custom4-title%';

// ! END VARS

if(!isset($calledasreturn))
  $calledasreturn=0; // init

if (!function_exists('get_headers')) {
function get_headers($url, $format=0) {
	
	if($Debug)
		echo "# GET_HEADERS<br>".PHP_EOL;

    $headers = array();
    $url = parse_url($url);
    $host = isset($url['host']) ? $url['host'] : '';
    $port = isset($url['port']) ? $url['port'] : 80;
    $path = (isset($url['path']) ? $url['path'] : '/') . (isset($url['query']) ? '?' . $url['query'] : '');
    $fp = fsockopen($host, $port, $errno, $errstr, 3);
    if ($fp)
    {
        $hdr = "GET $path HTTP/1.1\r\n";
        $hdr .= "Host: $host \r\n";
        $hdr .= "Connection: Close\r\n\r\n";
        fwrite($fp, $hdr);
        while (!feof($fp) && $line = trim(fgets($fp, 1024)))
        {
            if ($line == "\r\n") break;
            list($key, $val) = explode(': ', $line, 2);
            if ($format)
                if ($val) $headers[$key] = $val;
                else $headers[] = $key;
            else $headers[] = $line;
        }
        fclose($fp);
        return $headers;
    }
    return false;
}
}

// ! SET DEFAULTS AND INIT VARS

$on0 = "";
$on1 = "";
$payer_status = "";
$address_status = "";
$settle_amount = "";
$settle_currency = "";
$auction_closing_date = "";
$mc_gross = "";
$testtype = "";
$testmode = "";

if (!isset($ProductDelimiter))
  $ProductDelimiter=",";
if (!isset($llcharset))
  $llcharset="iso-8859-1";
if (!isset($EmailHeaderNoSlashR))
  $EmailHeaderNoSlashR=1;
if ((!isset($ExtraMailParam)) && (strtolower(@ini_get("safe_mode")) != 'on') && (@ini_get("safe_mode") != '1'))
  $ExtraMailParam="-f ".$SellerEmail;
@ini_set(sendmail_from,$SellerEmail);
if (!isset($AlwaysEmail))
  $AlwaysEmail=true;  // Emails will always be sent
if (($DefaultCurrency=="") || (!isset($DefaultCurrency)))
  $DefaultCurrency="USD";
if (!isset($ServerTimeAdjust))
  $ServerTimeAdjust=300;       
if (!isset($IPlock))
  $IPlock = 0;
  
$Test = strtoupper($Test);
  
$PDTtoken=trim($PDTtoken);
if (!empty($_GET)) while (list($name, $value) = each($_GET)) $$name = $value;
if (!empty($_POST)) while (list($name, $value) = each($_POST)) $$name = $value;
if (($DebugEmail != "") && (!isset($_REQUEST['DebugEmail'])))
  Debug("Received variables", $DebugEmail);
$found = false;
$numberofproducts = count($Products);

// todo: give user option to enter their timezone in setting. -MY
if(ini_get('date.timezone') == '') date_default_timezone_set('GMT');

// ! REQUEST -> VARS
if (!empty($_REQUEST))
{
  if($Debug)
	echo "# ASSIGN VARS<br>".PHP_EOL;
		
  reset($_REQUEST);
  while (list($namepair, $valuepair) = each($_REQUEST))
  {
    if ($namepair == "LinkKey") $found = true;
    if ($namepair == "Txnid") $found = true;
    if (substr($namepair, 0, 8) == "Products") $found = true;
    if (substr($namepair, 0, 19) == "productnotifyemails") $found = true;
    if ($namepair == "ManualPassword") $found = true;
    if ($namepair == "Test") $found = true;
    if ($namepair == "DownloadTemplate") $found = true;
    if ($namepair == "EmailTemplate") $found = true;
    if ($namepair == "ProductCSV") $found = true;
    if ($namepair == "PaypalEmail") $found = true;
    if ($namepair == "DefaultLocation") $found = true;
    if ($namepair == "DefaultPrice") $found = true;
    if ($namepair == "DefaultCurrency") $found = true;
    if ($namepair == "DefaultExpiry") $found = true;
    if ($namepair == "DefaultExtra") $found = true;
    if ($namepair == "IPlock") $found = true;
    if ($namepair == "RequireCustom") $found = true;
    if ($namepair == "NotifyDownloadEmail") $found = true;
    if ($namepair == "NotifyEmail") $found = true;
    if ($namepair == "SellerEmail") $found = true;
    if ($namepair == "SellerCompany") $found = true;
    if ($namepair == "SellerURL") $found = true;
    if ($namepair == "PDTtoken") $found = true;
    if ($namepair == "WarningTemplate") $found = true;
    if ($namepair == "EmailTemplate") $found = true;
    if ($namepair == "DownloadTemplate") $found = true;
    if ($namepair == "ServerTimeAdjust") $found = true;
    if ($namepair == "DownloadBackground") $found = true;
    if ($namepair == "WarningTemplatePage") $found = true;
    if ($namepair == "NotifyTemplate") $found = true;
    if ($namepair == "ConfirmTemplate") $found = true;
    if ($namepair == "ProductNotifyTemplate") $found = true;
    if (substr($namepair,0,12)=="pdfwatermark") $found=true;
    
    
    // from payloom
	if (preg_match("/^o[n|s]+([0-9])+_+([0-9])$/", $namepair, $matches)) {
		$k = $matches[0]; // key
		$o = $matches[1]; // option
		$p = $matches[2]; // product
		$nvar = "item_options_". $p;
		$$nvar .= (strstr($k, 'on')) ? "$valuepair: " : "$valuepair\n ";
	}
	
	// from paypal
	if (preg_match("/^option_[name|selection]+([0-9])+_+([0-9])$/", $namepair, $matches)) {
		$k = $matches[0]; // key
		$o = $matches[1]; // option
		$p = $matches[2]; // product
		$nvar = "item_options_". $p;
		$$nvar .= (strstr($k, 'option_selection')) ? "$valuepair, " : "";
	}
	
	
  }
  
  
  // get post vars 

    if(isset($_POST['custom'])){
	    Debug("Parsing Custom Var", $DebugEmail);
		parse_str($_POST['custom']);
	}
  


  // setup the checkoutMethod
  if($method == "stripe" && $stripeorder) {
  	$checkoutMethod = "stripe";
  	$notPayPal=true;
  }else if($method == "direct" && $directorder) {
  	$checkoutMethod = "direct";
  	$notPayPal=true;
  }else{
	  $checkoutMethod="paypal";
	  $notPayPal=false;
  }
  
}

// If found, then someone is trying to inject there own vars to override globals. 
if ($found)
{
  if($Debug){ echo "# BAD VARS FOUND<br>".PHP_EOL; }
  
ShowMessage($ErrorTemplate, "Access Denied.", $ErrorEmail);
  exit;
}

$clientipinfo=array();
$clientipinfo['ip']="unknown";
$clientipinfo['countrycode']="unknown";
$clientipinfo['countryname']="unknown";
$clientipinfo['continentcode']="unknown";     
$clientipinfo['continentname']="unknown"; 

// ! USER LOGOUT

if( isset($_SESSION['logged_in']) && $_SESSION['logged_in'] && ( (isset($logout)) || (isset($LOGOUT)) ) )
{ 
  if($Debug){ echo "# USER LOGGED OUT<br>".PHP_EOL; }
  unset($_SESSION['logged_in']);
  header("Location: ?orderform=1");
}
    

// ! USER LOGIN
if( !$_SESSION['logged_in']  && ( (isset($pl_admin)) || (isset($PL_ADMIN)) ) )
{ 
  if(  ($ManualPassword != "") && ($ManualPassword == $password) )
  {
    if($Debug){ echo "# USER LOGGED IN<br>".PHP_EOL; }
    $_SESSION['logged_in'] = true;
    
  }else{
    
        if($Debug){ echo "# INVALID LOGIN<br>".PHP_EOL; }
        $_SESSION['logged_in'] = false;
        echo '<div class="notification alert-error spacer-t10"><p><i class="fa fa-bomb"></i> Invalid Login </p><a href="#" class="close-btn">&times;</a></div>';

  }

}





// ! DBCONNECT
if (($DbHostPayloom!="") && ($DbUserPayloom!="") && ($DbPasswordPayloom!="") && ($DbNamePayloom!=""))
{
  
  if($Debug){ echo "# CONNECT TO MYSQL<br>".PHP_EOL; }
  $mysql_payloom=pl_dbconnect($DbHostPayloom,$DbUserPayloom,$DbPasswordPayloom);
  
  if (!$mysql_payloom)
  {
    if($Debug){ echo "# MYSQL CONNECTION FAILED<br>".PHP_EOL; }
    ShowMessage($ErrorTemplate, "Error connecting to MySQL", $ErrorEmail);
    exit;
  }
  
}


// ANYTHING SUBMITTED?
if ((empty($_GET)) && (empty($_POST)) && !$_SESSION['logged_in'] )
{
// Leaving blank for security reasons?
//  ShowMessage($ErrorTemplate, "Access Denied. Payloom can only be called by Paypal.", $ErrorEmail);
  if($Debug){ echo "# NOTHING SUBMITTED<br>".PHP_EOL; }
  return;
}

// ! CALLED AS RETURN PAGE?
if ($calledasreturn != 1)
{
  // not sure this is needed, will see... -MY
  if($Debug){ echo "# NOT CALLED AS RETURN PAGE ?<br>".PHP_EOL; }
  $calledasreturn = 0;
  $path_info = (isset($_SERVER["PATH_INFO"])) ? strcasecmp($_SERVER["PATH_INFO"], "/return") : 1 ;
  if ($path_info == 0)
    $calledasreturn = 1;
}

// ! LOGIN FORM
// If ?orderform, testform or addtocartlinks then request password
if ( (!$_SESSION['logged_in']) && ( (isset($orderform)) || (isset($ORDERFORM)) || (isset($testform)) || (isset($TESTFORM)) || (isset($vieworders)) || (isset($VIEWORDERS))) )
{
  if($Debug){ echo "# LOGIN FORM CALLED<br>".PHP_EOL; }
  
echo '
<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<title>Payloom Login</title>
<link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.5/css/bootstrap.min.css" rel="stylesheet">
<link href="https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css" rel="stylesheet">
<script language="JavaScript">
<!-- JavaScript
function validateform(form)
{
  if (form.password.value=="")
  {
    alert("Please enter the password")
    form.password.focus()
    return(false)
  }
  return(true);
}
// - JavaScript - -->
</script>
<style>
h3 { margin:0; font-size:18px; }
.container { 
max-width:400px;
text-align:center;
margin-top:40px;
}
</style>
</head>
<body style="padding:20px;">
<div class="container">'. getNavbar() . '
<form name="form1" method="post" action="'.$PayloomURL.'" onSubmit="return validateform(this);">
<input type="hidden" name="pl_admin" value="Y">';
if ((isset($testform)) || (isset($TESTFORM)))
  echo '<input type="hidden" name="testmode" value="Y">';
echo '
<div class="panel panel-default">
<div class="panel-heading text-center"><h3><i class="fa fa-key"></i> Login</h3></div>
<div class="panel-body text-center">
<label>Password</label><br>
<input type="password" class="form-control text-center" name="password" maxlength="50" size="30">';

if($fail)
	echo '<br><span class="text-danger"><i class="fa fa-bomb"></i> Invalid Login</span>';

echo '</div><div class="panel-footer"><input class="btn btn-primary btn-lg btn-block" type="submit" name="button1" value="Submit"></div></div></form>
</div>
<script language="JavaScript">
<!-- JavaScript
form1.password.focus()
// - JavaScript - -->
</script>
</body></html>';
exit;
  
}


// ! TEST/MANUAL ORDER FORM
// If password entered and correct then display manual order form
if ( $_SESSION['logged_in'] && !$manualorder && ( !isset($vieworders) && !isset($VIEWORDERS) ) && !isset($orderdetails))
{
	
	if($Debug){ echo "# TEST/MANUAL FORM CALLED<br>".PHP_EOL; }
  
echo '
<html><head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Payloom 3 Manual Form</title><link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.5/css/bootstrap.min.css" rel="stylesheet"><link href="https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css" rel="stylesheet">
<style>
body { padding:20px; }
h3 { margin:0; font-size:18px; }
.container { 
max-width:400px;
margin-top:40px;
}
</style>
</head>
<body>
<script language="JavaScript">
<!-- JavaScript
function validateform(form)
{
  if (form.item_number1.value=="")
  {
    alert("Please select at least one item")
    form.item_number1.focus()
    return(false);
    exit;
  }
  if (form.item_number10.value=="")
    form.num.value=9;
  if (form.item_number9.value=="")
    form.num.value=8;
  if (form.item_number8.value=="")
    form.num.value=7;
  if (form.item_number7.value=="")
    form.num.value=6;
  if (form.item_number6.value=="")
    form.num.value=5;
  if (form.item_number5.value=="")
    form.num.value=4;
  if (form.item_number4.value=="")
    form.num.value=3;
  if (form.item_number3.value=="")
    form.num.value=2;
  if (form.item_number2.value=="")
    form.num.value=1;
  if (form.newexpiry2.value!="")
  {
    if (ValidChars(form.newexpiry2.value,"0123456789")==false)
    {
      alert("Please enter a valid expiry time or select from the menu")
      form.newexpiry2.focus();
      return(false);
    }
    form.newexpiry.value=form.newexpiry2.value
  }
  else
  {
    form.newexpiry.value=form.newexpiry1.value
  }
  if (form.manualipaddr.value=="::1")
    form.manualipaddr.value="127.0.0.1"
  if ((form.manualipaddr.value=="") && (form.manualiplevel.value!="0"))
  {
    alert("Please enter the recipients IP address or select the IP level - off")
    form.manualipaddr.focus();
    return(false);
  }
  if (ValidateIP(form.manualipaddr.value)==false)
  {
    alert("Please enter a valid IP address or leave blank")
    form.manualipaddr.focus();
    return false;
  }
  if (form.manualipaddr.value=="::1")
    form.manualipaddr.value="127.0.0.1"
  if (form.manualipaddr.value=="")
    form.manualipaddr.value="0.0.0.0";
';
  
if ($testmode=="Y")
{    
echo '  if (form.payer_email.value=="")
  {
   alert("Please enter a valid email address")
   form.payer_email.focus();
   return(false);
  }';
}
  
  echo '
  if (form.payer_email.value!="")
  {
    if (!ValidateEmail(form.payer_email.value))
    {
      alert("Please enter a valid email address")
      form.payer_email.focus();
      return false;
    }
  }
  return true ;
}

function ValidateEmail(str)
{
    // https://html.spec.whatwg.org/multipage/forms.html%23valid-e-mail-address
    return /^[a-zA-Z0-9.!#$%&\'*+\/=?^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$/.test( str );
}

function ValidateIP(ip)
{
  if (ip!="")
  {
    var ni
    if (ValidChars(ip,"0123456789.")==false)
      return(false)
    var ipparts=ip.split(".")
    if (ipparts.length!=4)
      return(false)
    for (var k=0; k<4; k++)
    {
      if (ipparts[k].length<1)
      return(false)
      if ((ipparts[k].charAt(0)=="0") && (ipparts[k].length>1))
      return(false)
    ni=parseInt(ipparts[k],10)
    if ((ni<0) || (ni>255))
      return (false)
    }
  }
    return(true)
}
function ValidChars(str,valid)
{
  var v=true
  for (i=0;i<str.length;i++)
  {
    if (valid.indexOf(str.charAt(i))==-1)
    {
      v=false
      break
    }
  }
  return(v)
}
// - JavaScript - -->
</script>
<div class="container" style="max-width:600px;">
'. getNavBar($_SESSION['logged_in']) .'
<form name="form1" id="pl-form" method="post" action="'.$PayloomURL.'">
<input type="hidden" name="num" value="10">
<input type="hidden" name="manualorder" value="1">
<input type="hidden" name="txn_id" value="'.(string)time().'">
<div id="form-messages"></div>
<div class="panel panel-default">
<div class="panel-heading text-center">';
echo ($testmode=="Y") ? '<h3>Payloom Test Form</h3>' : '<h3>Payloom Manual Order Entry</h3>';   
echo '</div>
<div class="panel-body">
<div style="height:200px; overflow:auto; border:1px solid #ccc; margin-bottom:20px;">
<table class="table table-striped">
<tbody>';

echo getManualFormProducts();

echo '</tbody></table>

</div>
';

if($testmode == "Y") {
  echo '
<input type="hidden" name="newexpiry" value="">
<input type="hidden" name="newexpiry1" value="-1">
<input type="hidden" name="newexpiry2" value="">';
}else{
  echo '<div class="form-group"><label>Override Expiry</label></br>
<input type="hidden" name="newexpiry" value="">
<select class="form-control" name="newexpiry1">
<option selected value="-1">Leave as default</option>
<option value="10">10 minutes</option>
<option value="60">1 Hour</option>
<option value="180">3 Hours</option>
<option value="1440">24 Hours</option>
<option value="4320">3 Days</option>
<option value="10080">7 Days</option>
<option value="43200">30 Days</option>
<option value="525600">1 Year</option>
<option value="0">No Expiry</option>
</select>
<input type="hidden" name="newexpiry2" value="">
</div>';
}


if ($testmode!="Y")  
  {
    if (isset($IPlock))
    {
      
      echo '<div class="form-group"><label>IP address</label><br>
      <div class="row">
      <div class="col-md-6">
<input type="text" class="form-control" name="manualipaddr" maxlength="15" size="23">
</div><div class="col-md-6">
<select name="manualiplevel" class="form-control">
  <option value="-1">Default</option>
  <option selected value="0">Level 0 (off)</option>
  <option value="1">Level 1</option>
  <option value="2">Level 2</option>
  <option value="3">Level 3</option>
  <option value="4">Level 4</option>
</select></div></div></div>';

    }
    else
    {
      echo '<input type="hidden" name="manualipaddr" value="'.trim(strtok($_SERVER['REMOTE_ADDR'],",")).'">';
      echo '<input type="hidden" name="manualiplevel" value="-1">';
    }
  }
  else
  {
    echo '<input type="hidden" name="manualipaddr" value="">';
    echo '<input type="hidden" name="manualiplevel" value="0">';
  }
  
echo '
<div class="form-group">
  <label>First name</label><br>
  <input type="text" class="form-control" name="first_name">
</div>
<div class="form-group">
  <label>Last name</label><br>
  <input type="text" class="form-control" name="last_name">
</div>
<div class="form-group">
  <label>Email address</label><br>
  <input type="email" class="form-control" name="payer_email">
</div>';


if ($testmode =="Y") {
echo '<div class="form-group"><label>Currency</label><br>
<select name="mc_currency" class="form-control">
  <option value="USD">USD</option>
  <option value="GBP">GBP</option>
  <option value="EUR">EUR</option>
  <option value="AUD">AUD</option>
  <option value="BRL">BRL</option>
  <option value="CAD">CAD</option>
  <option value="CHF">CHF</option>
  <option value="CZK">CZK</option>
  <option value="DKK">DKK</option>
  <option value="HKD">HKD</option>
  <option value="HUF">HUF</option>
  <option value="ILS">ILS</option>
  <option value="JPY">JPY</option>
  <option value="NOK">NOK</option>
  <option value="NZD">NZD</option>
  <option value="PLN">SEK</option>
  <option value="SEK">SEK</option>
  <option value="SGD">SGD</option>
</select>
</div>

<div class="form-group"><label>Test type</label><br>
<select name="testtype" class="form-control">
  <option value="email">Email</option>
  <option value="return">Return (download) page</option>
</select>
</div>


</div><!-- panel-body -->
<div class="panel-footer">
<button type="submit" id="pl-submit" class="btn btn-primary btn-lg btn-block">
<i class="fa fa-gear"></i> Click to Test
</button>
</div>';

}else{
  
  echo '
  
  <div class="form-group"><label>Message</label><br>
  	<textarea name="manual_message" class="form-control"></textarea>
  </div>

  </div><!-- panel-body -->
<div class="panel-footer">
  <button type="submit" id="pl-submit" class="btn btn-primary btn-lg btn-block">
  <i class="fa fa-send"></i> Send Links
  </button>
</div>';
}

echo '
</div><!-- panel -->
</form>
</div><!-- container -->

<script src="//cdnjs.cloudflare.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="//cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/3.3.5/js/bootstrap.min.js"></script>


<script language="JavaScript">
<!-- JavaScript
form1.item_number1.focus();

$(function() {
  var form = $("#pl-form");
  var formMessages = $("#form-messages");
  $(form).submit(function(e) {
    e.preventDefault();
    if(!validateform(this))
    {
      return false;
    }
    var submit_text = $("#pl-submit").html();
    var processing = "<i class=\"fa fa-refresh fa-spin\"></i> Processing...";
    $("#pl-submit").html(processing).prop("disabled", true);
    var formData = $(form).serialize();
    $.ajax({
      type: "POST",
      url: $(form).attr("action"),
      data: formData
    })
    .done(function(response) {
            $("#pl-submit").html(submit_text).prop("disabled", false);
      $("html, body").animate({scrollTop:0}, "fast");
      $(formMessages).html(response);
    })
    .fail(function(data) {
      if (data.responseText !== "") {
        $(formMessages).text(data.responseText);
      } else {
        $(formMessages).text("Oops! An error occured and your message could not be sent.");
      }
    });

  });

});


// - JavaScript - -->
</script>
</body></html>
';
// exit if not a submission
if ($payer_email == "")
    
    if($Debug){ echo "# NO PAYER EMAIL = EXIT<br>".PHP_EOL; }
    exit;

}


// ! SHOW ORDERS
// If password entered and correct then display manual order form
if ($_SESSION['logged_in'] && ($testtype=="") && ( (isset($vieworders)) || (isset($VIEWORDERS)) ))
{

if($Debug){ echo "# VIEW ORDERS CALLED<br>".PHP_EOL; }

echo '
<html><head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Payloom 3 Manual Form</title>
<link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.5/css/bootstrap.min.css" rel="stylesheet">
<link href="https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css" rel="stylesheet">
<link href="//cdn.datatables.net/plug-ins/1.10.6/integration/bootstrap/3/dataTables.bootstrap.css" rel="stylesheet">
<style>
body { padding:20px; }
h3 { margin:0; font-size:18px; }
.container { 
max-width:400px;
margin-top:40px;
}
</style>
</head>
<body>
<script language="JavaScript">
<!-- JavaScript
// - JavaScript - -->
</script>
<div class="container" style="max-width:100%;">
'. getNavBar($_SESSION['logged_in']) .'
<div class="panel panel-default" style="width:100%">
<div class="panel-heading text-center">
<h3>Payloom View Orders</h3>  
</div>
<div class="panel-body">
<table id="orders" class="table table-striped table-responsive">
<thead><tr><th></th><th>Date</th><th>Total</th><th>Name</th><th>Email</th><th class="no-sort"></th></tr></thead>
<tbody>';

// GET ORDERS HERE
echo getOrders(); // give it's own function - MY

echo '</tbody></table>


</div><!-- panel-body -->
<div class="panel-footer">
</div>
</div><!-- panel -->
</div><!-- container -->

<div class="modal fade" id="order-modal">
  <div class="modal-dialog modal-lg">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
        <h4 class="modal-title">%modal-title%</h4>
      </div>
      <div class="modal-body">
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
      </div>
    </div><!-- /.modal-content -->
  </div><!-- /.modal-dialog -->
</div><!-- /.modal -->


<script src="//cdnjs.cloudflare.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="//cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/3.3.5/js/bootstrap.min.js"></script>
<script src="//cdn.datatables.net/1.10.6/js/jquery.dataTables.min.js"></script>
<script src="//cdn.datatables.net/plug-ins/1.10.6/integration/bootstrap/3/dataTables.bootstrap.js"></script>

<script language="JavaScript">
<!-- JavaScript

$(document).ready(function() {

    $("#orders").DataTable( { order: [[ 1, "desc" ]], columnDefs: [{ targets: "no-sort", orderable: false }] });
    
    $("#order-modal").on("show.bs.modal", function (event) {
    var button = $(event.relatedTarget) // Button that triggered the modal
    var transid = button.data("transid") // Extract info from data-* attributes
    var order= "";
    var modal = $(this)
    $.ajax({
        url: "payloom.php?orderdetails&orderno=" + transid,
        dataType:"text",
        success: function(data) {
        modal.find(".modal-title").text("Order " + transid)
        modal.find(".modal-body").html(data)
        },
        error: function() {
          modal.find(".modal-title").text("Error!")
        modal.find(".modal-body").html("An Error Occurred Retrieving Order Details")
      }
    });

  })


});
        
        
// - JavaScript - -->
</script>
</body></html>
';
  exit;
}

// ! SHOW ORDER DETAILS
// If password entered and correct then display manual order form
if ($_SESSION['logged_in'] && ($testtype=="") && ( (isset($orderdetails)) || (isset($ORDERDETAILS)) ))
{
if($Debug){ echo "# SHOW ORDER DETAILS<br>".PHP_EOL; }
echo getOrder($orderno);

exit;
};

// ! WRONG PASSWORD
if (($ManualPassword != "") && (isset($password)) && ($ManualPassword != $password) && (!isset($num)))
{
  if($Debug){ echo "# WRONG PASSWORD<br>".PHP_EOL; }
  //ShowMessage($ErrorTemplate, "Incorrect password.", "");
  header("Location: ?orderform=1&fail=1");
  exit;
}

// ! PROCESS MANUAL ORDER?
$manualorder = false;

if (($item_number1 != "") && ($num != "") && ($_SESSION['logged_in']))
{
  if($Debug){ echo "# PROCESS TEST/MANUAL ORDER<br>".PHP_EOL; }
  $manualorder = true;
  $res = "VERIFIED";
  $payment_status = "Completed";
  $receiver_email = $PaypalEmail;
  $clientipaddr = "0.0.0.0";
  if ($manualipaddr != "")
    $clientipaddr = $manualipaddr;
  if (function_exists('vl_geoip2'))
    $clientipinfo=vl_geoip2($clientipaddr);
  if ($mc_currency=="")
  {
    if ($DefaultCurrency!="")
      $mc_currency=$DefaultCurrency;
    else  
      $mc_currency="USD";  
  }
 
  
  $mc_gross=0.00; 
  $num_cart_items=$num; 
  for ($k=1;$k<=$num_cart_items;$k++)
  {
    $pvar = "item_number" . $k;
    $j = GetProductDetails($$pvar,$mc_currency,$cost,$desc, $link, $size, $exp, $lkextra);
    if ($j!=0)
    {
      $pvar = "item_name". $k;
      $$pvar=$desc;
      $pvar = "mc_gross_". $k;
      if ($testtype!="")
        $$pvar=$cost;
      else
        $$pvar="0.00";        
      $pvar = "quantity". $k;
      $$pvar="1";
      $mc_gross=$mc_gross+$cost;
    }
  }  
  $tax=0.00;
  $mc_handling=0.00;
  $mc_fee=0.00;
  $method="MANUAL";
  $option_selection1=$os0;
  $option_selection2=$os1;
  $option_name1=$on0;
  $option_name2=$on1;
  // See if manual orderform being used for tesing
  if ($testtype!="")
  {
    $Test="Y";
    $manualorder = false;
    if ($testtype=="email")
    {
      $calledasreturn=0;
    }
    if ($testtype=="return")
    {
      $calledasreturn=1;
    }    
  }
  else
  {
    if ($ManualEmailTemplate!="")
      $EmailTemplate=$ManualEmailTemplate;
    $mc_gross="0.00";  
  }  
}

// ! PROCESS STRIPE ORDER
if (($item_number_1 != "") && ($num != "") && ($checkoutMethod == "stripe"))
{

	if($Debug){ echo "# PROCESS STRIPE ORDER<br>".PHP_EOL; }
	
	// Set your secret key: remember to change this to your live secret key in production
	\Stripe\Stripe::setApiKey($stripeSecretKey);
    
    // Build metadata
    $metadata = array();
    $metadata['first_name'] =$first_name;
    $metadata['last_name']=$last_name;
    $metadata['address_name']=$address_name;
    $metadata['email']=$payer_email;
    $metadata['business_name']=$payer_business_name;
    $metadata['address_street']=$address_street;
    $metadata['address_city']=$address_city;
    $metadata['address_state']=$address_state;
    $metadata['address_country']=$address_country;
    $metadata['address_zip']=$address_country;
    $metadata['tax']=$tax;
    $metadata['shipping']=$mc_shipping;
    $metadata['telephone']=$telephone;
    $metadata['custom1']=$custom1;
    $metadata['custom2']=$custom2;
    $metadata['custom3']=$custom3;
    $metadata['custom4']=$custom4;
    
	
	// Create the charge on Stripe's servers - this will charge the user's card
	try {
	$charge = \Stripe\Charge::create(array(
	  "amount" => $mc_gross * 100, // amount in cents, again
	  "currency" => $DefaultCurrency,
	  "source" => $stripeToken,
	  "description" => $stripeDescription,
      "metadata" => $metadata )
	);
	
	// added paid as valid status result
    // 09-23-2015 10:18:28 am
	if($charge->status == 'succeeded' || $charge->status == 'paid')
	{
		$txn_id = $charge->id;
		$res = "VERIFIED";
		$payment_status = "Completed";
		$payment_type = "STRIPE";
		$payer_email = $stripeEmail;
	
	}
	//print_r($charge);
	
	} catch(Exception $e) {
	  // The card has been declined
	  $stripeError = $e->getMessage();
	  if($Debug){ echo "# STRIPE ERROR = [ $stripeError ]<br>".PHP_EOL; }
	  ShowMessage($ErrorTemplate, $stripeError, "");
	  exit;
	
	}
	

	
	$receiver_email = $PaypalEmail;
	$clientipaddr = "0.0.0.0";
	//$txn_id = (string)time(); //needs to be done via form page
	if (ValidIP($_SERVER['REMOTE_ADDR']))
	  $clientipaddr = $_SERVER['REMOTE_ADDR'];
	if (function_exists('vl_geoip2'))
	  $clientipinfo=vl_geoip2($_SERVER['REMOTE_ADDR']);
	if ($mc_currency=="")
	{
		if ($DefaultCurrency!="")
		  $mc_currency=$DefaultCurrency;
		else  
		  $mc_currency="USD";  
	} 
  $num_cart_items=$num; 
  for ($k=1;$k<=$num_cart_items;$k++)
  {
    $pvar = "item_number_" . $k;
    $j = GetProductDetails($$pvar,$mc_currency,$cost,$desc, $link, $size, $exp, $lkextra);
    
    if ($j!=0) // found?
    {
      $pvar = "item_name_". $k;
      $$pvar=$desc;
      $pvar = "amount_". $k;
      $$pvar=$cost; // cost comes from function?        
      $pvar = "quantity_". $k;
      $mc_gross=$mc_gross+($cost*$$pvar);
    }
  }  
  //$tax=0.00; // not used in directorder or stripe
  $mc_handling=0.00; // not used in directorder or stripe
  $mc_fee=0.00; // not used in directorder ord stripe
  $method="STRIPE";
  $calledasreturn=1;  
}

// ! PROCESS DIRECT ORDER
if (($item_number_1 != "") && ($num != "") && ($checkoutMethod == "direct"))
{

	if($Debug){ echo "# PROCESS DIRECT ORDER<br>".PHP_EOL; }

	$res = "VERIFIED";
	$payment_status = "Completed";
	$payment_type = "DIRECT";
	$receiver_email = $PaypalEmail;
	$clientipaddr = "0.0.0.0";
	//$txn_id = (string)time(); //needs to be done via form page
	if (ValidIP($_SERVER['REMOTE_ADDR']))
	  $clientipaddr = $_SERVER['REMOTE_ADDR'];
	if (function_exists('vl_geoip2'))
	  $clientipinfo=vl_geoip2($_SERVER['REMOTE_ADDR']);
	if ($mc_currency=="")
	{
		if ($DefaultCurrency!="")
		  $mc_currency=$DefaultCurrency;
		else  
		  $mc_currency="USD";  
	} 
  $num_cart_items=$num; 
  for ($k=1;$k<=$num_cart_items;$k++)
  {
    $pvar = "item_number_" . $k;
    $j = GetProductDetails($$pvar,$mc_currency,$cost,$desc, $link, $size, $exp, $lkextra);
    
    if ($j!=0) // found?
    {
      $pvar = "item_name_". $k;
      $$pvar=$desc;
      $pvar = "amount_". $k;
      $$pvar=$cost; // cost comes from function?        
      $pvar = "quantity_". $k;
      $mc_gross=$mc_gross+($cost*$$pvar);
    }
  }  
  //$tax=0.00; // not used in directorder
  $mc_handling=0.00; // not used in directorder
  $mc_fee=0.00; // not used in directorder
  $method="DIRECT";
  $calledasreturn=1;  
}



// ! DOWNLOAD IN BACKGROUND PAGE
// See if download request with page background (email links that display a page in the browser as well)
// Only works in email links, not return page links
if (isset($authe))
{ 
  
  if($Debug){ echo "# DOWNLOAD IN BACKGROUND PAGE<br>".PHP_EOL; }
  
  if ($DownloadBackground!="")
  {
    $page="";
    // See if background page is html or php
    $ext = fileextension($DownloadBackground);  
    if ($ext == ".php")
    {
      ob_start();
      include $DownloadBackground;
      $page = ob_get_contents(); 
      ob_end_clean();    
    }
    else
    {
      if ($fh = fopen($DownloadBackground, "r"))
      {
        $page = fread ($fh, 200000);
        fclose($fh);
      }
    }

    if ($page!="")
    {  
      $page = str_replace("#link#", $PayloomURL."?llauth=".$authe, $page);
      $page = str_replace("<body", "<body onLoad=\"download()\"", $page);      
      $redirectcode ="<script language=\"JavaScript\" type=\"text/javascript\">\n";
      $redirectcode.="function download()\n";
      $redirectcode.="{\n";
      $redirectcode.="  window.location=\"".$PayloomURL."?llauth=".$authe."\"\n";
      $redirectcode.="}\n";
      $redirectcode.="</script>\n";
      $redirectcode.="</body>\n";  
      $page = str_replace("</body>", $redirectcode, $page);
      print $page;
      exit;      
    }
    else
      $llauth=$authe;
  }
  else
    $llauth=$authe;
}


// See if download request
if (isset($llauth))
{

	if($Debug){ echo "# PROCESS DOWNLOAD REQUEST<br>".PHP_EOL; }
	
  // Remove any /filename from end
  $pos = strpos($llauth, "/");
  if (is_integer($pos))
    $llauth = substr($llauth, 0, $pos);
  $llauth = rawurldecode($llauth);
  $oldlink = false;
  if (is_integer(strpos($llauth, ",")))
    $oldlink = true;
  if ($oldlink == false)
    $llauth = base64_decode($llauth);   
  $fields=explode(",",$llauth);
  if ($oldlink)
  {
    $item_number = trim($fields[0]);
    $expiry = trim($fields[1]);
    $txn_id = trim($fields[2]);
    $ip="0.0.0.0";
    $ipl="0";
    $email="";
    $hash = md5($LinkKey . $item_number . $expiry . $txn_id);    
  }
  else
  {
    if (count($fields)==6)
    {
      $item_number = trim($fields[0]);
      $expiry = trim($fields[1]);
      $txn_id = trim($fields[2]);
      $ip = trim($fields[3]);
      $ipl = trim($fields[4]);
      $verifyhash = trim($fields[5]);
      $email="";
      $hash = md5($LinkKey . $item_number . $expiry . $txn_id . $ip . $ipl);
    }
    else
    {
      $item_number = trim($fields[0]);
      $expiry = trim($fields[1]);
      $txn_id = trim($fields[2]);
      $ip = trim($fields[3]);
      $ipl = trim($fields[4]);
      $email = trim($fields[5]);
      $verifyhash = trim($fields[6]);
      $hash = md5($LinkKey . $item_number . $expiry . $txn_id . $ip . $ipl . $email);
    }
  }  
  if ($verifyhash != $hash)
  {
    if($Debug){ echo "# BAD<br>".PHP_EOL; }
    ShowMessage($ErrorTemplate, $DownloadPermissionDeniedText, $ErrorEmail);
    exit;
  }
  $email=urldecode($email);
  // auth is OK but we should now check if link expired
  if ($expiry != 0)
  {
    $curtime = time();
    if ($curtime > $expiry)
    {
      if($Debug){ echo "# LINK EXPIRED<br>".PHP_EOL; }
      ShowMessage($ErrorTemplate, $LinkExpiredText, $ErrorEmail);
      exit;
    }
  }
  if (($ipl != "0") && ($ip != "0.0.0.0"))
  {
    $ipaddr = trim(strtok($_SERVER['REMOTE_ADDR'],","));
    $ipo[1] = strtok($ip, ".");
    $ipo[2] = strtok(".");
    $ipo[3] = strtok(".");
    $ipo[4] = strtok(".");
    $ipn[1] = strtok($ipaddr, ".");
    $ipn[2] = strtok(".");
    $ipn[3] = strtok(".");
    $ipn[4] = strtok(".");
    for ($k = 1;$k <= $ipl;$k++)
    {
      if ($ipo[$k] != $ipn[$k])
      {
        ShowMessage($ErrorTemplate, "Link IP address is not valid.\n", $ErrorEmail);
        exit;
      }
    }
  }
  
  
  // ! BLOCK EMAIL/IP ON DOWNLOAD ATTEMPT
  // Check for blocked email trying to download
  if (isset($BlockEmail[0]) || isset($BlockIP[0]))
  {
    if($Debug){ echo "# CHECKING BLOCKED EMAILS / IP ADDRESS<br>".PHP_EOL; }
    
    $be=false;
    
    // Check Email Address
    for ($k=0;$k<count($BlockEmail);$k++)
    {
      $pos = strpos(strtolower($email), strtolower(trim($BlockEmail[$k])));
      if (is_integer($pos))
      {
        $be=true;
        break;
      }
    }
    
    // Check IP Address
    for ($k=0;$k<count($BlockIP);$k++)
    {
      $pos = strpos($_SERVER['REMOTE_ADDR'], trim($BlockIP[$k]));
      if (is_integer($pos))
      {
        $be=true;
        break;
      }
    }
    
    
    if ($be == 1)
    {
      if ((!isset($BlockEmailUrl)) || ($BlockEmailUrl==""))
      {
        if($Debug){ echo "# SHOW BLOCKED MESSAGE<br>".PHP_EOL; }
        print "Access to this download has been blocked.";
        exit; 
      }
      else
      {
        if($Debug){ echo "# DISPLAY BLOCKED PAGE<br>".PHP_EOL; }
        header("Location: ".$BlockEmailUrl);
        exit;
      }
    }
  }
  
  // ! ALLOW DOWNLOAD OF FILE
  if($Debug){ echo "# ALLOW DOWNLOAD OF FILE<br>".PHP_EOL; }
  // Everything is OK so we can allow download of file
  GetProductDetails($item_number, "", $cost, $desc, $link, $size, $exp, $extra);
  // See if NOTIFYDOWNLOAD is set
  $pos = strpos(strtoupper($extra), "NOTIFYDOWNLOAD=");
  if (is_integer($pos))
  {
    $pos2=strpos($extra,"*",$pos);
    if (is_integer($pos2))    
      $NotifyDownloadEmail=substr($extra,$pos+15,$pos2-$pos-15);
    else
      $NotifyDownloadEmail=substr($extra,$pos+15);              
  }
  // See if redirect download required
  if (!isset($redirectall))
    $redirectall=0;
  $pos = strpos(strtoupper($extra), "REDIRECT=1");
  if ((is_integer($pos)) || ($redirectall==1))
  {
    header("Location: ".$link);
    exit;
  }  
  // Check to see if PDF Honeypot link
  $pos = strpos(strtoupper($extra), "PDFHONEYPOT=");
  if (is_integer($pos))
  {
    global $pdfhpurl, $pdfhpsecret;
    if ($NotifyDownloadEmail != "")
      EmailDownloadNotify($fname, $item_number, $desc, $txn_id, trim(strtok($_SERVER['REMOTE_ADDR'],",")), $expiry, $email);
    $link=pl_pdfhoneypot($link,$email,$ip,$pdfhpsecret,$pdfhpurl);
    header("Location: ".$link);
    exit;
  }         
  $ext = fileextension($link);
  $fname = filename($link);
  // If download path is for S3 then handle it now
  if (substr(trim(strtolower($link)),0,3)=="s3|")
  {
    if($Debug){ echo "# DOWNLOAD PATH IS S3<br>".PHP_EOL; }
    if ($NotifyDownloadEmail != "")
      EmailDownloadNotify($fname, $item_number, $desc, $txn_id, trim(strtok($_SERVER['REMOTE_ADDR'],",")), $expiry, $email);
    $url=get_s3_url($link,time()+$ServerTimeAdjust,"GET");
    header("Location: ".$url);
    exit;
  }
  // If PDFWATERMARK set and file size ok then handle watermarking here
  if (($ext==".pdf") && (function_exists('ll_pdfwatermark')) && (@filesize($link)<=$pdfwatermarkmaxsize) && (is_integer(strpos(strtoupper($extra), "PDFWATERMARK="))))
  {
    if($Debug){ echo "# HAS PDF WAERMARK<br>".PHP_EOL; }
    if ($NotifyDownloadEmail != ""){
      EmailDownloadNotify($fname, $item_number, $desc, $txn_id, trim(strtok($_SERVER['REMOTE_ADDR'],",")), $expiry, $email);
    }
    ll_pdfwatermark($link,$email,$txn_id,"","");
    exit;
  } 
  // If download link is php page then just include it.
  if ($ext == ".php")
  {
    if ($NotifyDownloadEmail != "")
      EmailDownloadNotify($fname, $item_number, $desc, $txn_id, trim(strtok($_SERVER['REMOTE_ADDR'],",")), $expiry, $email);
    // If there are any GET variables in the filename then set those in $_GET and $_REQUEST
    $fquery="";
    $pos=strpos($link,"?");
    if (is_integer($pos))
      $fquery=substr($link,$pos+1);
    if ($fquery!="")
    {
      $fvars=explode("&",$fquery);
      for ($k=0;$k<count($fvars);$k++)
      {
        $fvar=strtok($fvars[$k],"=");
        $fval=strtok("=");
        if ($fvar!="")
        {
          $_GET[$fvar]=$fval;
          $_REQUEST[$fvar]=$fval;
        }      
      }
      // Remove query from link
      $link=str_replace("?".$fquery,"",$link);      
    }
    include $link;
    exit;
  }
  // If download link is html page then just display it.
  if (($ext == ".html") || ($ext == ".htm"))
  {
    if (!($fh = @fopen($link, "rb")))
    {
      ShowMessage($ErrorTemplate, "Could not open file.", $ErrorEmail);
      exit;
    }
    header("Content-type: text/html\n");
    header("Content-transfer-encoding: binary\n");
    if ((strtolower(ini_get('zlib.output_compression'))!="on") && (ini_get('zlib.output_compression')!="1"))
    {
      if ((int)$size > 0)
        header("Content-Length: " . $size . "\n");
    }  
    if ($NotifyDownloadEmail != "")
      EmailDownloadNotify($fname, $item_number, $desc, $txn_id, trim(strtok($_SERVER['REMOTE_ADDR'],",")), $expiry, $email);
    @xfpassthru($fh);
    exit;
  }
  $mimetype=pl_getmimetype($fname);
  // Check file exists
  if (!($fh = @fopen($link, "rb")))
  {
    ShowMessage($ErrorTemplate, "Could not open file.",$ErrorEmail);
    exit;
  }
  fclose($fh);
  header("Content-disposition: attachment; filename=\"".basename($fname)."\"\n");
  if ($mimetype!="")
    header("Content-type: ".$mimetype."\n");      
  else 
    header("Content-type: application/octet-stream\n");          
  header("Content-transfer-encoding: binary\n");
  // See if link is local path or URL
  $pos = strpos(strtolower($link), "http://");
  if (!is_integer($pos))
  {
    $fsize = $size;
    /* is resume requested? */
    if (isset($_SERVER['HTTP_RANGE']))
    {
      pl_rangeDownload($link);
    }
    else
    {
      if (!($fh = @fopen($link, "rb")))
      {
        ShowMessage($ErrorTemplate, "Could not open file.", $ErrorEmail);
        exit;
      }
      header("Accept-Ranges: bytes");
      if ((strtolower(ini_get('zlib.output_compression'))!="on") && (ini_get('zlib.output_compression')!="1"))
        header("Content-Length: " . $size . "\n");
      if ($NotifyDownloadEmail != "")
        EmailDownloadNotify($fname, $item_number, $desc, $txn_id, trim(strtok($_SERVER['REMOTE_ADDR'],",")), $expiry, $email);
      @xfpassthru($fh);
    }
  }
  else
  {
    // link is a URL rather than local path so do simple download
    $link = str_replace(" ", "%20", $link);
    if (!($fh = @fopen($link, "rb")))
    {
      ShowMessage($ErrorTemplate, "Could not open file.", $ErrorEmail);
      exit;
    }
    if ((strtolower(ini_get('zlib.output_compression'))!="on") && (ini_get('zlib.output_compression')!="1"))
    {
      if ((int)$size > 0)
        header("Content-Length: " . $size . "\n");
    }
    if ($NotifyDownloadEmail != "")
      EmailDownloadNotify($fname, $item_number, $desc, $txn_id, trim(strtok($_SERVER['REMOTE_ADDR'],",")), $expiry, $email);
    @xfpassthru($fh);
  }
  exit;
}

// ! AUTO-RETURN / PDT RETURN
// If Auto Return and PDT used then verify order and get variables.
if (($calledasreturn==1) && (isset($_GET['tx'])) &&  (isset($_GET['amt'])))
{
  if($Debug){ echo "# AUTO-RETURN / PDT RETURN<br>".PHP_EOL; }
  $calledasautoreturn=1;
  if ($VerifyCurl==1)
  {
    $req = 'cmd=_notify-synch';
    $tx_token = strtoupper($_GET['tx']);
    $req .= "&tx=$tx_token&at=$PDTtoken";
//    $req .= "&sig=" . $_GET['sig'];
    $ch = curl_init();
    if ($UseSandbox==1)
    {
      curl_setopt($ch, CURLOPT_URL,"https://www.sandbox.paypal.com/cgi-bin/webscr");
      curl_setopt($ch, CURLOPT_PORT, 443);     
    }  
    else  
    {
      curl_setopt($ch, CURLOPT_URL,"http://www.paypal.com/cgi-bin/webscr");
      curl_setopt($ch, CURLOPT_PORT, 80);     
    }    
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $req);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
    if ($UseSandbox==1)
      curl_setopt($ch, CURLOPT_HTTPHEADER, array('Host: www.sandbox.paypal.com'));
    else
      curl_setopt($ch, CURLOPT_HTTPHEADER, array('Host: www.paypal.com'));      
    $ret = curl_exec($ch);
    curl_close($ch);   
  }
  else
  {
    // read the post from PayPal system and add 'cmd'
    $req = 'cmd=_notify-synch';
    $tx_token = strtoupper($_GET['tx']);
    $req .= "&tx=$tx_token&at=$PDTtoken";
    // post back to PayPal system to validate
    $header .= "POST /cgi-bin/webscr HTTP/1.1\r\n";
    if ($UseSandbox==1){
      $header .="Host: www.sandbox.paypal.com\r\n";
    }else{
      $header .="Host: www.paypal.com\r\n";
    }       
    $header .= "Content-Type: application/x-www-form-urlencoded\r\n";
    $header .= "Content-Length: " . strlen($req) . "\r\n";
    $header .="Connection: close\r\n\r\n";
    if ($UseSandbox==1)
      $fp = fsockopen ('ssl://www.sandbox.paypal.com', 443, $errno, $errstr, 30);
    else
      $fp = fsockopen ('www.paypal.com', 80, $errno, $errstr, 30);      
    if (!$fp) 
    {
      $res="";
    } 
    else
    {
      fputs ($fp, $header . $req);
      // read the body data
      $ret = '';
      $headerdone = false;
      while (!feof($fp))
      {
        $line = fgets ($fp, 1024);
        if (strcmp($line, "\r\n") == 0)
        {
          // read the header
          $headerdone = true;
        }
        else if ($headerdone)
        {
          // header has been read. now read the contents
          $ret .= $line;
        }
      }
      fclose ($fp);
    }  
  }   
  
  
  // parse the data
  $lines = explode("\n", $ret);
  $keyarray = array();
  $starti=-1;
  for ($i=0; $i<count($lines);$i++)
  { 
    if (strcmp (trim($lines[$i]), "SUCCESS") == 0)
    {
      $starti=$i;
      break;
    }  
  }  
  if ($starti>-1)
  {
    for ($i=$starti; $i<count($lines);$i++)
    {
      list($key,$val) = explode("=", $lines[$i]);
      $keyarray[urldecode($key)] = urldecode(rtrim($val));
    }      
    // assign posted variables to local variables
    if (!empty($keyarray)) while (list($name, $value) = each($keyarray)) $$name = $value; 
    $res="VERIFIED";         
  }
  else
  {
    $res="";
  }
}

// ! IPN HANDLER
// If not download request then establish whether we are being called from paypal.com
if (($Test == "Y") || ($manualorder == true) || ($notPayPal == true)){
  	if($Debug){ echo "# TEST || MANUAL || DIRECT == TRUE <br>".PHP_EOL; }
	$res = "VERIFIED";
}else if ($calledasautoreturn!=1){
  if ($VerifyCurl==1)
  {
    if($Debug){ echo "# VERIFY CURL<br>".PHP_EOL; }
    
    if ($UseSandbox==1)
    {
      if($Debug){ echo "# USE SANDBOX<br>".PHP_EOL; }
      $curlurl = 'https://www.sandbox.paypal.com/cgi-bin/webscr';
      $curlport=443;
    }  
    else
    {
      if($Debug){ echo "# DO NOT USE SANDBOX<br>".PHP_EOL; }
      $curlurl = 'http://www.paypal.com/cgi-bin/webscr';    
      $curlport=80;
    }  
    // get post vars 
    
    if($Debug){ echo "# VERIFY IPN REQUEST FROM PAYPAL<br>".PHP_EOL; }
    
    $curlreq = 'cmd=_notify-validate'; 
    foreach($_POST as $curlkey => $curlvalue) 
    { 
        $$curlkey = trim(stripslashes($curlvalue)); 
        $curlreq .= '&'. $curlkey .'='. urlencode($curlvalue); 
    }      
    // submit post values to paypal 
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $curlurl);
    curl_setopt($ch, CURLOPT_PORT, $curlport);     
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $curlreq);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
    if ($UseSandbox==1)
      curl_setopt($ch, CURLOPT_HTTPHEADER, array('Host: www.sandbox.paypal.com'));
    else
      curl_setopt($ch, CURLOPT_HTTPHEADER, array('Host: www.paypal.com'));      
    $res = curl_exec($ch);
    curl_close($ch);
  }else{
    reset ($_POST);
    $req = 'cmd=_notify-validate';
    foreach ($_POST as $key => $value)
    {
      $value = urlencode(stripslashes($value));
      $req .= "&$key=$value";
    }
    // post back to PayPal system to validate
    $header .= "POST /cgi-bin/webscr HTTP/1.1\r\n";
    if ($UseSandbox==1)
      $header .="Host: www.sandbox.paypal.com\r\n";
    else
      $header .="Host: www.paypal.com\r\n";        
    $header .= "Content-Type: application/x-www-form-urlencoded\r\n";
    $header .= 'Content-Length: ' . strlen($req) . "\r\n";
    $header .="Connection: close\r\n\r\n";
    if ($UseSandbox==1)
      $fp = fsockopen ('ssl://www.sandbox.paypal.com', 443, $errno, $errstr, 30);
    else  
      $fp = fsockopen ('www.paypal.com', 80, $errno, $errstr, 30);      
    if ($fp)
    {
      fputs ($fp, $header . $req);
      while (!feof($fp))
      {
        $res = fgets ($fp, 1024);
        $res=trim($res);
        if (strcmp ($res, "VERIFIED") == 0)
          break;
        if (strcmp ($res, "INVALID") == 0)
          break;
      }
      fclose ($fp);
    }
  }
}


// ! SET IP ADDRESS
if (!$manualorder) {
	
if($Debug){ echo "# SETUP IP ADDRESS<br>".PHP_EOL; }
	
  $clientipaddr = "0.0.0.0";
  
  if ($calledasreturn==1){
    if (ValidIP($_SERVER['REMOTE_ADDR']))
      $clientipaddr = $_SERVER['REMOTE_ADDR'];
    if (function_exists('vl_geoip2'))
      $clientipinfo=vl_geoip2($_SERVER['REMOTE_ADDR']); 
  }
  
  if (($calledasreturn==0) && (strlen($custom) > 10)){
    $k = GetVarFromString($custom, "I");
    if (function_exists('vl_geoip2'))
      $clientipinfo=vl_geoip2($k);    
    if (ValidIP($k))
      $clientipaddr = $k;
  }
  
}




// ! STORE ORDER IN MySQL
if ($res == "VERIFIED")
{
  if($Debug){ echo "# VERIFIED<br>".PHP_EOL; }
  
  if ($DbTableNameOrders != ""){
	  if($Debug){ echo "# STORE ORDER TO MYSQL<br>".PHP_EOL; }
	  storeOrderToMySQL();
  }
}



// If order completed but transaction type is reversal then don't continue handling it
if (($payment_status == "Completed") && ($txn_type == "reversal")){
	if($Debug){ echo "# TXN TYPE IS REVERSAL = EXITING<br>".PHP_EOL; }
	exit;
}
 
// ! NOT VERIFIED, SHOW ERROR  
// TODO: THIS IS DEFUALT ERROR MAKE IT BETTER THAT THIS -MY 
if ($res != "VERIFIED")
{ 
  if($Debug){ echo "# NOT VERIFIED = EXITING<br>".PHP_EOL; }
  
  if ($manualorder == false){
	  if($Debug){ echo "# NOT MANUAL ORDER = SHOW ERROR<br>".PHP_EOL; }
	  ShowMessage($ErrorTemplate, $DefaultProErrorText, $ErrorEmail);
  }
  exit;
}

  
// Handle delayed delivery because of eCheck or Payment Review
// MAY NOT NEED THIS FOR PAYLOOM?
if($Debug){ echo "# HANDLE DELAYED PAYMENTS?<br>".PHP_EOL; }
$copy_payment_status=$payment_status;
// See how to handle Payment Review 
if (($payment_status == "Pending") && ($pending_reason == "paymentreview") && ($DelayPaymentReview != "Y")){
	$copy_payment_status = "Completed";
}
  
if (($payment_status == "Pending") && ($pending_reason == "paymentreview") && ($DelayPaymentReview == "Y"))
{
  // Send notify or confirmation emails if required
  if ($calledasreturn==0)
  {
    // Send a notify email if required
    if (($NotifyTemplate!="") && ($NotifyEmail!=""))
    {
      if ($manualorder==false)
        SendNotifyEmail($NotifyTemplate, $NotifyEmail);
    }
    // Send a confirmation email if required
    if ($ConfirmTemplate!="")
    {
      if ($manualorder==false)
        SendNotifyEmail($ConfirmTemplate, $payer_email);
    }
      SendFraudEmail($ReviewTemplate, $ProdId, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ProdExtra, $notdownloadable);              
      ShowMessage($ErrorTemplate, "Your download links will be emailed to you when your eCheck payment clears.","");
      exit;
  }
  else
  {
    DisplayFraudPage($ReviewTemplatePage, $ProdId, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ProdExtra, $notdownloadable);
    exit;    
  }
}
  
// See how we should handle eChecks.
// If instant download allowed and eCheck just cleared then don't process again.
// Txnid updated when original order processed
if($Debug){ echo "# DEAL WITH E-CHECKS<br>".PHP_EOL; }
if (($DelayEchecks != "Y") && ($payment_type == "echeck") && ($payment_status == "Completed"))
  exit;
// See if instant download allowed
if (($payment_status == "Pending") && ($pending_reason == "echeck") && ($DelayEchecks != "Y"))
  $copy_payment_status = "Completed";
  
if (($payment_status == "Pending") && ($pending_reason == "echeck") && ($DelayEchecks == "Y"))
{
  // Send notify or confirmation emails if required
  if ($calledasreturn==0)
  {
    // Send a notify email if required
    if (($NotifyTemplate!="") && ($NotifyEmail!=""))
    {
      if ($manualorder==false)
        SendNotifyEmail($NotifyTemplate, $NotifyEmail);
    }
    // Send a confirmation email if required
    if ($ConfirmTemplate!="")
    {
      if ($manualorder==false)
        SendNotifyEmail($ConfirmTemplate, $payer_email);
    }
      SendFraudEmail($WarningTemplate, $ProdId, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ProdExtra, $notdownloadable);             
      ShowMessage($ErrorTemplate, "Your download links will be emailed to you when your eCheck payment clears.","");
      exit;
  }
  else
  {
    DisplayFraudPage($WarningTemplatePage, $ProdId, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ProdExtra, $notdownloadable);
    exit;    
  }
}

$payment_status=$copy_payment_status;

if ($payment_status != "Completed")
{
  if($Debug){ echo "# PAYMENT STATUS != COMPLETED<br>".PHP_EOL; }
  if ($manualorder == false) {
	  if($Debug){ echo "# SHOW ERROR THEN EXIT<br>".PHP_EOL; }
	  ShowMessage($ErrorTemplate, $TransactionNotCompleteText, $ErrorEmail);
  }
  exit;
}
// Send notify or confirmation emails and call AWeber, ARP as required.
if ($calledasreturn == 0 || ( $notPayPal && $calledasreturn == 1))
{
  if($Debug){ echo "# SEND EMAILS ...<br>".PHP_EOL; }
  
  // Send a notify email if required
  if (($NotifyTemplate != "") && ($NotifyEmail != ""))
  {
    if($Debug){ echo "# SEND NOTIFY EMAIL<br>".PHP_EOL; }
    if ($manualorder == false)
      SendNotifyEmail($NotifyTemplate, $NotifyEmail);
  }
  // Send a confirmation email if required
  if ($ConfirmTemplate != "")
  {
    if($Debug){ echo "# SEND CONFIRM EMAIL<br>".PHP_EOL; }
    if ($manualorder == false)
      SendNotifyEmail($ConfirmTemplate, $payer_email);
  }
}

// ! VERIFY TXNID
if ($Txnid != "")
{
  if($Debug){ echo "# TXNID CHECK<br>".PHP_EOL; }
  
  // Adjust txn_id depending on whether we were called by IPN or return page
  if ($calledasreturn == 0)
    $ourtxn_id = $txn_id . "-ipn";
  else
    $ourtxn_id = $txn_id . "-return";
  if (VerifyTransactionId($Txnid, $ourtxn_id) == 0)
  {
	  if($Debug){ echo "# ORDER ALREADY PROCESSED<br>".PHP_EOL; }
	  
	if($manualorder == true)
	{
		ShowAlert('Order number '.$txn_id.' has already been processed.', 'danger');
	}else{
    ShowMessage($ErrorTemplate, "Order number ".$txn_id." has already been processed. Check your email for download links.", $ErrorEmail);
    }
    exit; // Order already processed
  }

}
// Verify that receiver email is ours
if (strcasecmp($receiver_email, $PaypalEmail) != 0)
{
  if($Debug){ echo "# VERIFY RECEIVER EMAIL IS OURS<br>".PHP_EOL; }
  echo "$receiver_email = $PaypalEmail";
  ShowMessage($ErrorTemplate, "Paypal email address does not match.", $ErrorEmail);
  exit;
}
// See which currency transaction was in
$paycurr = $mc_currency;
$totalpaid = $mc_gross;
//$affcurrmult = isset($exchange[$paycurr]) ? $exchange[$paycurr] : 1;
//$totalaffiliate=round(($mc_gross-$tax) * $affcurrmult, 2);
$notdownloadable = 0;
$totalordered = 0; // Keep track of what should be paid
$nocurrency = false;
$minprod = 0;
$maxprod = 10;
if ($num_cart_items > 0)
{
  if($Debug){ echo "# NUM_CART_ITEMS > 0<br>".PHP_EOL; }
  $maxprod = $num_cart_items + 1;
  $minprod = 1;
}
if ($manualorder == true)
{
  if($Debug){ echo "# MANUAL ORDER == TRUE<br>".PHP_EOL; }
  $maxprod = $num + 1;
  $minprod = 1;
}

if($Debug){ echo "# START ITEM LOOP<br>".PHP_EOL; }
for ($k = $minprod; $k < $maxprod; $k++)
{
if($Debug){ echo "# LOOP $k...<br>".PHP_EOL; }
  if ($k == 0)
  {
    if($Debug){ echo "# MINPROD == 0<br>".PHP_EOL; }
    if (isset($item_number))
    {
      if($Debug){ echo "# ITEM_NUMBER ISSET ( $item_number )<br>".PHP_EOL; }
      
      if ($item_number != "")
      {
        $desc = $item_name;
        if($Debug){ echo "# ITEM NAME == $item_name<br>".PHP_EOL; }
        
          if ($UsePaypalOptions==true)
            $item_number.=$option_selection1.$option_selection2; 
                                       
          $j = GetProductDetails($item_number, $paycurr, $cost, $desc, $link, $size, $exp, $extra);
        
        if ($j == 0)
        {
          if($Debug){ echo "# ITEM NOT FOUND == NOTDOWNLOADABLE?<br>".PHP_EOL; }
          $notdownloadable++;
          continue;
        }
        if ((!isset($quantity)) || ($quantity == 0) || ($quantity == ""))
          $quantity = 1;
        if ($cost != -1)
          $totalordered = $totalordered + ($cost * $quantity);
        if (($cost == -1) && ($manualorder == false))
        {
          $nocurrency = true;
          continue;
        }
        $combos = explode(":", $link);
        if ((count($combos) == 1) || (substr(strtolower($link), 0, 5) == "http:") || (substr($link, 1, 2) == ":/"))
        {
          // Single file product
          if ($exp != 0)
          {
            if (strlen($exp) == 12)
            {
              $expiry = mktime(substr($exp, 8, 2), substr($exp, 10, 2), 0, substr($exp, 4, 2), substr($exp, 6, 2), substr($exp, 0, 4), -1);
              if (($calledasreturn==1) && (isset($payment_date)))              
                $exp = ($expiry - strtotime($payment_date)) / 60;
              else
                $exp = ($expiry - time()) / 60;                
            }
            else
            {
              if (($calledasreturn==1) && (isset($payment_date)))
                $expiry = strtotime($payment_date) + ($exp * 60);
              else
                $expiry = time() + ($exp * 60);
            }
          }
          else
            $expiry = 0;
          // See if ip locking required
          $ipleveltouse = $IPlock;
          if (($manualorder == true) && ($manualiplevel != "-1"))
            $ipleveltouse = $manualiplevel;
          else
          {
            $pos = strpos($extra, "IPLOCK=");
            if (is_integer($pos))
              $ipleveltouse = substr($extra, $pos + 7, 1);
          }
          // Handle multiple quantities of items. Useful if several serial numbers are required fo example
          $q = 1;
          $pos = strpos($extra, "MULTIPLE=");
          if (is_integer($pos))
            $q = $quantity;
          for ($i = 1;$i <= $q;$i++)
          {
            $ProdLink[] = GetSecureLink($link, $item_number, $expiry, $txn_id, $clientipaddr, $ipleveltouse,$payer_email);
            $ProdDesc[] = $desc;
            if ($link != "NA")
              $ProdFile[] = filename($link);
            else
              $ProdFile[] = "";
            $ProdSize[] = $size;
            $ProdExp[] = $exp;
            $ProdId[] = $item_number;
            $ProdExtra[] = $extra;
            if ($q==1)
              $ProdQty[] = $quantity;
            else
              $ProdQty[] = "1";                      
          }
        }
        else
        {
          // Multi file product (combo)
          // Loop round for each file
          $comboexpiry = $exp;
          for ($com = 0;$com < count($combos);$com++)
          {
            $j = GetProductDetails($combos[$com], $paycurr, $cost, $desc, $link, $size, $exp, $extra);
            if ($j == 0)
              continue;
            if ($comboexpiry != -1)
              $exp = $comboexpiry;
            if ($exp != 0)
            {
              if (strlen($exp) == 12)
              {
                $expiry = mktime(substr($exp, 8, 2), substr($exp, 10, 2), 0, substr($exp, 4, 2), substr($exp, 6, 2), substr($exp, 0, 4), -1);
                if (($calledasreturn==1) && (isset($payment_date)))              
                  $exp = ($expiry - strtotime($payment_date)) / 60;
                else
                  $exp = ($expiry - time()) / 60;
              }
              else
              {
                if (($calledasreturn==1) && (isset($payment_date)))
                  $expiry = strtotime($payment_date) + ($exp * 60);
                else              
                  $expiry = time() + ($exp * 60);
              }  
            }
            else
              $expiry = 0;
            // See if ip locking required
            $ipleveltouse = $IPlock;
            if (($manualorder == true) && ($manualiplevel != "-1"))
              $ipleveltouse = $manualiplevel;
            else
            {
              $pos = strpos($extra, "IPLOCK=");
              if (is_integer($pos))
                $ipleveltouse = substr($extra, $pos + 7, 1);
            }
            // Handle multiple quantities of items. Useful if several serial numbers are required fo example
            $q = 1;
            $pos = strpos($extra, "MULTIPLE=");
            if (is_integer($pos))
              $q = $quantity;
            for ($i = 1;$i <= $q;$i++)
            {
              $ProdLink[] = GetSecureLink($link, $combos[$com], $expiry, $txn_id, $clientipaddr, $ipleveltouse,$payer_email);
              $ProdDesc[] = $desc;
              if ($link != "NA")
                $ProdFile[] = filename($link);
              else
                $ProdFile[] = "";
              $ProdSize[] = $size;
              $ProdExp[] = $exp;
              $ProdId[] = $combos[$com];
              $ProdExtra[] = $extra;
              if ($q==1)
                $ProdQty[] = $quantity;
              else
                $ProdQty[] = "1";          
            }
          }
        }
      }
    }
  }
  else
  {
    if($Debug){ echo "# LOOP# > 0<br>".PHP_EOL; }
    
    $t = ($notPayPal) ? "item_number_" . $k : "item_number" . $k;
    
    if($Debug){ echo "# ITEM NUMBER == $t<br>".PHP_EOL; }
    
    if (isset($$t))
    {
      $pid = $$t;
      if ($pid != "")
      {
        $t = ($notPayPal) ? "quantity_" . $k :"quantity" . $k;
        $pqty = $$t;
        $t = ($notPayPal) ? "item_name_" . $k :"item_name" . $k;
        $desc = $$t;
        
	      if ($UsePaypalOptions==true)
	      {
	        $psel1="option_selection1_".$k;
	        $psel2="option_selection2_".$k;
	        $pid.=$$psel1.$$psel2;
	      }
	                         
	      $j = GetProductDetails($pid, $paycurr, $cost, $desc, $link, $size, $exp, $extra);
        
        if($Debug){ echo "# ITEM FOUND == $j<br>".PHP_EOL; }
        
        if (($manualorder == true) && ($newexpiry != -1))
          $exp = $newexpiry;
        
        if ($j == 0)
        {
          $notdownloadable++;
          continue;
        }
        
        if ((!isset($pqty)) || ($pqty == 0) || ($pqty == ""))
          $pqty = 1;
        if ($cost != -1)
          $totalordered = $totalordered + ($cost * $pqty);
        if (($cost == -1) && ($manualorder == false))
        {
          $nocurrency = true;
          continue;
        }
        $combos = explode(":", $link);
        if ((count($combos) == 1) || (substr(strtolower($link), 0, 5) == "http:") || (substr($link, 1, 2) == ":/"))
        {
          // Single file product
          if ($exp != 0)
          {
            if (strlen($exp) == 12)
            {
              $expiry = mktime(substr($exp, 8, 2), substr($exp, 10, 2), 0, substr($exp, 4, 2), substr($exp, 6, 2), substr($exp, 0, 4), -1);
              if (($calledasreturn==1) && (isset($payment_date)))              
                $exp = ($expiry - strtotime($payment_date)) / 60;
              else
                $exp = ($expiry - time()) / 60;
            }
            else
            {
              if (($calledasreturn==1) && (isset($payment_date)))
                $expiry = strtotime($payment_date) + ($exp * 60);
              else            
                $expiry = time() + ($exp * 60);
            }
          }
          else
            $expiry = 0;
          // See if ip locking required
          $ipleveltouse = $IPlock;
          if (($manualorder == true) && ($manualiplevel != "-1"))
            $ipleveltouse = $manualiplevel;
          else
          {
            $pos = strpos($extra, "IPLOCK=");
            if (is_integer($pos))
              $ipleveltouse = substr($extra, $pos + 7, 1);
          }
          // Handle multiple quantities of items. Useful if several serial numbers are required fo example
          $q = 1;
          $pos = strpos($extra, "MULTIPLE=");
          if (is_integer($pos))
            $q = $pqty;
          for ($i = 1;$i <= $q;$i++)
          {
            $ProdLink[] = GetSecureLink($link, $pid, $expiry, $txn_id, $clientipaddr, $ipleveltouse, $payer_email);
            $ProdDesc[] = $desc;
            if ($link != "NA")
              $ProdFile[] = filename($link);
            else
              $ProdFile[] = "";
            $ProdSize[] = $size;
            $ProdExp[] = $exp;
            $ProdId[] = $pid;
            $ProdExtra[] = $extra;
            if ($q==1)
              $ProdQty[] = $pqty;
            else
              $ProdQty[] = "1";          
          }
        }
        else
        {
          // Multi file product (combo)
          // Loop round for each file
          $comboexpiry = $exp;
          for ($com = 0;$com < count($combos);$com++)
          {
            $j = GetProductDetails($combos[$com], $paycurr, $cost, $desc, $link, $size, $exp, $extra);
            if ($j == 0)
              continue;
            if ($comboexpiry != -1)
              $exp = $comboexpiry;
            if (($manualorder == true) && ($newexpiry != -1))
              $exp = $newexpiry;
            if ($exp != 0)
            {
              if (strlen($exp) == 12)
              {
                $expiry = mktime(substr($exp, 8, 2), substr($exp, 10, 2), 0, substr($exp, 4, 2), substr($exp, 6, 2), substr($exp, 0, 4), -1);
                if (($calledasreturn==1) && (isset($payment_date)))              
                  $exp = ($expiry - strtotime($payment_date)) / 60;
                else
                  $exp = ($expiry - time()) / 60;
              }
              else
              {
                if (($calledasreturn==1) && (isset($payment_date)))
                  $expiry = strtotime($payment_date) + ($exp * 60);
                else              
                  $expiry = time() + ($exp * 60);
              }  
            }
            else
              $expiry = 0;
            // See if ip locking required
            $ipleveltouse = $IPlock;
            if (($manualorder == true) && ($manualiplevel != "-1"))
              $ipleveltouse = $manualiplevel;
            else
            {
              $pos = strpos($extra, "IPLOCK=");
              if (is_integer($pos))
                $ipleveltouse = substr($extra, $pos + 7, 1);
            }
            // Handle multiple quantities of items. Useful if several serial numbers are required fo example
            $q = 1;
            $pos = strpos($extra, "MULTIPLE=");
            if (is_integer($pos))
              $q = $pqty;
            for ($i = 1;$i <= $q;$i++)
            {
              $ProdLink[] = GetSecureLink($link, $combos[$com], $expiry, $txn_id, $clientipaddr, $ipleveltouse, $payer_email);
              $ProdDesc[] = $desc;
              if ($link != "NA")
                $ProdFile[] = filename($link);
              else
                $ProdFile[] = "";
              $ProdSize[] = $size;
              $ProdExp[] = $exp;
              $ProdId[] = $combos[$com];
              $ProdExtra[] = $extra;
              if ($q==1)
                $ProdQty[] = $pqty;
              else
                $ProdQty[] = "1";          
            }
          }
        }
      }
    }
  }
}
// Check that attempt wasn't made to use a currency that is not accepted.
if ($manualorder == false)
{
  if ($nocurrency == true)
  {
    if($Debug){ echo "# CURRENCY NOT ACCEPTED<br>".PHP_EOL; }
    ShowMessage($ErrorTemplate, "Payment made with a currency that is not accepted.", $ErrorEmail);
    exit;
  }
}
// Check that amount paid at least covers the download files requested.
if ($manualorder == false)
{
  if($Debug){ echo "# VERIFY AMOUNT PAID $totalpaid<br>".PHP_EOL; }
  
  // If custom has been set by Vibracart then we can get the discount amount applied
/*
  if (strlen($custom) > 5)
  {
    $k = GetVarFromString($custom, "D");
    if (is_numeric($k))
      $discount = $k;
  }
*/

  if (isset($discount))
  {
    if (($totalpaid+$discount) < ($totalordered * 0.995))
    {
      if($Debug){ echo "# TOTALPAID $totalpaid (WITH DISCOUNT) NOT ENOUGH<br>".PHP_EOL; }
      ShowMessage($ErrorTemplate, $WrongAmountText, $ErrorEmail);
      exit;
    }
  }
  else
  {
    if ($totalpaid < ($totalordered * 0.995))
    {
      if($Debug){ echo "# TOTALPAID $totalpaid (NO DISCOUNT) NOT ENOUGH<br>".PHP_EOL; }
      ShowMessage($ErrorTemplate, $WrongAmountText, $ErrorEmail);
      exit;
    }
  }
}
if ($manualorder == false)
{
  if ((($clientipaddr == "") || ($clientipaddr == "0.0.0.0")) && ($RequireCustom == 1))
  {
    ShowMessage($ErrorTemplate, "Button appears to have been tampered with.", "");
    exit;
  }
}
// Check for any bonus items
if (isset($OrderBonus) && is_array($OrderBonus))
{
  $bonusproductsstr="";
  for ($k=0;$k<count($OrderBonus);$k++)
  {
    $limit=strtok($OrderBonus[$k],",");
    if ($totalpaid>=$limit)
      $bonusproductsstr=strtok(","); 
  }
  if ($bonusproductsstr!="")
  {
    if (!isset($OrderBonusText))
      $OrderBonusText="";
    $bonusproducts=explode(":",$bonusproductsstr);
    for ($k=0;$k<count($bonusproducts);$k++)
    {
      $pid = $bonusproducts[$k];
      if ($pid != "")
      {
        $j = GetProductDetails($pid, $paycurr, $cost, $desc, $link, $size, $exp, $extra);
        if (($manualorder == true) && ($newexpiry != -1))
          $exp = $newexpiry;
        if ($j == 0)
        {
          $notdownloadable++;
          continue;
        }
        $combos = explode(":", $link);
        if ((count($combos) == 1) || (substr(strtolower($link), 0, 5) == "http:") || (substr($link, 1, 2) == ":/"))
        {
          // Single file product
          if ($exp != 0)
          {
            if (strlen($exp) == 12)
            {
              $expiry = mktime(substr($exp, 8, 2), substr($exp, 10, 2), 0, substr($exp, 4, 2), substr($exp, 6, 2), substr($exp, 0, 4), -1);
              if (($calledasreturn==1) && (isset($payment_date)))              
                $exp = ($expiry - strtotime($payment_date)) / 60;
              else
                $exp = ($expiry - time()) / 60;
            }
            else
            {
              if (($calledasreturn==1) && (isset($payment_date)))
                $expiry = strtotime($payment_date) + ($exp * 60);
              else            
                $expiry = time() + ($exp * 60);
            }
          }
          else
            $expiry = 0;
          // See if ip locking required
          $ipleveltouse = $IPlock;
          if (($manualorder == true) && ($manualiplevel != "-1"))
            $ipleveltouse = $manualiplevel;
          else
          {
            $pos = strpos($extra, "IPLOCK=");
            if (is_integer($pos))
              $ipleveltouse = substr($extra, $pos + 7, 1);
          }
          $ProdLink[] = GetSecureLink($link, $pid, $expiry, $txn_id, $clientipaddr, $ipleveltouse, $payer_email);
          $ProdDesc[] = $OrderBonusText.$desc;
          if ($link != "NA")
            $ProdFile[] = filename($link);
          else
            $ProdFile[] = "";
          $ProdSize[] = $size;
          $ProdExp[] = $exp;
          $ProdId[] = $pid;
          $ProdExtra[] = $extra;
          $ProdQty[] = "1";          
        }
        else
        {
          // Multi file product (combo)
          // Loop round for each file
          $comboexpiry = $exp;
          for ($com = 0;$com < count($combos);$com++)
          {
            $j = GetProductDetails($combos[$com], $paycurr, $cost, $desc, $link, $size, $exp, $extra);
            if ($j == 0)
              continue;
            if ($comboexpiry != -1)
              $exp = $comboexpiry;
            if (($manualorder == true) && ($newexpiry != -1))
              $exp = $newexpiry;
            if ($exp != 0)
            {
              if (strlen($exp) == 12)
              {
                $expiry = mktime(substr($exp, 8, 2), substr($exp, 10, 2), 0, substr($exp, 4, 2), substr($exp, 6, 2), substr($exp, 0, 4), -1);
                if (($calledasreturn==1) && (isset($payment_date)))              
                  $exp = ($expiry - strtotime($payment_date)) / 60;
                else
                  $exp = ($expiry - time()) / 60;
              }
              else
              {
                if (($calledasreturn==1) && (isset($payment_date)))
                  $expiry = strtotime($payment_date) + ($exp * 60);
                else              
                  $expiry = time() + ($exp * 60);
              }  
            }
            else
              $expiry = 0;
            // See if ip locking required
            $ipleveltouse = $IPlock;
            if (($manualorder == true) && ($manualiplevel != "-1"))
              $ipleveltouse = $manualiplevel;
            else
            {
              $pos = strpos($extra, "IPLOCK=");
              if (is_integer($pos))
                $ipleveltouse = substr($extra, $pos + 7, 1);
            }
            $ProdLink[] = GetSecureLink($link, $combos[$com], $expiry, $txn_id, $clientipaddr, $ipleveltouse, $payer_email);
            $ProdDesc[] = $OrderBonusText.$desc;
            if ($link != "NA")
              $ProdFile[] = filename($link);
            else
              $ProdFile[] = "";
            $ProdSize[] = $size;
            $ProdExp[] = $exp;
            $ProdId[] = $combos[$com];
            $ProdExtra[] = $extra;
            $ProdQty[] = "1";          
          }
        }
      }   
    }
  }
}
// End of bonus item handling

      
// !IPN or RETURN PAGE

// !IPN or EMAIL ONLY RESULT
if ($calledasreturn == 0 || ( $notPayPal && $calledasreturn == 1) )
{
  
  if($Debug){ echo "# SEND EMAIL<br>".PHP_EOL; }
  // Send either custom or predefined download links email

  if ((count($ProdId) > 0) || ($AlwaysEmail==true))
  {
    // See if product specific email template defined
    $newtemplate = "";
    $sendsms=false;
    $tempcount = 0;  
    for ($k = 0;$k < count($ProdId);$k++)
    {
      $extrasettings = explode("*", $ProdExtra[$k]);
      for ($j = 0;$j < count($extrasettings);$j++)
      {
        $command = explode("=", $extrasettings[$j],2);
        if ((strtoupper($command[0]) == "SMS") && (strtoupper($command[1])=="YES"))
          $sendsms=true;
              
      }
    }
    // See if any product email notifications need to be made.
    if (count($productnotifyemails)>0)
    {
      $productnotifyemails=array_unique($productnotifyemails);
      if ($ProductNotifyTemplate != "")
      {
        for ($k=0;$k<count($productnotifyemails);$k++)
        {
          SendNotifyEmail($ProductNotifyTemplate, $productnotifyemails[$k]);
        }
      }      
    }
    
    if (($tempcount == count($ProdId)) && ($tempcount > 0))
      $EmailTemplate = $newtemplate;
    
    
    
    SendEmail($EmailTemplate, $ProdId, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ProdExtra, $notdownloadable);
    
    
      
  }

 // commented out on 2015-10-02 05:42 am - duplicate emails to customer bug?
 // SendEmail($EmailTemplate, $ProdId, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ProdExtra, $notdownloadable);
      
  
  if ($manualorder == true)
  {
    if($Debug){ echo "# MANUAL ORDER = SUCCESS<br>".PHP_EOL; }
    
    ShowAlert('Download links have been emailed to '.$payer_email.'</div>', 'success');
  }  
  else
  {
    if ($Test == "Y")
    {
	    if($Debug){ echo "# TEST = YES<br>".PHP_EOL; }
	    
		if ((count($ProdId) > 0) || ($AlwaysEmail==true)){
		    ShowAlert('Payloom setup seems to be OK. You should receive the download link by email.', 'success');
		}else{
		    ShowAlert('No email was sent because product ordered was not recognized. Check the product id used.', 'danger');
		}
    }   
  }
  
  
}

// ! DISPLAY RETURN PAGE
if ( $calledasreturn == 1 ||  $notPayPal  )
{
  if($Debug){ echo "# DISPLAY RETURN PAGE<br>".PHP_EOL; }
  // See if product specific download template defined
  $newtemplate = "";
  $tempcount = 0;
  for ($k = 0;$k < count($ProdId);$k++)
  {
    $extrasettings = explode("*", $ProdExtra[$k]);
    for ($j = 0;$j < count($extrasettings);$j++)
    {
      $command = explode("=", $extrasettings[$j],2);
      if (strtoupper($command[0]) == "DOWNTEMP")
      {
        if ($k == 0)
        {
          $newtemplate = $command[1];
          $tempcount++;
        }
        else
        {
          if (($command[1] != "") && ($newtemplate == $command[1]))
            $tempcount++;
        }
        continue;
      }
    }
  }
  
  if (($tempcount == count($ProdId)) && ($tempcount > 0))
    $DownloadTemplate = $newtemplate;
  
  if($Test == "Y")
  	echo '<div class="alert alert-info" style="padding-bottom:40px;">';
  // Display either predefined download page or custom one
  DisplayPage($DownloadTemplate, $ProdId, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ProdExtra, $notdownloadable);
  if($Test == "Y")
  	echo '</div>';
  
}


function GetSecureLink($link, $id, $expiry, $ordnum, $ip = "0.0.0.0", $ipl=0,$email="")
{
  global $NoFilename, $PayloomURL, $LinkKey;
  if ($link != "NA")
  {
    $dfile = filename($link);
    $verifyhash = md5($LinkKey . $id . $expiry . $ordnum . $ip . $ipl . urlencode($email));
    $auth = $id . "," . $expiry . "," . $ordnum . "," . $ip . "," . $ipl. "," . urlencode($email) . "," . $verifyhash;
    $auth = base64_encode($auth);
    $auth = rawurlencode($auth);
    if ($NoFilename == 1){
      $plink = "$PayloomURL?llauth=$auth";
    }else{
      $plink = "$PayloomURL?llauth=$auth/$dfile";
    }
  }else{
    $plink = "";
  }
  return ($plink);
}


function SendEmail($Template, $ProdId, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ProdExtra, $nd)
{
  global $SellerCompany, $SellerEmail, $SellerURL, $HTMLEmail, $manualorder,$llcharset,$Debug;
  
  if($Debug){ echo "# SENDEMAIL($Template)<br>".PHP_EOL; }
  
  
  if ($Template == "NONE")
    return;
  if ($Template!="")
  {  
    $ext = fileextension($Template);
    if ($ext == ".php")
    {
      ob_start();
      include $Template;
      $mailBody = ob_get_contents(); 
      ob_end_clean();    
    }
    else
    {
      if (!($fh = @fopen($Template, "r")))
        return(0);
      $mailBody = fread ($fh, 200000);
      fclose($fh);
    }
  }
  else
  {
    // Predefined html template
    if ($HTMLEmail=="Y")
    {
      $ext=".html";
      $mailBody="";
      $mailBody.="<html>\n";
      $mailBody.="<head>\n";
      $mailBody.="<meta http-equiv=\"content-type\" content=\"text/html; charset=".$llcharset."\">\n";      
      $mailBody.="<title>Your order from ".$SellerCompany."</title>\n";
      $mailBody.="</head>\n";
      $mailBody.="<body>\n";
      if ($manualorder==false)
        $mailBody.="Thank you for your order. For reference your order number is #order_number#.<br>\n";
      else
        $mailBody.="Thank you for your order.<br>\n";        
      $mailBody.="<!--knownstart-->\n";
      $mailBody.="<br>\n";
      $mailBody.="Please use the links below to download your purchase.<br>\n";
      $mailBody.="<br>\n";
      $mailBody.="<!--eachproductstart-->\n";
      $mailBody.="#product#<br>\n";
      $mailBody.="<br>\n";
      $mailBody.="<!--eachproductend-->\n";
      $mailBody.="<!--knownend-->\n";
      $mailBody.="<!--unknownstart-->\n";
      $mailBody.="<br>\n";
      $mailBody.="You have ordered items that are not downloadable. Your order will be processed as quickly as possible.<br>\n";
      $mailBody.="<!--unknownend-->\n";
      $mailBody.="If you have any questions regarding this order please contact us.<br>\n";
      $mailBody.="<br>\n";
      $mailBody.=$SellerCompany."<br>\n";
      $mailBody.="<a href=\"".$SellerURL."\">".$SellerURL."</a><br>\n";    
      $mailBody.="<a href=\"mailto:".$SellerEmail."\">".$SellerEmail."</a><br>\n";    
      $mailBody.="</body>\n";
      $mailBody.="</html>\n";
    }
    else
    {
      $ext=".txt";
      $mailBody="";
      $mailBody.="Your order from ".$SellerCompany."\n";
      if ($manualorder==false)
        $mailBody.="Thank you for your order. For reference your order number is #order_number#.\n";
      else   
        $mailBody.="Thank you for your order.\n";
      $mailBody.="<!--knownstart-->Please use the links below to download your purchase.\n";
      $mailBody.="\n";
      $mailBody.="<!--eachproductstart-->#product#\n";
      $mailBody.="<!--eachproductend--><!--knownend-->\n";
      $mailBody.="\n";
      $mailBody.="<!--unknownstart-->You have ordered items that are not downloadable but will be processed as quickly as possible.\n";
      $mailBody.="<!--unknownend-->\n";
      $mailBody.="If you have any questions regarding this order please contact us.\n";
      $mailBody.="\n";
      $mailBody.=$SellerCompany."\n";
      $mailBody.=$SellerURL."\n";
      $mailBody.=$SellerEmail."\n";   
    }
  }
  EmailTemplateProcess($mailBody, $ProdId, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ProdExtra, $nd, $ext);  
}

function SendFraudEmail($Template, $ProdId, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ProdExtra, $nd)
{
  global $SellerCompany, $SellerEmail, $SellerURL, $HTMLEmail, $manualorder, $llcharset;
  if ($Template!="")
  {  
    $ext = fileextension($Template);
    if ($ext == ".php")
    {
      ob_start();
      include $Template;
      $mailBody = ob_get_contents(); 
      ob_end_clean();    
    }
    else
    {
      if (!($fh = @fopen($Template, "r")))
        return(0);
      $mailBody = fread ($fh, 200000);
      fclose($fh);
    }
  }
  else
  {
    // Predefined html template
    if ($HTMLEmail=="Y")
    {
      $ext=".html";
      $mailBody="";
      $mailBody.="<html>\n";
      $mailBody.="<head>\n";
      $mailBody.="<meta http-equiv=\"content-type\" content=\"text/html; charset=".$llcharset."\">\n";
      $mailBody.="<title>Your order from ".$SellerCompany."</title>\n";
      $mailBody.="</head>\n";
      $mailBody.="<body>\n";
      if ($manualorder==false)
        $mailBody.="Thank you for your order. For reference your order number is #order_number#.<br>\n";
      else
        $mailBody.="Thank you for your order.<br><br>\n";        
      $mailBody.="Your order will be completed when payment has cleared in our Paypal account.<br>\n";
      $mailBody.="<br>\n";
      $mailBody.="If you have any questions regarding this order please contact us.<br>\n";
      $mailBody.="<br>\n";
      $mailBody.=$SellerCompany."<br>\n";
      $mailBody.="<a href=\"".$SellerURL."\">".$SellerURL."</a><br>\n";    
      $mailBody.="<a href=\"mailto:".$SellerEmail."\">".$SellerEmail."</a><br>\n";    
      $mailBody.="</body>\n";
      $mailBody.="</html>\n";
    }
    else
    {
      $ext=".txt";
      $mailBody="";
      $mailBody.="Your order from ".$SellerCompany."\n";
      if ($manualorder==false)
        $mailBody.="Thank you for your order. For reference your order number is #order_number#.\n";
      else   
        $mailBody.="Thank you for your order.\n\n";
      $mailBody.="Your order will be completed when payment has cleared in our Paypal account.\n";
      $mailBody.="\n";
      $mailBody.="If you have any questions regarding this order please contact us.\n";
      $mailBody.="\n";
      $mailBody.=$SellerCompany."\n";
      $mailBody.=$SellerURL."\n";
      $mailBody.=$SellerEmail."\n";   
    }
  }
  EmailTemplateProcess($mailBody, $ProdId, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ProdExtra, $nd, $ext);  
}

function EmailTemplateProcess($mailBody, $ProdId, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ProdExtra, $nd, $ext)
{
  global $SellerCompany, $SellerEmail, $SellerURL  ,$payer_email, $CopyEmail, $EmailHeaderNoSlashR, $UnknownEsegment, $HTMLEmail, $ExtraMailParam;
  global $DownloadBackground, $llcharset,$txn_id,$Debug;
  
  if($Debug){ echo "# EMAILTEMPLATEPROCESS() CALLED<br>".PHP_EOL; }
  
  
  // Insert #unknownsegment# variable)
  InsertUsegment($mailBody, $UnknownEsegment, $nd);
  // Replace all non product related variables
  InsertVariables($mailBody);
  // Insert product variables
  InsertProductVariables($mailBody, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ext);
  // Insert item loop variables
  InsertItemLoopVariables($mailBody);
  // Insert variables and repeat block for #eachproductstart#
  InsertLoopVariables($mailBody, $ProdId, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ProdExtra, "ESEGMENT", $ext);
  // Handle any <!--unknownstart--> <!--unknownend--> section
  InsertUnknownSection($mailBody, $nd);
  // Handle any <!--knownstart--> <!--knownend--> section
  InsertKnownSection($mailBody,count($ProdDesc));
  // If using a download background page replace auth with authe
  if ($DownloadBackground!="")
    $mailBody = str_replace("?llauth=", "?authe=", $mailBody);        
  // Get subject for email
  if ($ext == ".txt")
  {
    $pos = strpos($mailBody, "\n");
    $subject = substr($mailBody, 0, $pos);
    $mailBody = substr($mailBody, $pos + 1, strlen($mailBody) - $pos-1);
  }
  else
  {
    $subject = "Download Links";
    $pos = strpos($mailBody, "<TITLE>");
    if (!is_integer($pos))
      $pos = strpos($mailBody, "<title>");
    $pos2 = strpos($mailBody, "</TITLE>");
    if (!is_integer($pos2))
      $pos2 = strpos($mailBody, "</title>");
    if ((is_integer($pos)) && (is_integer($pos2)))
    {
      $subject = substr($mailBody, $pos + 7, $pos2 - $pos-7);
    }
  }
  if (($HTMLEmail == "Y") && ($ext == ".txt"))
  {
    $mailBody = str_replace("\n", "<br>\n", $mailBody);
    $mailBody = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD W3 HTML//EN\">\n<HTML>\n<HEAD>\n<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=".$llcharset."\">\n<TITLE>Download Information</TITLE>\n</HEAD>\n<BODY>\n" . $mailBody;
    $mailBody .= "</BODY>\n</HTML>\n";
  }
  if (($HTMLEmail == "Y") && ($ext != ".txt"))
    $mailBody = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD W3 HTML//EN\">\n" . $mailBody;
    
  SendEmailOut($payer_email, $SellerEmail, $SellerCompany, $subject, $mailBody, $HTMLEmail);
  if ($CopyEmail != "")
  {
    $subject = "Copy of order email sent to $payer_email for order $txn_id";
    SendEmailOut($CopyEmail, $SellerEmail, $SellerCompany, $subject, $mailBody, $HTMLEmail);
  }
}

function DisplayPage($Template, $ProdId, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ProdExtra, $nd)
{
  global $manualorder, $Affiliate, $Shareasale, $Idevaffiliate, $totalaffiliate, $Jamaffiliate; 
  global $SellerCompany, $SellerEmail, $SellerURL, $HTMLEmail, $llcharset;
  
  
  if ($Template!="")
  {
    $ext = fileextension($Template);  
    if ($ext == ".php")
    {
      ob_start();
      include $Template;
      $page = ob_get_contents(); 
      ob_end_clean(); 
    }
    else
    {
      if (!($fh = fopen($Template, "r")))
        return(0);
      $page = fread ($fh, 200000);
      fclose($fh);
    }
  }
  else
  {
    $page="";
    $page.="<html>\n";
    $page.="<head>\n";
    $page.="<meta http-equiv=\"content-type\" content=\"text/html; charset=".$llcharset."\">\n";
    $page.="<title>Thank you for your order</title>\n";
    $page.="</head>\n";
    $page.="<body>\n";
    $page.="Thank you for your order. Your transaction has been completed, and a receipt for your<br>\npurchase has been emailed to you from Paypal. For reference your order number is #order_number#.<br>\n";
    $page.="<!--knownstart-->\n";
    $page.="<br>\n";
    $page.="Please use the links below to download your purchase.<br>\n";
    $page.="<br>\n";
    $page.="<!--eachproductstart-->\n";
    $page.="#product#<br>\n";
    $page.="<br>\n";
    $page.="<!--eachproductend-->\n";
    $page.="These links have also been emailed to you at #email#.<br>\n";
    $page.="<!--knownend-->\n";
    $page.="<!--unknownstart-->\n";
    $page.="<br>\n";
    $page.="You have ordered items that are not downloadable. Your order will be processed as quickly as possible.<br>\n";
    $page.="<!--unknownend-->\n";
    $page.="<br>\n";
    $page.="If you have any questions regarding this order please contact us.<br>\n";
    $page.="<br>\n";
    $page.=$SellerCompany."<br>\n";
    $page.="<a href=\"".$SellerURL."\">".$SellerURL."</a><br>\n";    
    $page.="<a href=\"mailto:".$SellerEmail."\">".$SellerEmail."</a><br>\n";
    // Now output affiliate code if not manual order
    if ($manualorder == false)
    {
      if ($Affiliate != "")
      {
        $page.= "#affiliate#\n";
      }
      if ($Shareasale != "")
      {
        $page.= "#shareasale#\n";
      }
      if ($Idevaffiliate != "")
      {
        $page.= "#idevaffiliate#\n";
      }
      if ($Jamaffiliate != "")
      {
        $page.= "#jamaffiliate#\n";
      }
    }        
    $page.="</body>\n";
    $page.="</html>\n";
  }
  PageTemplateProcess($page, $ProdId, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ProdExtra, $nd);  
}

function DisplayFraudPage($Template, $ProdId, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ProdExtra, $nd)
{
  global $manualorder, $Affiliate, $Shareasale, $Idevaffiliate, $totalaffiliate, $Jamaffiliate; 
  global $SellerCompany, $SellerEmail, $SellerURL, $HTMLEmail, $llcharset;
  if ($Template!="")
  {
    $ext = fileextension($Template);  
    if ($ext == ".php")
    {
      ob_start();
      include $Template;
      $page = ob_get_contents(); 
      ob_end_clean();    
    }
    else
    {
      if (!($fh = @fopen($Template, "r")))
        return(0);
      $page = fread ($fh, 200000);
      fclose($fh);
    }
  }
  else
  {
    $page="";
    $page.="<html>\n";
    $page.="<head>\n";
    $page.="<meta http-equiv=\"content-type\" content=\"text/html; charset=".$llcharset."\">\n";
    $page.="<title>Thank you for your order</title>\n";
    $page.="</head>\n";
    $page.="<body>\n";
    $page.="Thank you for your order. For reference your order number is #order_number#.<br>\n";
    $page.="<br>\n";
    $page.="<!--knownstart-->\n";
    $page.="Your order will be completed when payment clears in our Paypal account.<br>\n";
    $page.="<br>\n";    
    $page.="<!--knownend-->\n";    
    $page.="<!--unknownstart-->\n";
    $page.="You have ordered items that are not downloadable. Your order will be processed as quickly as possible.<br>\n";
    $page.="<br>\n";    
    $page.="<!--unknownend-->\n";
    $page.="If you have any questions regarding this order please contact us.<br>\n";
    $page.="<br>\n";
    $page.=$SellerCompany."<br>\n";
    $page.="<a href=\"".$SellerURL."\">".$SellerURL."</a><br>\n";    
    $page.="<a href=\"mailto:".$SellerEmail."\">".$SellerEmail."</a><br>\n";
    // Now output affiliate code if not manual order
    if ($manualorder == false)
    {
      if ($Affiliate != "")
      {
        $page.= "#affiliate#\n";
      }
      if ($Shareasale != "")
      {
        $page.= "#shareasale#\n";
      }
      if ($Idevaffiliate != "")
      {
        $page.= "#idevaffiliate#\n";
      }
      if ($Jamaffiliate != "")
      {
        $page.= "#jamaffiliate#\n";
      }
    }        
    $page.="</body>\n";
    $page.="</html>\n";
  }
  PageTemplateProcess($page, $ProdId, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ProdExtra, $nd);  
}

function PageTemplateProcess($page, $ProdId, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ProdExtra, $nd)
{
  global $UnknownDsegment, $Affiliate;
  // Create Affiliate string if required
  if ($Affiliate != "")
    InsertVariables($Affiliate);
  // Insert #unknownsegment# variable)
  InsertUsegment($page, $UnknownDsegment, $nd);
  // Replace all non product related variables
  InsertVariables($page);
  // Insert poduct variables
  InsertProductVariables($page, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, ".html");
  // Insert item loop variables
  InsertItemLoopVariables($page);
  // Insert variables and repeat block for #eachproductstart#
  InsertLoopVariables($page, $ProdId, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ProdExtra, "DSEGMENT", ".html");
  // Handle any <!--unknownstart--> <!--unknownend--> section
  InsertUnknownSection($page, $nd);
  // Handle any <!--knownstart--> <!--knownend--> section
  InsertKnownSection($page,count($ProdDesc));  
  print $page;
}

function SendNotifyEmail($Template, $Emailadr)
{
  global $EmailHeaderNoSlashR, $SellerCompany, $SellerEmail, $ExtraMailParam;
  if (($Template == "") || ($Emailadr == ""))
    return;
  $ext = fileextension($Template);
  if ($ext == ".php")
  {
    ob_start();
    include $Template;
    $mailBody = ob_get_contents(); 
    ob_end_clean();    
  }
  else
  {
    if (!($fh = @fopen($Template, "r")))
      return;
    $mailBody = fread ($fh, 200000);
    fclose($fh);
  }      
  // Replace all non product related variables
  InsertVariables($mailBody);
  // Insert item loop variables
  InsertItemLoopVariables($mailBody);
  // Get subject for email
  if ($ext == ".txt")
  {
    $pos = strpos($mailBody, "\n");
    $subject = substr($mailBody, 0, $pos);
    $mailBody = substr($mailBody, $pos + 1, strlen($mailBody) - $pos-1);
  }
  else
  {
    $subject = "Order Notification";
    $pos = strpos($mailBody, "<TITLE>");
    if (!is_integer($pos))
      $pos = strpos($mailBody, "<title>");
    $pos2 = strpos($mailBody, "</TITLE>");
    if (!is_integer($pos2))
      $pos2 = strpos($mailBody, "</title>");
    if ((is_integer($pos)) && (is_integer($pos2)))
    {
      $subject = substr($mailBody, $pos + 7, $pos2 - $pos-7);
    }
  }
  if ($ext != ".txt")
    $mailBody = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD W3 HTML//EN\">\n" . $mailBody;
  if ($ext != ".txt")
    SendEmailOut($Emailadr, $SellerEmail, $SellerCompany, $subject, $mailBody, "Y");
  else
    SendEmailOut($Emailadr, $SellerEmail, $SellerCompany, $subject, $mailBody, "N");
  // Send copy of email if being sent to client
  global $CopyEmail,$NotifyEmail;
  if (($CopyEmail!="") && ($Emailadr!=$CopyEmail) && ($Emailadr!=$NotifyEmail))
  {
    if ($ext != ".txt")
      SendEmailOut($CopyEmail, $SellerEmail, $SellerCompany, $subject, $mailBody, "Y");
    else
      SendEmailOut($CopyEmail, $SellerEmail, $SellerCompany, $subject, $mailBody, "N");
  } 
}

function InsertVariables(&$buf)
{
  global $payer_email, $invoice, $memo, $mc_gross, $txn_id, $first_name, $last_name, $payer_email, $payer_id;
  global $address_name, $address_street, $address_city, $address_state, $address_zip, $address_country, $option_name1, $option_selection1, $mc_currency;
  global $option_name2, $option_selection2, $custom, $tax, $num_cart_items, $mc_fee, $payer_business_name, $payment_date, $address_country_code, $clientipaddr;
  global $manualorder, $Affiliate, $Shareasale, $Idevaffiliate, $totalaffiliate, $payer_status, $address_status, $auction_buyer_id, $Jamaffiliate;
  global $mc_shipping, $shipping_method,$discount,$contact_phone,$clientipinfo, $manual_message;
  global $telephone, $custom1, $custom2, $custom3, $custom4;
  
  // If order tax is set then calculate net total and tax percentage
  if (($tax!="") && ($mc_gross>0))
  {
    $totalnet=$mc_gross-$tax;
    $taxrate=($tax/$totalnet)*100;
    $taxrate = sprintf("%01.2f", $taxrate);
  }
  else
  {
    $totalnet=$mc_gross;
    $taxrate=0;    
  }
  
  if(isset($contact_phone))
  	$telephone = $contact_phone;
  
  
  // Remove slashes from data
  if (pl_get_magic_quotes_gpc())
  {
    $memo=stripslashes($memo);          
    $first_name=stripslashes($first_name);          
    $last_name=stripslashes($last_name);          
    $address_name=stripslashes($address_name);          
    $payer_business_name=stripslashes($payer_business_name);          
    $address_street=stripslashes($address_street);          
    $address_city=stripslashes($address_city);          
    $address_state=stripslashes($address_state);          
    $address_country=stripslashes($address_country);          
  }
  $buf = str_replace("#invoice#", $invoice, $buf);
  $buf = str_replace("#merchant_order_id#", $invoice, $buf);
  $buf = str_replace("#memo#", $memo, $buf);
  $buf = str_replace("#mc_gross#", $mc_gross, $buf);
  $buf = str_replace("#total#", $mc_gross, $buf);
  $buf = str_replace("#totalnet#", $totalnet, $buf);
  $buf = str_replace("#taxrate#", $taxrate, $buf);
  $buf = str_replace("#totalaffiliate#", $totalaffiliate, $buf);
  $buf = str_replace("#txn_id#", $txn_id, $buf);
  $buf = str_replace("#order_number#", $txn_id, $buf);
  $buf = str_replace("#ordernumber#", $txn_id, $buf);
  $buf = str_replace("#orderno#", $txn_id, $buf);
  $buf = str_replace("#first_name#", $first_name, $buf);
  $buf = str_replace("#last_name#", $last_name, $buf);
  if (($first_name == "") && ($last_name = ""))
    $buf = str_replace("#name#", $payer_business_name, $buf);
  else
    $buf = str_replace("#name#", $first_name . " " . $last_name, $buf);
  $buf = str_replace("#payer_business_name#", $payer_business_name, $buf);
  $buf = str_replace("#payer_email#", $payer_email, $buf);
  $buf = str_replace("#email#", $payer_email, $buf);
  $buf = str_replace("#payer_id#", $payer_id, $buf);
  $buf = str_replace("#address_name#", $address_name, $buf);
  $buf = str_replace("#address_street#", $address_street, $buf);
  $buf = str_replace("#address_city#", $address_city, $buf);
  $buf = str_replace("#address_state#", $address_state, $buf);
  $buf = str_replace("#address_zip#", $address_zip, $buf);
  $buf = str_replace("#address_country#", $address_country, $buf);
  $buf = str_replace("#address_country_code#", $address_country_code, $buf);
  $buf = str_replace("#option_name1#", $option_name1, $buf);
  $buf = str_replace("#option_selection1#", $option_selection1, $buf);
  $buf = str_replace("#option_name2#", $option_name2, $buf);
  $buf = str_replace("#option_selection2#", $option_selection2, $buf);
  $buf = str_replace("#mc_currency#", $mc_currency, $buf);
  $buf = str_replace("#date#", date("j F Y"), $buf); // Output date like 24 January 2004
  $buf = str_replace("#payment_date#", $payment_date, $buf);
  $buf = str_replace("#custom#", $custom, $buf);
  $buf = str_replace("#tax#", $tax, $buf);
  $buf = str_replace("#num_cart_items#", $num_cart_items, $buf);
  $buf = str_replace("#fee#", $mc_fee, $buf);
  $buf = str_replace("#mc_fee#", $mc_fee, $buf);
  $buf = str_replace("#settle_amount#", $settle_amount, $buf);
  $buf = str_replace("#settle_currency#", $settle_currency, $buf);
  $buf = str_replace("#auction_buyer_id#", $auction_buyer_id, $buf);
  $buf = str_replace("#auction_closing_date#", $auction_closing_date, $buf);
  $buf = str_replace("#payer_status#", $payer_status, $buf);
  $buf = str_replace("#address_status#", $address_status, $buf);
  $buf = str_replace("#ipaddr#", $clientipaddr, $buf);
  $buf = str_replace("#ipcountrycode#", $clientipinfo['countrycode'], $buf);
  $buf = str_replace("#ipcountryname#", $clientipinfo['countryname'], $buf);
  $buf = str_replace("#ipcontinentcode#", $clientipinfo['continentcode'], $buf);
  $buf = str_replace("#ipcontinentname#", $clientipinfo['continentname'], $buf);
  $buf = str_replace("#shipping#", $mc_shipping, $buf);
  $buf = str_replace("#shipping_method#", $shipping_method, $buf);
  if($manualorder == true && isset($manual_message))
  	$buf = str_replace("#message#", $manual_message, $buf);
  if (isset($discount))
    $buf = str_replace("#discount#", $discount, $buf);
  else
    $buf = str_replace("#discount#", "0.00", $buf);
        
  $buf = str_replace("#telephone#", $telephone, $buf);
  $buf = str_replace("#custom1#", $custom1, $buf);
  $buf = str_replace("#custom2#", $custom2, $buf);
  $buf = str_replace("#custom3#", $custom3, $buf);
  $buf = str_replace("#custom4#", $custom4, $buf);
 }


function InsertProductVariables(&$buf, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ext)
{
  global $numberofproducts, $HTMLEmail, $manualorder, $newexpiry, $txn_id, $manualiplevel, $clientipaddr, $IPlock;
  global $calledasreturn, $payment_date, $payer_email;
  $max = 30;
//  if ($numberofproducts > $max)
//    $max = $numberofproducts;
  // First deal with any #link_n# that is part of hyperlink
  $start = 0;
  do
  {
    $pos = strpos($buf, "<a", $start);
    if (!is_integer($pos))
      $pos = strpos($buf, "<A", $start);
    $pos2 = strpos($buf, "</a>", $pos);
    if (!is_integer($pos2))
      $pos2 = strpos($buf, "</A>", $pos);
    $found = 0;
    if ((is_integer($pos)) && (is_integer($pos2)))
    {
      $found = 1;
      for ($k = 1; $k <= $max; $k++)
      {
        if (isset($ProdLink[$k-1]) && $ProdLink[$k-1] == "")
        {
          // See if #link_k# is within the hyperlink
          $hl = substr($buf, $pos, $pos2 - $pos);
          $pos3 = strpos($hl, "#link_" . $k . "#");
          if (!is_integer($pos3))
            $pos3 = strpos($hl, "#link_" . $k . "#");
          if (is_integer($pos3))
          {
            $start = $pos;
            $buf = substr_replace($buf, "", $pos, $pos2 - $pos);
            break;
          }
          else
            $start = $pos2;
        }
        else
          $start = $pos2;
      }
    }
  }
  while ($found == 1);
  // Now replace all other variables
  for ($k = 1; $k <= $max; $k++)
  {
    if (isset($ProdDesc[$k-1]) && $ProdDesc[$k-1] != "")
    {
      $buf = str_replace("#description_" . $k . "#", $ProdDesc[$k-1], $buf);
      $buf = str_replace("#filename_" . $k . "#", $ProdFile[$k-1], $buf);
      $buf = str_replace("#link_" . $k . "#", $ProdLink[$k-1], $buf);
      $buf = str_replace("#size_" . $k . "#", FriendlyFileSize($ProdSize[$k-1]), $buf);
      $buf = str_replace("#expires_" . $k . "#", FriendlyExpiryTime($ProdExp[$k-1]), $buf);
      if (($calledasreturn==1) && (isset($payment_date)))
        $buf = str_replace("#expiresat_" . $k . "#", date("d F Y G:i", strtotime($payment_date) + ($ProdExp[$k-1] * 60)), $buf);                    
      else
        $buf = str_replace("#expiresat_" . $k . "#", date("d F Y G:i", time() + ($ProdExp[$k-1] * 60)), $buf);
      if (($HTMLEmail == "Y") || ($ext != ".txt"))
      {
        $tot = "To download " . $ProdDesc[$k-1] . " click the link below:<BR>";
        $tot .= "<a href=\"" . $ProdLink[$k-1] . "\">" . $ProdFile[$k-1] . "</a>";
        if ($ProdSize[$k-1] != "0")
          $tot .= " (" . FriendlyFileSize($ProdSize[$k-1]) . ")";
        if ($ProdExp[$k-1] != "0")
          $tot .= " ~ Download link will expire in " . FriendlyExpiryTime($ProdExp[$k-1]);
      }
      else
      {
        $tot = "To download " . $ProdDesc[$k-1] . " click the link below:\n" . $ProdLink[$k-1] . " \n";
        $tot .= $ProdFile[$k-1];
        if ($ProdSize[$k-1] != "0")
          $tot .= " (" . FriendlyFileSize($ProdSize[$k-1]) . ")";
        if ($ProdExp[$k-1] != "0")
          $tot .= " ~ Download link will expire in " . FriendlyExpiryTime($ProdExp[$k-1]);
      }
      $buf = str_replace("#product_" . $k . "#", $tot, $buf);
    }
    else
    {
      $buf = str_replace("#description_" . $k . "#", "", $buf);
      $buf = str_replace("#filename_" . $k . "#", "", $buf);
      $buf = str_replace("#size_" . $k . "#", "", $buf);
      $buf = str_replace("#expires_" . $k . "#", "", $buf);
      $buf = str_replace("#expiresat_" . $k . "#", "", $buf);
      $buf = str_replace("#product_" . $k . "#", "", $buf);
      $buf = str_replace("#link_" . $k . "#", "", $buf);
    }
  }
  // Handle any #description(id)# variable
  $itemids = getitemvars($buf, "description");
  if ($itemids!="")
  {  
    $items = explode(",", $itemids);
    for ($k = 0;$k < count($items);$k++)
    {
      $j = GetProductDetails($items[$k], $paycurr, $cost, $desc, $link, $size, $exp, $extra);
      if ($j != 0)
        $buf = str_replace("#description(" . $items[$k] . ")#", $desc, $buf);
      else
        $buf = str_replace("#description(" . $items[$k] . ")#", "", $buf);
    }
  }
  // Handle any #expires(id)# variable
  $itemids = getitemvars($buf, "expires");
  if ($itemids!="")
  {
    $items = explode(",", $itemids);
    for ($k = 0;$k < count($items);$k++)
    {
      $j = GetProductDetails($items[$k], $paycurr, $cost, $desc, $link, $size, $exp, $extra);
      if ($j != 0)
      {
        if (($manualorder == true) && ($newexpiry != -1))
          $exp = $newexpiry;
        if ($exp != 0)
        {
          if (strlen($exp) == 12)
          {
            $expiry = mktime(substr($exp, 8, 2), substr($exp, 10, 2), 0, substr($exp, 4, 2), substr($exp, 6, 2), substr($exp, 0, 4), -1);
            if (($calledasreturn==1) && (isset($payment_date)))              
              $exp = ($expiry - strtotime($payment_date)) / 60;
            else         
              $exp = ($expiry - time()) / 60;
          }
        }
        $buf = str_replace("#expires(" . $items[$k] . ")#", FriendlyExpiryTime($exp), $buf);
      }
      else
        $buf = str_replace("#expires(" . $items[$k] . ")#", "", $buf);
    }
  }
  // Handle any #expiresat(id)# variable
  $itemids = getitemvars($buf, "expiresat");
  if ($itemids!="")
  {
    $items = explode(",", $itemids);
    for ($k = 0;$k < count($items);$k++)
    {
      $j = GetProductDetails($items[$k], $paycurr, $cost, $desc, $link, $size, $exp, $extra);
      if ($j != 0)
      {
        if (($manualorder == true) && ($newexpiry != -1))
          $exp = $newexpiry;
        if ($exp != 0)
        {
          if (strlen($exp) == 12)
          {
            $expiry = mktime(substr($exp, 8, 2), substr($exp, 10, 2), 0, substr($exp, 4, 2), substr($exp, 6, 2), substr($exp, 0, 4), -1);
            if (($calledasreturn==1) && (isset($payment_date)))              
              $exp = ($expiry - strtotime($payment_date)) / 60;
            else
              $exp = ($expiry - time()) / 60;
          }
        }
        if (($calledasreturn==1) && (isset($payment_date)))                    
          $buf = str_replace("#expiresat(" . $items[$k] . ")#", date("d F Y G:i", strtotime($payment_date) + ($exp * 60)), $buf);
        else  
          $buf = str_replace("#expiresat(" . $items[$k] . ")#", date("d F Y G:i", time() + ($exp * 60)), $buf);
      }
      else
        $buf = str_replace("#expiresat(" . $items[$k] . ")#", "", $buf);
    }
  }
  // Handle any #filename(id)# variable
  $itemids = getitemvars($buf, "filename");
  if ($itemids!="")
  {
    $items = explode(",", $itemids);
    for ($k = 0;$k < count($items);$k++)
    {
      $j = GetProductDetails($items[$k], $paycurr, $cost, $desc, $link, $size, $exp, $extra);
      if (($j != 0) && ($link != "NA"))
        $buf = str_replace("#filename(" . $items[$k] . ")#", filename($link), $buf);
      else
        $buf = str_replace("#filename(" . $items[$k] . ")#", "", $buf);
    }
  }
  // Handle any #size(id)# variable
  $itemids = getitemvars($buf, "size");
  if ($itemids!="")
  {
    $items = explode(",", $itemids);
    for ($k = 0;$k < count($items);$k++)
    {
      $j = GetProductDetails($items[$k], $paycurr, $cost, $desc, $link, $size, $exp, $extra);
      if (($j != 0) && ($link != "NA"))
        $buf = str_replace("#size(" . $items[$k] . ")#", FriendlyFileSize($size), $buf);
      else
        $buf = str_replace("#size(" . $items[$k] . ")#", "", $buf);
    }
  }
  // Handle any #link(id)# variable
  $itemids = getitemvars($buf, "link");
  if ($itemids!="")
  {
    $items = explode(",", $itemids);
    for ($k = 0;$k < count($items);$k++)
    {
      $j = GetProductDetails($items[$k], $paycurr, $cost, $desc, $link, $size, $exp, $extra);
      if (($j != 0) && ($link != "NA"))
      {
        if (($manualorder == true) && ($newexpiry != -1))
          $exp = $newexpiry;
        if ($exp != 0)
        {
          if (strlen($exp) == 12)
          {
            $expiry = mktime(substr($exp, 8, 2), substr($exp, 10, 2), 0, substr($exp, 4, 2), substr($exp, 6, 2), substr($exp, 0, 4), -1);
            if (($calledasreturn==1) && (isset($payment_date)))              
              $exp = ($expiry - strtotime($payment_date)) / 60;
            else
              $exp = ($expiry - time()) / 60;          
          }
          else
          {
            if (($calledasreturn==1) && (isset($payment_date)))
              $expiry = strtotime($payment_date) + ($exp * 60);
            else                               
              $expiry = time() + ($exp * 60);
          }
        }
        else
          $expiry = 0;
        $ipleveltouse = 0;
        if (isset($IPlock))
          $ipleveltouse = $IPlock;
        if (($manualorder == true) && ($manualiplevel != "-1"))
          $ipleveltouse = $manualiplevel;
        else
        {
          $pos = strpos($extra, "IPLOCK=");
          if (is_integer($pos))
            $ipleveltouse = substr($extra, $pos + 7, 1);
        }
        $plink = GetSecureLink($link, $items[$k], $expiry, $txn_id, $clientipaddr, $ipleveltouse, $payer_email);
        $buf = str_replace("#link(" . $items[$k] . ")#", $plink, $buf);
      }
      else
        $buf = str_replace("#link(" . $items[$k] . ")#", "", $buf);
    }
  }
}

function InsertLoopVariables(&$buffer, $ProdId, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ProdExtra, $temptype, $ext)
{
  global $option_name1, $option_selection1, $option_name2, $option_selection2, $Dsegment, $Esegment, $HTMLEmail;
  global $payer_email, $first_name, $last_name, $payer_business_name;
  global $manualorder, $txn_id, $DbNamePayloom, $DbTableNameOrders, $mysql_payloom;
  global $DbHostPayloom, $DbUserPayloom, $DbPasswordPayloom, $DbNamePayloom;
  global $custom,$txn_id;

          
  // See if serial number, software passport, clicklocker or userfunction return value already stored
  if (count($ProdId)>0)
  {
    if ($DbTableNameOrders!="")
    {
      $query="SELECT * FROM ".$DbTableNameOrders." WHERE orderno=".pl_quote_smart(trim($txn_id));
      $mysql_result=pl_mysql_query($query,$mysql_payloom);
      if ($row=pl_mysql_fetch_array_assoc($mysql_result))
      {
        $d = $row['serialnumber'];
        $sernoarray=explode("|",$d);
        $d = $row['softwarepassportname'];
        $spnamearray=explode("|",$d);
        $d = $row['softwarepassportkey'];
        $spkeyarray=explode("|",$d);
        $d = $row['userfunction'];
        $userfuncarray=explode("|",$d);        
        $d = $row['clicklocker'];
        $clicklockerarray=explode("|",$d);        
      }
    }
    if (count($sernoarray)!=count($ProdId))
      $sernoarray=array_fill(0,count($ProdId),"");
    if (count($spnamearray)!=count($ProdId))
      $spnamearray=array_fill(0,count($ProdId),"");
    if (count($spkeyarray)!=count($ProdId))
      $spkeyarray=array_fill(0,count($ProdId),"");
    if (count($userfuncarray)!=count($ProdId))
      $userfuncarray=array_fill(0,count($ProdId),"");
    if (count($clicklockerarray)!=count($ProdId))
      $clicklockerarray=array_fill(0,count($ProdId),"");
  }  
  do
  {
    $found = 0;
    $pos = strpos($buffer, "<!--eachproductstart-->");
    $pos2 = strpos($buffer, "<!--eachproductend-->");
    if ((is_integer($pos)) && (is_integer($pos2)))
    {
      $found = 1;
      $buf = substr($buffer, $pos + 23, $pos2 - $pos-23);
      // Now remove this section
      $buffer1 = substr($buffer, 0, $pos);
      $buffer2 = substr($buffer, $pos2 + 21, strlen($buffer) - $pos2-21);
      $buffer = $buffer1;
      for ($k = 1; $k <= count($ProdLink); $k++)
      {
        $repeatbuf=$buf;
        ProcessProductVariables($repeatbuf, $k, $ProdId, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ProdExtra, $temptype, $ext);
        $buffer.=$repeatbuf;
      }
      $buffer .= $buffer2;
    }
  }
  while ($found == 1);
  // Now replace any loop variables outside of the loop (assume first product ordered)
  // If this product already handled then make sure details stored in $loitemdataarray are not altered
  $tmploitemdata="";
  if ($loitemdataarray[0]!="")
    $tmploitemdata=$loitemdataarray[0];
  if (count($ProdId)>0)
    ProcessProductVariables ($buffer, 1, $ProdId, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ProdExtra, $temptype, $ext);  

                    
  // Store any serial numbers etc
  if (($DbTableNameOrders!="") && (count($ProdId)>0))
  {
    $Query = "UPDATE " . $DbTableNameOrders . " SET serialnumber=".pl_quote_smart(implode($sernoarray,"|")).", softwarepassportname=".pl_quote_smart(implode($spnamearray,"|")).", softwarepassportkey=".pl_quote_smart(implode($spkeyarray,"|")).", userfunction=".pl_quote_smart(implode($userfuncarray,"|")).", clicklocker=".pl_quote_smart(implode($clicklockerarray,"|"))." WHERE orderno=" . pl_quote_smart($txn_id);
    $mysql_result = pl_mysql_query($Query, $mysql_payloom); 
  }  

}

function ProcessProductVariables(&$repeatbuf, $k, $ProdId, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ProdExtra, $temptype, $ext)
{
  global $option_name1, $option_selection1, $option_name2, $option_selection2, $Dsegment, $Esegment, $HTMLEmail;
  global $payer_email, $first_name, $last_name, $payer_business_name, $Custom11Field,$custom;
  global $calledasreturn, $payment_date;
  global $DbNamePayloom, $DbTableNameOrders, $mysql_payloom;
  global $DbHostPayloom, $DbUserPayloom, $DbPasswordPayloom, $DbNamePayloom;  


  // Get default segment
  $segment = "";
  if ($temptype == "DSEGMENT")
  {
    $defseg = $Dsegment;
  }
  else
  {
    $defseg = $Esegment;
  }  
  if ($defseg != "")
  {
    if (($fh = @fopen($defseg, "r")))
    {
      $segment = fread ($fh, 100000);
      fclose($fh);
    }
  }
  // See if product segment
  if ($ProdExtra[$k-1] != "")
  {
    $extrasettings = explode("*", $ProdExtra[$k-1]);
    for ($j = 0;$j < count($extrasettings);$j++)
    {
      $command = explode("=", $extrasettings[$j],2);
      if (strtoupper($command[0]) == $temptype)
      {
        if ($command[1] != "")
        {
          if (($fh = @fopen($command[1], "r")))
          {
            $segment = fread ($fh, 100000);
            fclose($fh);
          }
        }
      }
    }
  }
  if ($segment!="")
  {
    // Insert standard variables into segment
    InsertVariables($segment);
    InsertProductVariables($segment, $ProdDesc, $ProdLink, $ProdSize, $ProdExp, $ProdFile, $ext);
  }
  $repeatbuf = str_replace("#segment#", $segment, $repeatbuf);
  $repeatbuf = str_replace("#item_number#", $ProdId[$k-1], $repeatbuf);
  $repeatbuf = str_replace("#description#", $ProdDesc[$k-1], $repeatbuf);
  $repeatbuf = str_replace("#filename#", $ProdFile[$k-1], $repeatbuf);
  $repeatbuf = str_replace("#link#", $ProdLink[$k-1], $repeatbuf);
  $repeatbuf = str_replace("#size#", FriendlyFileSize($ProdSize[$k-1]), $repeatbuf);
  $repeatbuf = str_replace("#expires#", FriendlyExpiryTime($ProdExp[$k-1]), $repeatbuf);
  $repeatbuf = str_replace("#itemposition#", $k, $repeatbuf);
  if (($calledasreturn==1) && (isset($payment_date)))                
    $repeatbuf = str_replace("#expiresat#", date("d F Y G:i", strtotime($payment_date) + ($ProdExp[$k-1]) * 60), $repeatbuf);
  else  
    $repeatbuf = str_replace("#expiresat#", date("d F Y G:i", time() + ($ProdExp[$k-1]) * 60), $repeatbuf);
  if (($HTMLEmail == "Y") || ($ext != ".txt"))
  {
    if (($ProdLink[$k-1]=="NA") || ($ProdLink[$k-1]=="NA"))
    {
      $tot=$ProdDesc[$k-1];
    }
    else
    {
      $tot = "To download " . $ProdDesc[$k-1] . " click the link below:<BR>";
      $tot .= "<a href=\"" . $ProdLink[$k-1] . "\">" . $ProdFile[$k-1] . "</a>";
      if ($ProdSize[$k-1] != "0")
        $tot .= " (" . FriendlyFileSize($ProdSize[$k-1]) . ")";
      if ($ProdExp[$k-1] != "0")
        $tot .= " ~ Download link will expire in " . FriendlyExpiryTime($ProdExp[$k-1]);
    }  
  }
  else
  {
    if (($ProdLink[$k-1]=="NA") || ($ProdLink[$k-1]=="NA"))
    {
      $tot=$ProdDesc[$k-1];
    }
    else
    {
      $tot = "To download " . $ProdDesc[$k-1] . " click the link below:\n" . $ProdLink[$k-1] . " \n";
      $tot .= $ProdFile[$k-1];
      if ($ProdSize[$k-1] != "0")
        $tot .= " (" . FriendlyFileSize($ProdSize[$k-1]) . ")";
      if ($ProdExp[$k-1] != "0")
        $tot .= " ~ Download link will expire in " . FriendlyExpiryTime($ProdExp[$k-1]);
    }    
  }
  // If link was NA (now blank) then set to blank
  if ($ProdLink[$k-1]=="")
    $tot="";
  $repeatbuf = str_replace("#product#", $tot, $repeatbuf);
  
   
  // See if USERNAME, PASSWORD, USER_FUNCTION, SERIAL_NO_LIST, SOFTWARE_PASSPORT or NOTE defined in extras
/*
  if ($ProdExtra[$k-1] != "")
  {
    // Some variables should only be processed if actually used in the template
    $serialnumberused = strpos(strtolower($repeatbuf), "#serialnumber#");
    $userfunctionused = strpos(strtolower($repeatbuf), "#userfunction#");
    $softwarepassportused=strpos(strtolower($repeatbuf),"#softwarepassportkey#");
    $clicklockerused=strpos(strtolower($repeatbuf),"#clicklocker#");
    $callurlused=strpos(strtolower($repeatbuf),"#callurl#");
    $callurldataused=strpos(strtolower($repeatbuf),"#callurldata#");      
    $extrasettings = explode("*", $ProdExtra[$k-1]);
    for ($j = 0;$j < count($extrasettings);$j++)
    {
      $command = explode("=", $extrasettings[$j],2);
      if (strtoupper($command[0]) == "USERNAME")
      {
        $repeatbuf = str_replace("#username#", $command[1], $repeatbuf);
        $loitemdataarray[$k-1].=",USERNAME=".$command[1];    
      }  
      if (strtoupper($command[0]) == "PASSWORD")
      {
        $repeatbuf = str_replace("#password#", $command[1], $repeatbuf);
        $loitemdataarray[$k-1].=",PASSWORD=".$command[1];    
      }  
      if (strtoupper($command[0]) == "NOTE")
      {
        $repeatbuf = str_replace("#note#", $command[1], $repeatbuf);
        $loitemdataarray[$k-1].=",NOTE=".$command[1];    
      }  
      if ((strtoupper($command[0]) == "SERIAL_NO_LIST") && (is_integer($serialnumberused)))
      {
        if ($sernoarray[$k-1]!="")
          $serialnumber=$sernoarray[$k-1];
        else
        {        
          $serialnumber = GetSerialNumber($command[1]);
          $sernoarray[$k-1]=$serialnumber;
        }  
        $repeatbuf = str_replace("#serialnumber#", $serialnumber, $repeatbuf);
        $loitemdataarray[$k-1].=",SERIALNO=".$serialnumber;    
      }
      if ((strtoupper($command[0]) == "USER_FUNCTION") && (is_integer($userfunctionused)))
      {
        if ($userfuncarray[$k-1]!="")
          $ufd=$userfuncarray[$k-1];
        else
        {  
          $ufd = userfunction($command[1], $option_name1, $option_selection1, $option_name2, $option_selection2);
          $userfuncarray[$k-1]=$ufd;
        }
        $repeatbuf = str_replace("#userfunction#", $ufd, $repeatbuf);
        $loitemdataarray[$k-1].=",USERFUNCTION=".$ufd;            
      }
      if ((strtoupper($command[0]) == "SOFTWARE_PASSPORT") && (is_integer($softwarepassportused)))
      {
        if (($spkeyarray[$k-1]!="") && ($spnamearray[$k-1]!=""))
        {
          $spname=$spnamearray[$k-1];
          $spkey=$spkeyarray[$k-1];
        }  
        else        
        {
          $spd = softwarepassport($command[1], $option_selection1, $option_selection2);
          $spdarray = explode("|", $spd);
          $spname=$spdarray[0];
          $spkey=$spdarray[1];
          $spnamearray[$k-1]=$spname;
          $spkeyarray[$k-1]=$spkey;
        }
        $repeatbuf = str_replace("#softwarepassportname#", $spname, $repeatbuf);
        $repeatbuf = str_replace("#softwarepassportkey#", $spkey, $repeatbuf);
        $loitemdataarray[$k-1].=",SOFTWAREPASSPORTNAME=".$spname;    
        $loitemdataarray[$k-1].=",SOFTWAREPASSPORTKEY=".$spkey;
      }
      if ((strtoupper($command[0]) == "CLICKLOCKER") && (is_integer($clicklockerused)))
      {
        if ($clicklockerarray[$k-1]!="")
          $activation=$clicklockerarray[$k-1];
        else
        {
          if ($payer_business_name != "")
            $nametouse = $payer_business_name;
          else
            $nametouse = $first_name . " " . $last_name;
          $activation = ClickLocker($command[1], $nametouse, $payer_email);
          $clicklockerarray[$k-1]=$activation;
        }
        $repeatbuf = str_replace("#clicklocker#", $activation, $repeatbuf);
        $loitemdataarray[$k-1].=",CLICKLOCKER=".$activation;            
      }
      if ((strtoupper($command[0]) == "CALLURL") && (is_integer($callurlused)))
      {
        $callurlret=callurl($command[1]);
        $repeatbuf = str_replace("#callurl#", "", $repeatbuf);
      }
      if ((strtoupper($command[0]) == "CALLURLDATA") && (is_integer($callurldataused)))
      {
        $callurlret=callurl($command[1]);
        $repeatbuf = str_replace("#callurldata#", $callurlret, $repeatbuf);
        $callurlretclean=str_replace(","," ",$callurlret);
        $callurlretclean=str_replace("\n"," ",$callurlretclean);
        $loitemdataarray[$k-1].=",CALLURLDATA=".$callurlretclean;            
      }
      if (strtoupper($command[0]) == "ACROLOK")
      {
        $acrolokret=acrolok($ProdFile[$k-1],$payer_email,$command[1]);
        $repeatbuf = str_replace("#acrolok#", $acrolokret, $repeatbuf);
        $loitemdataarray[$k-1].=",ACROLOK=".$acrolokret;            
      }                    

    }

  }
*/

  // Clear any remaining template variables
  $repeatbuf = str_replace("#note#", "", $repeatbuf);
  $repeatbuf = str_replace("#itemposition#", "", $repeatbuf); 
   
}


function InsertItemLoopVariables(&$buffer)
{
  global $num_cart_items, $num, $manualorder, $notPayPal;
  // If order tax is set then calculate tax rate
  if (($GLOBALS['tax']!="") && ($GLOBALS['mc_gross']>0))
  {
    $totalnet=$GLOBALS['mc_gross']-$GLOBALS['tax'];
    $taxrate=($GLOBALS['tax']/$totalnet)*100;
    $taxrate = sprintf("%01.2f", $taxrate);
  }
  else
  {
    $totalnet=$mc_gross;
    $taxrate=0;    
  }  
  do
  {
    $found = 0;
    $pos = strpos($buffer, "<!--eachitemstart-->");
    $pos2 = strpos($buffer, "<!--eachitemend-->");
    if ((is_integer($pos)) && (is_integer($pos2)))
    {
      $found = 1;
      $buf = substr($buffer, $pos + 20, $pos2 - $pos-20);
      // Now remove this section
      $buffer1 = substr($buffer, 0, $pos);
      $buffer2 = substr($buffer, $pos2 + 18, strlen($buffer) - $pos2-18);
      $buffer = $buffer1;
      $minprod = 0;
      $maxprod = 1;
      if ($num_cart_items > 0)
      {
        $maxprod = $num_cart_items + 1;
        $minprod = 1;
      }
      if ($manualorder == true)
      {
        $maxprod = $num + 1;
        $minprod = 1;
      }
      for ($k = $minprod; $k < $maxprod; $k++)
      {
        $repeatbuf = $buf;
        if ($k == 0)
        {
           // Remove slashes from description if required
          $desc = $GLOBALS['item_name'];
          if (pl_get_magic_quotes_gpc())
            $desc=stripslashes($desc);
          $repeatbuf = str_replace("#item_number#", $GLOBALS['item_number'], $repeatbuf);
          $repeatbuf = str_replace("#item_options#", rtrim($GLOBALS['item_options'], ","), $repeatbuf);
          $repeatbuf = str_replace("#quantity#", $GLOBALS['quantity'], $repeatbuf);
          $repeatbuf = str_replace("#description#", $desc, $repeatbuf);
          $repeatbuf = str_replace("#item_name#", $desc, $repeatbuf);
          $repeatbuf = str_replace("#itemtotal#", $GLOBALS['mc_gross'], $repeatbuf);
          if ($GLOBALS['quantity']>0){
            $itemprice = $GLOBALS['mc_gross'] / $GLOBALS['quantity'];
          }else{
            $itemprice=0.00;
          }  
          $itemprice = sprintf("%01.2f", $itemprice);
          $repeatbuf = str_replace("#itemprice#", $itemprice, $repeatbuf);
          $itemposition = (string)($k + 1);
          $repeatbuf = str_replace("#itemposition#", $itemposition, $repeatbuf);
        }
        else
        {
          // Remove slashes from description if required
          $desc = ($notPayPal) ? $GLOBALS['item_name_' . $k] : $GLOBALS['item_name' . $k];
          if (pl_get_magic_quotes_gpc())
            $desc=stripslashes($desc);   
          $numkey = ($notPayPal)? 'item_number_' : 'item_number';       
          $repeatbuf = str_replace("#item_number#", $GLOBALS[$numkey . $k], $repeatbuf);
          $qtykey = ($notPayPal)? 'quantity_' : 'quantity';
          $repeatbuf = str_replace("#quantity#", $GLOBALS[$qtykey . $k], $repeatbuf);
          $repeatbuf = str_replace("#description#", $desc, $repeatbuf);
          $repeatbuf = str_replace("#item_name#", $desc, $repeatbuf);
          $repeatbuf = str_replace("#item_options#", rtrim($GLOBALS['item_options_' . $k], ","), $repeatbuf);
          $amtkey = ($notPayPal) ? 'amount_' : 'mc_gross_';
          
          if ($GLOBALS[$qtykey.$k]>0 && !$notPayPal){
            $itemprice = $GLOBALS[$amtkey . $k] / $GLOBALS[$qtykey . $k];
          }else if ($GLOBALS[$qtykey.$k]>0 && $notPayPal){
            $itemprice = $GLOBALS[$amtkey . $k];
          }else{
            $itemprice=0.00;
          }
          
          // Calculate net price using order tax rate
          if ($taxrate>0)
          {
            $itempricenet=$itemprice/(($taxrate/100)+1);
            $itemtax=$itemprice-$itempricenet;
            $itempricenet = sprintf("%01.2f", $itempricenet);
            $itemtax = sprintf("%01.2f", $itemtax);
          }
          else
          {
            $itempricenet=$itemprice;
            $itemtax==0;
            $itempricenet = sprintf("%01.2f", $itempricenet);
            $itemtax = sprintf("%01.2f", $itemtax);
          }
          
          $itemprice = sprintf("%01.2f", $itemprice);
          $repeatbuf = str_replace("#itemprice#", $itemprice, $repeatbuf);
          $repeatbuf = str_replace("#itempricenet#", $itempricenet, $repeatbuf);
          $repeatbuf = str_replace("#itemtax#", $itemtax, $repeatbuf);
          if($notPayPal) {
          	$itemtotal = sprintf("%01.2f", ($GLOBALS[$amtkey . $k] * $GLOBALS[$qtykey . $k]));
          }else{
	        $itemtotal = sprintf("%01.2f", $GLOBALS[$amtkey . $k]);
	      }
          $repeatbuf = str_replace("#itemtotal#", $itemtotal, $repeatbuf);
          $itemposition = (string)$k;
          $repeatbuf = str_replace("#itemposition#", $itemposition, $repeatbuf);
          $repeatbuf = str_replace("#option_selection1x#", $GLOBALS['option_selection1_' . $k], $repeatbuf);
        }
        $buffer .= $repeatbuf;
      }
      $buffer .= $buffer2;
    }
  }
  while ($found == 1);
}

function InsertUsegment(&$buf, $UnknownSegment, $nd)
{
  $segment = "";
  if ($nd > 0)
  {
    if ($UnknownSegment != "")
    {
      if (!($fh = @fopen($UnknownSegment, "r")))
      {
        $segment = "";
      }
      else
      {
        $segment = fread ($fh, 100000);
        fclose($fh);
      }
    }
  }
  $buf = str_replace("#unknownsegment#", $segment, $buf);
}

function InsertUnknownSection(&$buf, $nd)
{
  if ($nd == 0)
  {
    do
    {
      $found = 0;
      $pos = strpos($buf, "<!--unknownstart-->");
      $pos2 = strpos($buf, "<!--unknownend-->");
      if ((is_integer($pos)) && (is_integer($pos2)))
      {
        $found = 1;
        $buf = substr_replace($buf, "", $pos, ($pos2 - $pos) + 17);
      }
    }
    while ($found == 1);
  }
  $buf = str_replace("<!--unknownstart-->", "", $buf);
  $buf = str_replace("<!--unknownend-->", "", $buf);
}

function InsertKnownSection(&$buf, $numknown)
{
  if ($numknown==0)
  {
    do
    {
      $found = 0;
      $pos = strpos($buf, "<!--knownstart-->");
      $pos2 = strpos($buf, "<!--knownend-->");
      if ((is_integer($pos)) && (is_integer($pos2)))
      {
        $found = 1;
        $buf=substr_replace($buf,"",$pos,($pos2-$pos)+15);
      }
    }
    while ($found == 1);
  }
  $buf = str_replace("<!--knownstart-->", "", $buf);
  $buf = str_replace("<!--knownend-->", "", $buf);
}

function getitemvars($buf, $n)
{
  $start = 0;
  $itemids = "";
  do
  {
    $pos = strpos($buf, "#" . $n . "(", $start);
    $found = 0;
    if (is_integer($pos))
    {
      $found = 1;
      $pos2 = strpos($buf, ")#", $pos);
      if (is_integer($pos2))
      {
        if ($itemids != "")
          $itemids .= ",";
        $itemids .= substr($buf, $pos + strlen($n) + 4, $pos2 - ($pos + strlen($n) + 4));
      }
      $start = $pos2;
    }
  }
  while ($found == 1);
  return($itemids);
}

function GetProductDetails($id, $currency, &$cost, &$description, &$url, &$size, &$expiry, &$extra)
{
  global $Products, $numberofproducts, $MatchItemName;
  global $DefaultLocation, $DefaultPrice, $DefaultExpiry, $DefaultExtra;
  global $mysql_payloom, $DbTableNameProducts, $DbProductsId, $DbProductsDescription;
  global $DbProductsPrice, $DbProductsLocation, $DbProductsExpiry, $DbProductsExtra;
  global $DefaultCurrency;
  global $UsePaypalOptions,$os0,$os1;
  global $GlobalDiscount;
  global $ProductDelimiter;
  global $Debug;
  
  $found = 0;
  
  if($Debug){ echo "# GETPRODUCTDETAILS() CALLED<br>".PHP_EOL; }
  
  if (($DbTableNameProducts=="") || (!isset($DbTableNameProducts)))
  {
    // Get product details from script or text file
    // Match against item id (item_number)
    for ($k = 0;$k < $numberofproducts;$k++)
    {
      if (trim(strtok($Products[$k], $ProductDelimiter)) == trim($id))
      {
        $found = 1;
        $description = strtok($ProductDelimiter);
        $description=trim($description);
        $description = str_replace("^", "", $description);
        $costs = explode(":", trim(strtok($ProductDelimiter)));
        $url = strtok($ProductDelimiter);
        $url=trim($url);
        $size = strtok($ProductDelimiter);
        $size=trim($size);
        $expiry = strtok($ProductDelimiter);
        $expiry = trim($expiry);
        $extra = strtok($ProductDelimiter);
        $extra = trim($extra);
        // Now get price for the chosen currency
        if ((count($costs==1)) && (is_numeric($costs[0])))
          $costs[0]=$DefaultCurrency."=".$costs[0];
        $cost = -1.00; // Leave as -1 if price not listed in chosen currency
        for ($j = 0;$j < count($costs);$j++)
        {
          if (strcasecmp(strtok($costs[$j], "="), $currency) == 0)
            $cost = strtok("=");
        }
        break;
      }
    }
    if (($MatchItemName == true) && ($found == 0))
    {
      // Match against item description (item_name)
      $found = 0;
      for ($k = 0;$k < $numberofproducts;$k++)
      {
        $tid = strtok($Products[$k], $ProductDelimiter);
        $tid=trim($tid);
        $desc = strtok($ProductDelimiter);
        $desc=trim($desc);
        $match = false;
        // No wildcard
        if ((substr($desc, 0, 1) != "^") && (substr($desc, strlen($desc)-1, 1) != "^"))
        {
          if (strcasecmp(trim($desc), trim($description)) == 0)
            $match = true;
        }
        // Wildcard at start and end
        if ((substr($desc, 0, 1) == "^") && (substr($desc, strlen($desc)-1, 1) == "^"))
        {
          $desc = str_replace("^", "", $desc);
          if (is_integer(strpos($description, $desc)))
            $match = true;
        }
        // Wildcard at start only
        if ((substr($desc, 0, 1) == "^") && (substr($desc, strlen($desc)-1, 1) != "^"))
        {
          $desc = str_replace("^", "", $desc);
          if (strcasecmp($desc, substr($description, strlen($description) - strlen($desc))) == 0)
            $match = true;
        }
        // Wildcard at end only
        if ((substr($desc, 0, 1) != "^") && (substr($desc, strlen($desc)-1, 1) == "^"))
        {
          $desc = str_replace("^", "", $desc);
          if (strcasecmp($desc, substr($description, 0, strlen($desc))) == 0)
            $match = true;
        }
        if ($match)
        {
          $found = 1;
          $id = $tid;
          $costs = explode(":", strtok($ProductDelimiter));
          $costs=trim($costs);
          $url = strtok($ProductDelimiter);
          $url=trim($url);
          $size = strtok($ProductDelimiter);
          $size=trim($size);
          $expiry = strtok($ProductDelimiter);
          $expiry=trim($expiry);
          $extra = strtok($ProductDelimiter);
          $extra = trim($extra);
          // Now get price for the chosen currency
          if ((count($costs==1)) && (is_numeric($costs[0])))
            $costs[0]=$DefaultCurrency."=".$costs[0];
          $cost = -1.00; // Leave as -1 if price not listed in chosen currency
          for ($j = 0;$j < count($costs);$j++)
          {
            if (strcasecmp(strtok($costs[$j], "="), $currency) == 0)
              $cost = strtok("=");
          }
          break;
        }
      }
    }
  }

  // If still not found see if default product feature is enabled
  if ($found == 0)
  {
    if (($DefaultLocation != "") && ($DefaultPrice != "") && ($DefaultExpiry != ""))
    {
      $handleasdefault=false;
      if (substr(trim(strtolower($DefaultLocation)),0,3)=="s3|")
        $handleasdefault=true;
      else
      {  
        if (file_exists($DefaultLocation . $id))
          $handleasdefault=true;          
      }          
      if ($handleasdefault)
      {    
        $url = $DefaultLocation . $id;
        $expiry = $DefaultExpiry;
        $extra = $DefaultExtra;
        $size = 0;
        // Now get price for the chosen currency
        $costs = explode(":", $DefaultPrice);
        if ((count($costs==1)) && (is_numeric($costs[0])))
          $costs[0]=$DefaultCurrency."=".$costs[0];
        $cost = -1.00; // Leave as -1 if price not listed in chosen currency
        for ($j = 0;$j < count($costs);$j++)
        {
          if (strcasecmp(strtok($costs[$j], "="), $currency) == 0)
            $cost = strtok("=");
        }
        $found = 1;
      }
    }
  }
  // Get file size if not defined
  if ($found == 1)
  {
    // If file size set as 0 then try to get it
    if (($size == 0) && ($url != "NA"))
    {
      if (substr(trim(strtolower($url)),0,3)=="s3|")
      {
        $s = filesize_s3($url);
        if (is_numeric($s))
          $size = $s;
      }
      else
      {
        $pos = strpos(strtolower($url), "http://");
        if (is_integer($pos))
        {
          $s = filesize_remote($url);
          if (is_integer($s))
            $size = $s;
        }
        else
          $size = @filesize($url);
      }  
    }
  }
  // If discount set then apply that
  if ((is_numeric($cost)) && (is_numeric($GlobalDiscount)))
  {
    $cost=$cost-$cost*($GlobalDiscount/100);
    $cost=sprintf("%01.2f", $cost);
  }
  return($found);
}

function GetAuctionDetails(&$id, $currency, &$cost, &$description, &$url, &$size, &$expiry, &$extra)
{
  global $Products, $numberofproducts, $AllowAuctionId;
  global $DefaultLocation, $DefaultPrice, $DefaultExpiry, $DefaultExtra;
  global $mysql_payloom, $DbTableNameProducts, $DbProductsId, $DbProductsDescription;
  global $DbProductsPrice, $DbProductsLocation, $DbProductsExpiry, $DbProductsExtra;
  global $DefaultCurrency;
  global $GlobalDiscount;
  global $ProductDelimiter;
  $found = 0;
  if (($DbTableNameProducts=="") || (!isset($DbTableNameProducts)))
  {      
    // Get product details from script or text file
    // First see if we can match auction id
    if ((!isset($AllowAuctionId)) || ($AllowAuctionId == true))
    {
      for ($k = 0;$k < $numberofproducts;$k++)
      {
        if (trim(strtok($Products[$k], $ProductDelimiter)) == trim($id))
        {
          $found = 1;
          $desc = strtok($ProductDelimiter);
          $desc=trim($desc);
          $costs = explode(":", trim(strtok($ProductDelimiter)));
          $url = strtok($ProductDelimiter);
          $url=trim($url);
          if ($DefaultLocation!="")          
          {
            $combos = explode(":", $url);
            if ((count($combos) == 1) || (substr(strtolower($url), 0, 5) == "http:") || (substr($url, 1, 2) == ":/"))
              $url = $DefaultLocation.$url;
            else 
              $url = $url;
          }             
          $size = strtok($ProductDelimiter);
          $size=trim($size);
          $expiry = strtok($ProductDelimiter);
          $expiry = trim($expiry);
          $extra = strtok($ProductDelimiter);
          $extra = trim($extra);
          // Now get price for the chosen currency
          if ((count($costs==1)) && (is_numeric($costs[0])))
            $costs[0]=$DefaultCurrency."=".$costs[0];
          $cost = -1.00; // Leave as -1 if price not listed in chosen currency
          for ($j = 0;$j < count($costs);$j++)
          {
            if (strcasecmp(strtok($costs[$j], "="), $currency) == 0)
              $cost = strtok("=");
          }
          break;
        }
      }
      if ($found == 1)
      {
        $description = str_replace("^", "", $desc);
        // Get file size if not defined
        // If file size set as 0 then try to get it
        if (($size == 0) && ($url != "NA"))
        {
          if (substr(trim(strtolower($url)),0,3)=="s3|")
          {
            $s = filesize_s3($url);
            if (is_numeric($s))
              $size = $s;        
          }
          else
          {
            $pos = strpos(strtolower($url), "http://");
            if (is_integer($pos))
            {
              $s = filesize_remote($url);
              if (is_integer($s))
                $size = $s;
            }
            else
              $size = @filesize($url);
          }  
        }
        return($found);
      }
    }
    // If auction if not matched (or not allowed) try matching auction title
    $found = 0;
    for ($k = 0;$k < $numberofproducts;$k++)
    {
      $tid = strtok($Products[$k], $ProductDelimiter);
      $tid=trim($tid);
      $desc = strtok($ProductDelimiter);
      $desc=trim($desc);
      $match = false;
      // No wildcard
      if ((substr($desc, 0, 1) != "^") && (substr($desc, strlen($desc)-1, 1) != "^"))
      {
        if (strcasecmp(trim($desc), trim($description)) == 0)
          $match = true;
      }
      // Wildcard at start and end
      if ((substr($desc, 0, 1) == "^") && (substr($desc, strlen($desc)-1, 1) == "^"))
      {
        $desc = str_replace("^", "", $desc);
        if (is_integer(strpos($description, $desc)))
          $match = true;
      }
      // Wildcard at start only
      if ((substr($desc, 0, 1) == "^") && (substr($desc, strlen($desc)-1, 1) != "^"))
      {
        $desc = str_replace("^", "", $desc);
        if (strcasecmp($desc, substr($description, strlen($description) - strlen($desc))) == 0)
          $match = true;
      }
      // Wildcard at end only
      if ((substr($desc, 0, 1) != "^") && (substr($desc, strlen($desc)-1, 1) == "^"))
      {
        $desc = str_replace("^", "", $desc);
        if (strcasecmp($desc, substr($description, 0, strlen($desc))) == 0)
          $match = true;
      }
      if ($match)
      {
        $found = 1;
        $id = $tid;
        $costs = explode(":", trim(strtok($ProductDelimiter)));
        $url = strtok($ProductDelimiter);
        $url=trim($url);
        if ($DefaultLocation!="")          
        {
          $combos = explode(":", $url);
          if ((count($combos) == 1) || (substr(strtolower($url), 0, 5) == "http:") || (substr($url, 1, 2) == ":/"))
            $url = $DefaultLocation.$url;
        }             
        $size = strtok($ProductDelimiter);
        $size=trim($size);
        $expiry = strtok($ProductDelimiter);
        $expiry=trim($expiry);
        $extra = strtok($ProductDelimiter);
        $extra = trim($extra);
        // Now get price for the chosen currency
        if ((count($costs==1)) && (is_numeric($costs[0])))
          $costs[0]=$DefaultCurrency."=".$costs[0];
        $cost = -1.00; // Leave as -1 if price not listed in chosen currency
        for ($j = 0;$j < count($costs);$j++)
        {
          if (strcasecmp(strtok($costs[$j], "="), $currency) == 0)
            $cost = strtok("=");
        }
        break;
      }
    }
  }  
  else
  {
    // Get product details from MySQL table
    // First see if we can match auction id
    if ((!isset($AllowAuctionId)) || ($AllowAuctionId == true))
    {
      $query="SELECT * FROM ".$DbTableNameProducts." WHERE ".$DbProductsId."=".pl_quote_smart(trim($id));
      $mysql_result=pl_mysql_query($query,$mysql_payloom);
      if ($row=pl_mysql_fetch_array_assoc($mysql_result))
      {
        $found = 1;
        $description = $row[$DbProductsDescription];
        $description = str_replace("^", "", $description);
        if ($DbProductsPrice!="")
          $costs = explode(":", $row[$DbProductsPrice]);
        else
          $costs = explode(":", $DefaultPrice);                  
        $url = $row[$DbProductsLocation];
        if ($DefaultLocation!="")          
        {
          $combos = explode(":", $url);
          if ((count($combos) == 1) || (substr(strtolower($url), 0, 5) == "http:") || (substr($url, 1, 2) == ":/"))
            $url = $DefaultLocation.$url;
          else 
            $url = $url;
        }             
        $size = 0;
        if ($DbProductsExpiry!="")
          $expiry = $row[$DbProductsExpiry];
        else
          $expiry = $DefaultExpiry;  
        $expiry = trim($expiry);
        if ($DbProductsExtra!="")
          $extra = $row[$DbProductsExtra];
        else
          $extra = $DefaultExtra;       
        $extra = trim($extra);
        // Now get price for the chosen currency
        if ((count($costs==1)) && (is_numeric($costs[0])))
          $costs[0]=$DefaultCurrency."=".$costs[0];
        $cost = -1.00; // Leave as -1 if price not listed in chosen currency
        for ($j = 0;$j < count($costs);$j++)
        {
          if (strcasecmp(strtok($costs[$j], "="), $currency) == 0)
            $cost = strtok("=");
        }
      }
      if ($found == 1)
      {
        $description = str_replace("^", "", $desc);
        // Get file size if not defined
        // If file size set as 0 then try to get it
        if (($size == 0) && ($url != "NA"))
        {
          if (substr(trim(strtolower($url)),0,3)=="s3|")
          {
            $s = filesize_s3($url);
            if (is_numeric($s))
              $size = $s;        
          }
          else
          {
            $pos = strpos(strtolower($url), "http://");
            if (is_integer($pos))
            {
              $s = filesize_remote($url);
              if (is_integer($s))
                $size = $s;
            }
            else
              $size = @filesize($url);
          }  
        }
        return($found);
      }
    }
    // If auction if not matched (or not allowed) try matching auction title
    $query="SELECT * FROM ".$DbTableNameProducts;
    $mysql_result=pl_mysql_query($query,$mysql_payloom);
    $found = 0;
    while($row=pl_mysql_fetch_array_assoc($mysql_result))
    {
      $tid=$row[$DbProductsId];
      $desc=$row[$DbProductsDescription];
      $match = false;
      // No wildcard
      if ((substr($desc, 0, 1) != "^") && (substr($desc, strlen($desc)-1, 1) != "^"))
      {
        if (strcasecmp(trim($desc), trim($description)) == 0)
          $match = true;
      }
      // Wildcard at start and end
      if ((substr($desc, 0, 1) == "^") && (substr($desc, strlen($desc)-1, 1) == "^"))
      {
        $desc = str_replace("^", "", $desc);
        if (is_integer(strpos($description, $desc)))
          $match = true;
      }
      // Wildcard at start only
      if ((substr($desc, 0, 1) == "^") && (substr($desc, strlen($desc)-1, 1) != "^"))
      {
        $desc = str_replace("^", "", $desc);
        if (strcasecmp($desc, substr($description, strlen($description) - strlen($desc))) == 0)
          $match = true;
      }
      // Wildcard at end only
      if ((substr($desc, 0, 1) != "^") && (substr($desc, strlen($desc)-1, 1) == "^"))
      {
        $desc = str_replace("^", "", $desc);
        if (strcasecmp($desc, substr($description, 0, strlen($desc))) == 0)
          $match = true;
      }
      if ($match)
      {
        $found = 1;
        $id = $tid;
        if ($DbProductsPrice!="")
          $costs = explode(":", $row[$DbProductsPrice]);
        else
          $costs = explode(":", $DefaultPrice);        
        $url = $row[$DbProductsLocation];
        if ($DefaultLocation!="")          
        {
          $combos = explode(":", $url);
          if ((count($combos) == 1) || (substr(strtolower($url), 0, 5) == "http:") || (substr($url, 1, 2) == ":/"))
            $url = $DefaultLocation.$url;
        }                       
        $size = 0;
        if ($DbProductsExpiry!="")
          $expiry = $row[$DbProductsExpiry];
        else
          $expiry = $DefaultExpiry;  
        $expiry = trim($expiry);
        if ($DbProductsExtra!="")
          $extra = $row[$DbProductsExtra];
        else
          $extra = $DefaultExtra;       
        $extra = trim($extra);
        // Now get price for the chosen currency
        if ((count($costs==1)) && (is_numeric($costs[0])))
          $costs[0]=$DefaultCurrency."=".$costs[0];
        $cost = -1.00; // Leave as -1 if price not listed in chosen currency
        for ($j = 0;$j < count($costs);$j++)
        {
          if (strcasecmp(strtok($costs[$j], "="), $currency) == 0)
            $cost = strtok("=");
        }
        break;
      }
    }
  }
  // Get file size if not defined
  if ($found == 1)
  {
    // If file size set as 0 then try to get it
    if (($size == 0) && ($url != "NA"))
    {
      if (substr(trim(strtolower($url)),0,3)=="s3|")
      {
        $s = filesize_s3($url);
        if (is_numeric($s))
          $size = $s;        
      }
      else
      {
        $pos = strpos(strtolower($url), "http://");
        if (is_integer($pos))
        {
          $s = filesize_remote($url);
          if (is_integer($s))
            $size = $s;
        }
        else
          $size = @filesize($url);
      }  
    }
  }
  // If discount set then apply that
  if ((is_numeric($cost)) && (is_numeric($GlobalDiscount)))
  {
    $cost=$cost-$cost*($GlobalDiscount/100);
    $cost=sprintf("%01.2f", $cost);
  }  
  return($found);
}

function VerifyTransactionId($fn, $on)
{
  global $DbTableNameOrders, $mysql_payloom;
  if ($fn == "")
    return(1);
  if (strtolower($fn) == "mysql")  
  {
    $orderno=strtok($on,"-");
    $calltype=strtok("-");
    // Check for order processed in mysql table instead
    $query="SELECT * FROM ".$DbTableNameOrders." WHERE orderno=".pl_quote_smart(trim($orderno));
    $mysql_result=pl_mysql_query($query,$mysql_payloom);
    if ($row=pl_mysql_fetch_array_assoc($mysql_result))
    {
      if (($calltype=="ipn") && ($row["ipn"]=="Y"))
        return(0);
      if (($calltype=="return") && ($row["return"]=="Y"))
        return(0);        
    }
    // Now update details that depend on whether called as IPN or return
    if ($calltype=="return")
      $Query = "UPDATE " . $DbTableNameOrders . " SET `return`='Y' WHERE orderno=" . pl_quote_smart(trim($orderno));
    else  
      $Query = "UPDATE " . $DbTableNameOrders . " SET `ipn`='Y' WHERE orderno=" . pl_quote_smart(trim($orderno));
    $mysql_result = pl_mysql_query($Query, $mysql_payloom);
    return(1);
  }    
  if (is_writeable($fn) == false)
    return(1);
  if (is_readable($fn) == false)
    return(1);
  $fh = @fopen($fn, "r");
  if (!($fh))
    return(1);
  // Check each entry for a match
  $match = 0;
  while (!feof($fh))
  {
    $txid = fgets($fh, 255);
    if (substr($txid, 0, strlen($on)) == $on)
    {
      $match = 1;
      break;
    }
  }
  fclose($fh);
  if ($match == 1)
    return(0);
  $fh = @fopen($fn, "a");
  if (!($fh))
    return(1);
  flock($fh, 2);
  fputs($fh, "$on\n");
  fflush($fh);
  flock($fh, 3);
  fclose($fh);
  return(1);
}

function FriendlyExpiryTime($exp)
{
  if ($exp == 0)
    return("");
  if (($exp >= 1) && ($exp <= 59))
  {
    if ($exp == 1)
      return("$exp minute");
    else
      return("$exp minutes");
  }
  if (($exp >= 60) && ($exp <= 1440))
  {
    $hours = intval($exp / 60);
    $mins = $exp % 60;
    if ($hours == 1)
      $ret = $hours . " hour";
    else
      $ret = $hours . " hours";
    if ($mins > 0)
    {
      if ($mins == 1)
        $ret .= " & " . $mins . " minute";
      else
        $ret .= " & " . $mins . " minutes";
    }
    return($ret);
  }
  if ($exp >= 1441)
  {
    $days = intval($exp / 1440);
    $exp = $exp - ($days * 1440);
    $hours = intval($exp / 60);
    $mins = $exp % 60;
    if ($days == 1)
      $ret = $days . " day";
    else
      $ret = $days . " days";
    if ($hours > 0)
    {
      if ($mins == 0)
        $ret .= " &";
      if ($hours == 1)
        $ret .= " " . $hours . " hour";
      else
        $ret .= " " . $hours . " hours";
    }
    if ($mins > 0)
    {
      if ($mins == 1)
        $ret .= " & " . $mins . " minute";
      else
        $ret .= " & " . $mins . " minutes";
    }
    return($ret);
  }
}

function FriendlyFileSize($sz)
{
  if ($sz == 0)
    return("Unknown size");
  if ($sz <= 1023)
    return($sz . " Bytes");
  if (($sz >= 1024) && ($sz <= 1048575))
  {
    $sz = intval($sz / 1024);
    return($sz . " KB");
  }
  if ($sz >= 1048576)
  {
    $sz = $sz / 1048576;
    $sz = intval($sz * 100) / 100;
    return($sz . " MB");
  }
}

function ValidIP($ip)
{
  if ($ip != "")
  {
    $parts = explode(".", $ip);
    if (count($parts) == 4)
    {
      for ($k = 0;$k < 4;$k++)
      {
        if ((!is_numeric($parts[$k])) || ($parts[$k] < 0) || ($parts[$k] > 255))
          return(false);
      }
      return(true);
    }
  }
  return(false);
}

function CustomError($Template, $msg)
{
  if ($Template == "")
    return(0);
  $ext = fileextension($Template);
  if ($ext == ".php")
  {
    ob_start();
    include $Template;
    $page = ob_get_contents(); 
    ob_end_clean();    
  }
  else
  {
    if (!($fh = @fopen($Template, "r")))
      return(0);
    $page = fread ($fh, 200000);
    fclose($fh);
  }
  $page = str_replace("#message#", $msg, $page);
  print $page;
  return(1);
}

function ShowMessage($Template, $msg, $em)
{
  global $EmailHeaderNoSlashR, $SellerCompany, $SellerEmail, $ExtraMailParam;
  if ($em != "")
  {
    $subject = "[Payloom] Error Notification";
    $mailBody = "Date: ". date('r')."\n";
    $mailBody .= "IP: ". $_SERVER['REMOTE_ADDR']."\n\n";
    $mailBody .= "The following error message was generated for transaction number " . $GLOBALS['txn_id'] . "\n\n";
    $mailBody .= $msg . "\n";
    $mailBody .= "The following variables were received by Payloom.\n\n";
    if (!empty($_GET))
    {
      reset($_GET);
      while (list($namepair, $valuepair) = each($_GET))
      {
        $$namepair = $valuepair;
        $mailBody .= "GET " . $namepair . "=" . $valuepair . "\n";
      }
    }
    if (!empty($_POST))
    {
      reset($_POST);
      while (list($namepair, $valuepair) = each($_POST))
      {
        $$namepair = $valuepair;
        if($valuepair != 'CartLoom_Cart_WPS')
        	$mailBody .= "POST " . $namepair . "=" . $valuepair . "\n";
      }
    }
    reset($_GET);
    reset($_POST);
    SendEmailOut($em, $SellerEmail, $SellerCompany, $subject, $mailBody, "N");
  }
  if (0 == CustomError($Template, $msg))
  {
    print ("<html>\n");
    print ("<head>\n");
    print ("<title>Payloom</title>\n");
    print ("</head>\n");
    print ("<body>\n");
    print("<p>$msg</p>");
    print ("</body>\n");
    print ("</html>\n");
  }
}

function ShowAlert($msg, $type="success")
{	
	echo '<div class="alert alert-'.$type.' text-center">
    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>'.$msg.'</div>';
	
}

// ! DEBUG EMAIL
function Debug($msg, $em)
{
  global $EmailHeaderNoSlashR, $SellerCompany, $SellerEmail, $calledasreturn;
  if ($em != "")
  {
    $subject = "[Payloom] Debug Data from $SellerCompany";
    $mailBody = "The following debug data was generated\n\n";
    $mailBody .= $msg . "\n\n";
    $mailBody .= "IP=" . $_SERVER['REMOTE_ADDR'] . "\n\n";
    $mailBody .= "calledasreturn=" . $calledasreturn . "\n\n";
    $mailBody .= "The following variables were received by Payloom.\n\n";
    if (!empty($_GET))
    {
      reset($_GET);
      while (list($namepair, $valuepair) = each($_GET))
      {
        $$namepair = $valuepair;
        $mailBody .= "GET " . $namepair . "=" . $valuepair . "\n";
      }
    }
    if (!empty($_POST))
    {
      reset($_POST);
      while (list($namepair, $valuepair) = each($_POST))
      {
        $$namepair = $valuepair;
        if($valuepair != 'CartLoom_Cart_WPS')
        	$mailBody .= "POST " . $namepair . "=" . $valuepair . "\n";
      }
    }
    reset($_GET);
    reset($_POST);
    SendEmailOut($em, $SellerEmail, $SellerCompany, $subject, $mailBody, "N");
  }
}

function xgetallheaders()
{
  $headers = array();
  while (list($key, $value) = each ($_SERVER))
  {
    if (strncmp($key, "HTTP_", 5) == 0)
    {
      $key = strtr(ucwords(strtolower(strtr(substr($key, 5), "_", " "))), " ", "-");
      $headers[$key] = $value;
    }
  }
  return $headers;
}
function fileextension($fname)
{
  if ($fname == "")
    return("");
  $pos = strrpos($fname, ".");
  if (is_integer($pos))
  {
    $ext=strtolower(substr($fname, $pos));
    // Now remove any query that may be there for a .php file
    $pos = strpos($ext, "?");
    if (is_integer($pos))
    {
      $ext=substr($ext,0,$pos);
    }
    return($ext);
  }    
  return("");
}
function filename($fname)
{
  if ($fname == "")
    return("");
  // First see if link is for S3
  if (substr(trim(strtolower($fname)),0,3)=="s3|")
  {
    $pos=strrpos($fname, "|");
    if (is_integer($pos))
      $fname = substr($fname, $pos + 1);
  }
  $pos1 = strrpos($fname, "/");
  $pos2 = strrpos($fname, "\\");
  if ($pos1 === false)
    $pos1 = -1;
  if ($pos2 === false)
    $pos2 = -1;
  if ($pos1 > $pos2)
    $pos = $pos1;
  else
    $pos = $pos2;
  if ($pos > -1)
  {
    $name = substr($fname, $pos + 1);
    return($name);
  }
  return($fname);
}

function filesize_remote($url, $timeout = 3)
{
  if (function_exists('curl_init'))
  {
    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_NOBODY, true);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HEADER, true);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true); //not necessary unless the file redirects
    $data = curl_exec($ch);
    curl_close($ch);
    if ($data === false) {
      return(false);
    }   
    $contentLength = 'unknown';
    $status = 'unknown';
    if (preg_match('/^HTTP\/1\.[01] (\d\d\d)/', $data, $matches)) {
      $status = (int)$matches[1];
    }
    if (preg_match('/Content-Length: (\d+)/', $data, $matches)) {
      $contentLength = (int)$matches[1];
    }
    if ($contentLength=="unknown")
      return(false);
    return($contentLength);
  }
  else
  {
    $url = parse_url($url);
    if ($fp = @fsockopen($url['host'], ($url['port'] ? $url['port'] : 80), $errno, $errstr, $timeout))
    {
      fwrite($fp, 'HEAD '.$url['path'].$url['query']." HTTP/1.0\r\nHost: ".$url['host']."\r\n\r\n");
      @stream_set_timeout($fp, $timeout);
      while (!feof($fp))
      {
        $size = fgets($fp, 4096);
        if (stristr($size, 'Content-Length') !== false)
        {
          $size = trim(substr($size, 16));
          break;
        }
      }
      fclose ($fp);
    }
    return is_numeric($size) ? intval($size) : false;
  }
}

function pl_quote_smart($value)
{    
  if (function_exists("mysqli_real_escape_string"))
  {
    global $mysql_payloom;
    if (get_magic_quotes_gpc())
      $value = stripslashes($value);
    $value = "'" . mysqli_real_escape_string($mysql_payloom,$value) . "'";
    return $value;
  }
  else
  {
    if (get_magic_quotes_gpc())
      $value = stripslashes($value);
    if (function_exists('mysql_real_escape_string'))
      $value = "'" . mysql_real_escape_string($value) . "'";
    else  
      $value="'".addslashes($value)."'";      
    return $value;
  }  
}

// ! DATABASE HELPERS
function pl_dbconnect()
{
  global $DbNamePayloom,$DbHostPayloom,$DbUserPayloom,$DbPasswordPayloom,$mysql_payloom;
  if (function_exists("mysqli_connect"))
    $mysql_payloom=mysqli_connect($DbHostPayloom,$DbUserPayloom,$DbPasswordPayloom);
  else  
    $mysql_payloom=mysql_connect($DbHostPayloom,$DbUserPayloom,$DbPasswordPayloom);
  if ($mysql_payloom===false)
    return(false);
  if (function_exists("mysqli_select_db"))
    $db=mysqli_select_db($mysql_payloom,$DbNamePayloom);
  else
    $db=mysql_select_db($DbNamePayloom,$mysql_payloom);    
  if ($db==false)
    return(false);
  return($mysql_payloom);
}

function pl_mysql_query($query,$mysql_payloom)
{
  if (function_exists("mysqli_query"))
    return mysqli_query($mysql_payloom,$query);
  return(mysql_query($query,$mysql_payloom));
}

function pl_mysql_fetch_array_assoc($mysql_result,$ignore=0)
{ 
  if (function_exists("mysqli_fetch_array"))
    return(mysqli_fetch_array($mysql_result,MYSQLI_ASSOC));
  return(mysql_fetch_array($mysql_result,MYSQL_ASSOC));
}

function pl_mysql_fetch_row($mysql_result)
{ 
  if (function_exists("mysqli_fetch_row"))
    return(mysqli_fetch_row($mysql_result));
  return(mysql_fetch_row($mysql_result));
}

function pl_mysql_close($mysql_payloom)
{
  if (function_exists("mysqli_close"))
    return(mysqli_close($mysql_payloom));
  return(mysql_close($mysql_payloom));
}


// ! EMAIL HELPER
function SendEmailOut($toemail, $fromemail, $fromname, $subject, $mailBody, $htmlformat)
{
  global $EmailHeaderNoSlashR, $ExtraMailParam, $ErrorTemplate, $ErrorEmail, $UsePHPmailer, $UsePearMail;
  global $Custom_Mail_Headers, $llcharset,$manualorder,$Test,$Debug;
  
  if($Debug){ echo "# SENDEMAILOUT( $toemail )<br>".PHP_EOL; }
  
  // Remove any comma in from name
  $fromname = str_replace(",", " ", $fromname);
  // Handle multiple email addresses
  $sendtoemail=explode(",",$toemail);  
  // If phpmailer setup then use it otherwise handle with PHP mail() function
  if ($UsePHPmailer == 1)
  {
    global $EmailUsername, $EmailPassword, $EmailServer, $EmailPort, $EmailAuth, $EmailServerSecurity;
    if ($EmailPort=="")
      $EmailPort=25;
    if ($EmailAuth=="")
      $EmailAuth=1;
    require_once("../rw_common/plugins/payloom/class.phpmailer.php");
    //require_once("payloom3/class.smtp.php");
    $mail = new PHPMailer();
    $mail->CharSet = $llcharset;
    //$mail->IsSMTP();
    $mail->Host = $EmailServer;
    $mail->Port = $EmailPort;    
    if ($EmailAuth=="0")        
      $mail->SMTPAuth = false;
    else
      $mail->SMTPAuth = true;
    if ($EmailServerSecurity!="")     
      $mail->SMTPSecure = $EmailServerSecurity;
    $mail->Username = $EmailUsername;
    $mail->Password = $EmailPassword;
    $mail->From = $fromemail;
    $mail->FromName = $fromname;
    for ($k=0; $k<count($sendtoemail); $k++)
      $mail->AddAddress(trim($sendtoemail[$k]));
    if ($htmlformat == "Y")
      $mail->IsHTML(true);
    else
      $mail->IsHTML(false);
    $mail->Subject = $subject;
    $mail->Body = $mailBody;
    if ($Custom_Mail_Headers!="")
    {
      $cushd=explode("\r\n",$Custom_Mail_Headers);
      for ($k=0;$k<count($cushd);$k++)
      {
        if ($cushd[$k]!="")      
          $mail->AddCustomHeader($cushd[$k]);
      }  
    }
    $mail->Send();
    if ($mail->isError())
    {
      if (($manualorder) || ($Test=="Y"))
      {
        ShowMessage($ErrorTemplate, "Email send using PHPmailer failed","");
        exit;
      }
    }
    return;
  }
  if ($UsePearMail == 1)
  {
    global $EmailUsername, $EmailPassword, $EmailServer;
    $headers = array ('From' => $fromemail,
                      'To' => $sendtoemail[0],
                      'Subject' => $subject);
    $smtp = Mail::factory('smtp',array ('host' => $EmailServer,
    'auth' => true,
    'username' => $EmailUsername,
    'password' => $EmailPassword));
    $mail = $smtp->send($sendtoemail[0], $headers, $mailBody);
    if (PEAR::isError($mail))
    {
      if (($manualorder) || ($Test=="Y"))
      {
        ShowMessage($ErrorTemplate, "Email send using Pear Mail function failed", "");
        exit;
      }
    }  
    return;
  }
  // If still here then use PHP mail() function  
  $headers = "From: " . $fromname . " <" . $fromemail . ">\r\n";
  $headers.= "Reply-To: " . $fromname . " <" . $fromemail . ">\r\n";
  $headers.= "MIME-Version: 1.0\r\n";
  if ($htmlformat=="Y")
  {
    $headers .= "Content-type: text/html; charset=".$llcharset."\r\n";
    $headers .= "Content-Transfer-Encoding: base64\r\n";      
    $mailBody=chunk_split(base64_encode($mailBody));
  }
  else
    $headers .= "Content-type: text/plain\r\n";
  if ($Custom_Mail_Headers!="")
    $headers .= $Custom_Mail_Headers;    
  if ($EmailHeaderNoSlashR == 1)
    $headers = str_replace("\r", "", $headers);
  for ($k=0; $k<count($sendtoemail); $k++)
  {
    if ($ExtraMailParam != "")
      $sent = mail($sendtoemail[$k], $subject, $mailBody, $headers, $ExtraMailParam);
    else
      $sent = mail($sendtoemail[$k], $subject, $mailBody, $headers);
    if ($sent == false)
    {
      if (($manualorder) || ($Test=="Y"))
      {      
        ShowMessage($ErrorTemplate, "Email send using mail function failed", "");
        exit;
      }  
    }
  }
}
// Notify that download was made.
function EmailDownloadNotify($fname, $in, $desc, $ordnum, $ipaddr, $expiry, $email)
{
  global $NotifyDownloadEmail, $SellerCompany, $SellerEmail;
  global $Debug;
  
  if($Debug){ echo "# EMAILDOWNLOADNOTIFY()<br>".PHP_EOL; }
  
  if (function_exists('vl_geoip2'))
    $clientipinfo=vl_geoip2($_SERVER['REMOTE_ADDR']); 
  $subject = "Payloom Download of $in from order $ordnum - $email";
  $mailBody = "Download notification.\n\n";
  $mailBody .= "Order Number : " . $ordnum . "\n";
  $mailBody .= "Email : ".$email."\n";   
  $mailBody .= "Item Number : " . $in . "\n";
  $mailBody .= "Description : " . $desc . "\n";
  $mailBody .= "Filename : " . $fname . "\n";
  if (function_exists('vl_geoip2'))
    $mailBody .= "IP : " . $ipaddr . " (".$clientipinfo['countryname'].")\n";
  else
    $mailBody .= "IP : " . $ipaddr . "\n";    
  $mailBody .= "Download time : " . date("d M Y H:i:s") . "\n";
  $mailBody .= "Expiry time : " . date("d M Y H:i:s", $expiry) . "\n";
  $mailBody .= "User agent : " . $_SERVER['HTTP_USER_AGENT'] . "\n";
  $mailBody .= "\n";
  SendEmailOut($NotifyDownloadEmail, $SellerEmail, $SellerCompany, $subject, $mailBody, "N");
  return;
}

function GetVarFromString($s, $v)
{
  global $LinkKey;
  $s = rawurldecode($s);
  $s = base64_decode($s);
  $hash = strtok($s, "^");
  $s = strtok("^");
  if ($hash != md5($LinkKey . $s))
    return("");
  $vars = explode(",", $s);
  $value = "";
  for ($j = 0;$j < count($vars);$j++)
  {
    $var = explode("=", $vars[$j]);
    if (strtoupper($var[0]) == $v)
      $value = $var[1];
  }
  return($value);
}

function GetSerialNumber($snlist)
{
  global $EmailHeaderNoSlashR, $SellerCompany, $SellerEmail, $ExtraMailParam;
  $warnwhenleft = 5;
  $serialnumber = "";
  if (($snlist == "") || (snlist == "NOTREQUIRED"))
    return("");
  if (is_writeable($snlist) == false)
    return($serialnumber);
  $fh = @fopen($snlist, "r+b");
  flock($fh, 2);
  while (!feof($fh))
  {
    $fpoint = ftell($fh);
    $lne = fgets($fh, 255);
    $fpoint2 = ftell($fh);
    $lne = trim($lne);
    if (($lne != str_repeat("*", strlen($lne))) && (strlen($lne) > 2))
    {
      $blank = str_repeat("*", strlen($lne));
      fseek($fh, $fpoint);
      fputs($fh, $blank);
      fseek($fh, $fpoint2);
      $serialnumber = $lne;
      break;
    }
  }
  $countleft = 0;
  while (!feof($fh))
  {
    $lne = fgets($fh, 255);
    $lne = trim($lne);
    if (($lne != str_repeat("*", strlen($lne))) && (strlen($lne) > 2))
      $countleft++;
    if ($countleft > $warnwhenleft)
      break;
  }
  flock($fh, 3);
  fclose($fh);
  if ($countleft <= $warnwhenleft)
  {
    $subject = "Linklok serial number list warning";
    $mailBody = "Warning the following serial number list is nearly finished.\n\n";
    $mailBody .= $snlist . "\n";
    SendEmailOut($SellerEmail, $SellerEmail, $SellerCompany, $subject, $mailBody, "N");
  }
  return($serialnumber);
}




function storeOrderToMySQL()
{
  global $calledasreturn,$manualorder,$parent_txn_id, $memo, $tax, $mc_shipping, $mc_handling, $mc_fee, $mc_currency;
  global $payment_status, $txn_type, $num_cart_items;
  global $txn_id, $first_name, $last_name, $payer_business_name, $address_street, $address_city;
  global $address_state, $address_zip, $address_country, $payer_email, $mc_gross, $custom, $payment_type;
  global $clientipaddr, $invoice, $Debug, $notPayPal, $checkoutMethod;
  global $mysql_payloom, $DbTableNameOrders, $discount;
  global $custom1,$custom2,$custom3,$custom4;
  if (($payment_status == "Completed") && ($txn_type != "reversal"))
  {
    $itemsordered = "";
    $itemnamesordered="";
    $itemoptionssordered="";
    $itemqtysordered="";
    $itempricesordered="";
    
    if ($num_cart_items > 0)
    {
      if($Debug){ echo "# LOOP THRU PRODUCTS<br>".PHP_EOL; }
      for ($k = 1;$k <= $num_cart_items;$k++)
      {
        if($Debug){ echo "# LOOP - $k...<br>".PHP_EOL; }
        $t = ($notPayPal) ? "item_number_" . $k : "item_number" . $k;
        $pid = $GLOBALS[$t];
        if($Debug){ echo "# NUMBER == $pid<br>".PHP_EOL; }
        if ($itemsordered != "")
          $itemsordered .= "|";
        $itemsordered .= $pid;
        
        $t = ($notPayPal) ? "item_name_". $k : "item_name" . $k;
        $pid = $GLOBALS[$t];
        if ($itemnamesordered != "")
          $itemnamesordered .= "|";
        $itemnamesordered .= $pid;
        
        $t = "item_options_" . $k;
        $pid = $GLOBALS[$t];
        if ($itemoptionsordered != "")
          $itemoptionsordered .= "|";
        $itemoptionsordered .= $pid;
        
        $t = ($notPayPal) ? "quantity_". $k : "quantity" . $k;
        $pid = $GLOBALS[$t];
        if ($pid=="")
          $pid="1";
        if ($itemqtysordered != "")
          $itemqtysordered .= "|";
        $itemqtysordered .= $pid;
        $t = ($notPayPal) ? "amount_". $k : "mc_gross_" . $k;
        $pid = $GLOBALS[$t];
        if ($pid=="")
          $pid="0.00";
        if ($itempricesordered != "")
          $itempricesordered .= "|";
        $itempricesordered .= $pid;
      }
    }
    else
    {
      $itemsordered = $GLOBALS['item_number'];
      $itemnamesordered = $GLOBALS['item_name'];
      $itemoptionsordered = $GLOBALS['item_options'];
      $itemqtysordered = $GLOBALS['quantity'];
      $itempricesordered = $GLOBALS['mc_gross'];
    }
    
    // make sure the table is created
    setupPayloomDatabase();
    
    $Query = "INSERT INTO " . $DbTableNameOrders . " (";
    $Query.="orderno,";
    $Query.="parentorderno,";
    $Query.="datetime,";
    $Query.="processor,";
    $Query.="name,";
    $Query.="company,";
    $Query.="street1,";
    $Query.="street2,";
    $Query.="city,";
    $Query.="state,";
    $Query.="zip,";
    $Query.="country,";
    $Query.="email,";
    $Query.="telephone,";
    $Query.="fax,";
    $Query.="shipname,";
    $Query.="shipcompany,";
    $Query.="shipstreet1,";
    $Query.="shipstreet2,";
    $Query.="shipcity,";
    $Query.="shipstate,";
    $Query.="shipzip,";
    $Query.="shipcountry,";
    $Query.="shiptelephone,";
    $Query.="message,";
    $Query.="invoice,";    
    $Query.="ip,";
    $Query.="referrerfirst,";
    $Query.="entryfirst,";
    $Query.="referrernow,";
    $Query.="entrynow,";                
    $Query.="total,";
    $Query.="tax,";    
    $Query.="shipping,";
    $Query.="fee,";
    $Query.="currency,";
    $Query.="method,";
    $Query.="custom1,";
    $Query.="custom2,";
    $Query.="custom3,";
    $Query.="custom4,";
    $Query.="discount,";
    $Query.="numitems,";
    $Query.="itemnumber,";
    $Query.="itemname,";
    $Query.="itemoptions,";
    $Query.="quantity,";
    $Query.="price,";
    $Query.="orderstatus";
    $Query.=") VALUES(";
    
    $Query.=pl_quote_smart($txn_id).",";
    $Query.=pl_quote_smart($parent_txn_id).",";
    $Query.=pl_quote_smart(date("Y-n-d H:i:s",time())).",";
    if ($manualorder){
      $Query.=pl_quote_smart("MANUAL-PAYPAL").",";
    }else if($checkoutMethod == "direct"){
      $Query.=pl_quote_smart("DIRECT").",";  
    }else if($checkoutMethod == "stripe"){
      $Query.=pl_quote_smart("STRIPE").","; 
    }else{
      $Query.=pl_quote_smart("PAYPAL").",";  
    }    
    $Query.=pl_quote_smart($first_name." ".$last_name).",";
    $Query.=pl_quote_smart($payer_business_name).",";
    $Query.=pl_quote_smart($address_street).",";
    $Query.=pl_quote_smart("").",";   // Steet 2 not used in Paypal
    $Query.=pl_quote_smart($address_city).",";
    $Query.=pl_quote_smart($address_state).",";
    $Query.=pl_quote_smart($address_zip).",";
    $Query.=pl_quote_smart($address_country).",";
    $Query.=pl_quote_smart($payer_email).",";
    $Query.=pl_quote_smart($telephone).",";  // Telephone not used in Paypal
    $Query.=pl_quote_smart("").",";  // Fax not used in Paypal
    $Query.=pl_quote_smart("").",";  // shipping address not used in Paypal
    $Query.=pl_quote_smart("").",";  // shipping address not used in Paypal
    $Query.=pl_quote_smart("").",";  // shipping address not used in Paypal
    $Query.=pl_quote_smart("").",";  // shipping address not used in Paypal
    $Query.=pl_quote_smart("").",";  // shipping address not used in Paypal
    $Query.=pl_quote_smart("").",";  // shipping address not used in Paypal
    $Query.=pl_quote_smart("").",";  // shipping address not used in Paypal
    $Query.=pl_quote_smart("").",";  // shipping address not used in Paypal
    $Query.=pl_quote_smart("").",";  // shipping telephone not used in Paypal
    $Query.=pl_quote_smart($memo).",";
    $Query.=pl_quote_smart($invoice).",";    
    if ($clientipaddr!="0.0.0.0")
      $Query.=pl_quote_smart($clientipaddr).",";
    else 
      $Query.=pl_quote_smart("").",";
    $Query.=pl_quote_smart("").",";
    $Query.=pl_quote_smart("").",";
    $Query.=pl_quote_smart("").",";
    $Query.=pl_quote_smart("").",";      
    $Query.=$mc_gross.",";
    $Query.=$tax.",";
    $Query.=$mc_shipping+$mc_handling.",";
    if(is_numeric ($mc_fee)) { $Query.=$mc_fee.","; } else { $Query.="0.00,"; }
    $Query.=pl_quote_smart($mc_currency).",";
    if ($manualorder) {  
      $Query.=pl_quote_smart("MANUAL").",";
    }else{
    	$Query.=pl_quote_smart($payment_type).","; 
    }   
	$Query.=pl_quote_smart($custom1).","; // custom1
	$Query.=pl_quote_smart($custom2).","; // custom2
	$Query.=pl_quote_smart($custom3).","; // custom3
	$Query.=pl_quote_smart($custom4).","; // custom4
	
    if (trim($discount)=="") {
      $Query.=pl_quote_smart("0.00").",";
    }else{ 
     $Query.=pl_quote_smart($discount).",";
    }
    if ($num_cart_items>0)
      $Query.=$num_cart_items.",";
    else  
      $Query.="1,";
    $Query.=pl_quote_smart($itemsordered).",";
    $Query.=pl_quote_smart($itemnamesordered).",";
    $Query.=pl_quote_smart($itemoptionsordered).",";
    $Query.=pl_quote_smart($itemqtysordered).",";
    $Query.=pl_quote_smart($itempricesordered).",";
    $Query.=pl_quote_smart("OK");

    $Query.=")";
    $mysql_result = pl_mysql_query($Query, $mysql_payloom);
    // Now update ip address which may only be know if called as return
    if ($calledasreturn)
    {
      $clip=$clientipaddr;
      if ($clientipaddr=="0.0.0.0")
        $clip=trim(strtok($_SERVER['REMOTE_ADDR'],","));
      $Query = "UPDATE " . $DbTableNameOrders . " SET ip='".$clip."' WHERE orderno='" . $txn_id . "'";
      $mysql_result = pl_mysql_query($Query, $mysql_payloom);
    }  
  }
  // If merchant refunds order
  if ($payment_status == "Refunded")
  {
    $Query = "UPDATE " . $DbTableNameOrders . " SET orderstatus='Refunded' WHERE orderno='" . $parent_txn_id . "'";
    $mysql_result = pl_mysql_query($Query, $mysql_payloom);
  }
  // If Paypal reverses order
  if (($payment_status == "Completed") && ($txn_type == "reversal"))
  {
    $Query = "UPDATE " . $DbTableNameOrders . " SET orderstatus='Reversed' WHERE orderno='" . $parent_txn_id . "'";
    $mysql_result = pl_mysql_query($Query, $mysql_payloom);
  }
  // If Paypal cancels reversed order (i.e. you won dispute)
  if (($payment_status == "Cancelled") && ($txn_type == "reversal"))
  {
    $Query = "UPDATE " . $DbTableNameOrders . " SET orderstatus='OK' WHERE orderno='" . $parent_txn_id . "'";
    $mysql_result = pl_mysql_query($Query, $mysql_payloom);
  }
}

function xfpassthru($file)
{
 global $downloadbuffer;
 if ($downloadbuffer>0)
 {
   @set_time_limit(86400); 
   while(!feof($file))
   {
      print(fread($file, $downloadbuffer));
      ob_flush();
      flush();
      sleep(1);
   }
   fclose($file);
 }
 else
   @fpassthru($file);
}

function callurl($url)
{
  InsertVariables($url);
  $url=str_replace("@","%40", $url);
  $url=str_replace(" ","%20", $url);
  if (function_exists('curl_init'))
  {
     $ch = curl_init();
     curl_setopt ($ch, CURLOPT_URL, $url);
     curl_setopt ($ch, CURLOPT_HEADER, false);
     curl_setopt ($ch, CURLOPT_RETURNTRANSFER, true);
     if ((strtolower(@ini_get("safe_mode")) != 'on') && (@ini_get("safe_mode") != '1') && (@ini_get("open_basedir") == ''))
       curl_setopt ($ch, CURLOPT_FOLLOWLOCATION, 1);
     curl_setopt ($ch, CURLOPT_TIMEOUT, 30);
     $buf=curl_exec($ch);
     curl_close ($ch);
  }
  else
  {
    if (!($fh=fopen($url,"rb")))
    {
      return("Could not contact page");
    }
    $buf="";
    do
    {
     $buf1 = fread($fh, 100000);
     if (strlen($buf1) == 0)
     {
         break;
     }
     $buf .= $buf1;
    }
    while (true);
    fclose($fh);
  }
  return ($buf);
}

function acrolok($filename,$email,$secretkey)
{
  $pos=strpos($filename,".");
  if (is_integer($pos))
    $filename=substr($filename,0,$pos);
  $primarykey=strtoupper(md5($filename.$email));
  $fileid=strtoupper(md5($filename));
  $secondarykey=strtoupper(md5($fileid.$secretkey));
  $serialnumberstring=$primarykey."-".$secondarykey;
  return($serialnumberstring);  
}


function get_s3_url($location,$expires,$operation="GET")
{
  // Split into access key id, secret access key, bucket , filename
  $parts=explode("|",$location);
  $accesskeyid=trim($parts[1]);
  $secretaccesskey=trim($parts[2]);
  $bucket=trim($parts[3]);
  $resource=trim($parts[4]);
  $filename=filename($resource);
  $extension=fileextension($resource);  
 
  $headers = array(
      'response-content-disposition' => 'attachment; filename=' . "\"".$filename."\"",
      'response-content-type' => 'application/force-download',
  );
  $resource = str_replace(array('%2F', '%2B'), array('/', '+'), rawurlencode($resource));

  $string_to_sign = $operation."\n\n\n$expires\n/$bucket/$resource";
  //$final_url = "http://s3.amazonaws.com/$bucket/$resource?";
  $final_url = "http://$bucket.s3.amazonaws.com/$resource?";
  $append_char = '?';
  foreach ($headers as $header => $value) {
      $final_url .= $header . '=' . urlencode($value) . '&';
      $string_to_sign .= $append_char . $header . '=' . $value;
      $append_char = '&';
  }

  $signature = urlencode(hex2b64(hmacsha1($secretaccesskey,$string_to_sign)));
  $final_url=$final_url . "AWSAccessKeyId=$accesskeyid&Expires=$expires&Signature=$signature&FixForIE=".$extension;
  return ($final_url); 
}

function filesize_s3($location)
{
  global $ServerTimeAdjust;
  $url=get_s3_url($location,time()+$ServerTimeAdjust,"HEAD");
  $size=filesize_remote($url);
  if ($size===false)
    return("Unknown");
  return($size);  
}

function hmacsha1($key,$data)
{
  $blocksize=64;
  $hashfunc='sha1';
  if (strlen($key)>$blocksize)
      $key=pack('H*', $hashfunc($key));
  $key=str_pad($key,$blocksize,chr(0x00));
  $ipad=str_repeat(chr(0x36),$blocksize);
  $opad=str_repeat(chr(0x5c),$blocksize);
  $hmac = pack(
              'H*',$hashfunc(
                  ($key^$opad).pack(
                      'H*',$hashfunc(
                          ($key^$ipad).$data
                      )
                  )
              )
          );
  return bin2hex($hmac);
}

function hex2b64($str)
{
  $raw = '';
  for ($i=0; $i < strlen($str); $i+=2) {
          $raw .= chr(hexdec(substr($str, $i, 2)));
  }
  return base64_encode($raw);
}

function XMLhandler($url,$page,$post_string)
{
  $header  = "POST ".$page." HTTP/1.0 \r\n";
  $header .= "MIME-Version: 1.0 \r\n";
  $header .= "Content-type: application/PTI26 \r\n";
  $header .= "Content-length: ".strlen($post_string)." \r\n";
  $header .= "Content-transfer-encoding: text \r\n";
  $header .= "Request-number: 1 \r\n";
  $header .= "Document-type: Request \r\n";
  $header .= "Interface-Version: Test 1.4 \r\n";
  $header .= "Connection: close \r\n\r\n";
  $header .= $post_string;
  
  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL,$url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt($ch, CURLOPT_TIMEOUT, 4); 
  curl_setopt($ch, CURLOPT_CUSTOMREQUEST, $header);
  
  $data = curl_exec($ch);
  if (curl_errno($ch))
    print curl_error($ch);
  else
    curl_close($ch);
  return($data);  
}

function getStateCode($name)
{
  $states=array(
  'alabama'=>'AL',
  'alaska'=>'AK',
  'arizona'=>'AZ',
  'arkansas'=>'AR',
  'california'=>'CA',
  'colorado'=>'CO',
  'connecticut'=>'CT',
  'delaware'=>'DE',
  'district of columbia'=>'DC',
  'florida'=>'FL',
  'georgia'=>'GA',
  'hawaii'=>'HI',
  'idaho'=>'ID',
  'illinois'=>'IL',
  'indiana'=>'IN',
  'iowa'=>'IA',
  'kansas'=>'KS',
  'kentucky'=>'KY',
  'louisiana'=>'LA',
  'maine'=>'ME',
  'maryland'=>'MD',
  'massachusetts'=>'MA',
  'michigan'=>'MI',
  'minnesota'=>'MN',
  'mississippi'=>'MS',
  'missouri'=>'MO',
  'montana'=>'MT',
  'nebraska'=>'NE',
  'nevada'=>'NV',
  'new hampshire'=>'NH',
  'new jersey'=>'NJ',
  'new mexico'=>'NM',
  'new york'=>'NY',
  'north carolina'=>'NC',
  'north dakota'=>'ND',
  'ohio'=>'OH',
  'oklahoma'=>'OK',
  'oregon'=>'OR',
  'pennsylvania'=>'PA',
  'puerto rico'=>'PR',
  'rhode island and providence plantations'=>'RI',
  'rhode island'=>'RI',
  'south carolina'=>'SC',
  'south dakota'=>'SD',
  'tennessee'=>'TN',
  'texas'=>'TX',
  'utah'=>'UT',
  'vermont'=>'VT',
  'virginia'=>'VA',
  'washington'=>'WA',
  'west virginia'=>'WV',
  'wisconsin'=>'WI',
  'wyoming'=>'WY',
  'alberta'=>'AB',
  'british columbia'=>'BC', 
  'ontario'=>'ON', 
  'newfoundland and labrador'=>'ON', 
  'nova scotia'=>'NS', 
  'prince edward island'=>'PE', 
  'new brunswick'=>'NB', 
  'quebec'=>'QC', 
  'manitoba'=>'MB', 
  'saskatchewan'=>'SK', 
  'northwest territories'=>'NT', 
  'nunavut'=>'NU',
  'yukon territory'=>'YT',        
  'alberta'=>'AB',
  'colombie-britannique'=>'BC',
  'manitoba'=>'MB',
  'nouveau-brunswick'=>'NB',
  'terre-neuve-et-labrador'=>'NL',
  'nouvelle-ecosse'=>'NS',
  'territoires du nord-ouest'=>'NT',
  'nunavut'=>'NU',
  'ontario'=>'ON',
  'ile-du-prince-edouard'=>'PE',
  'quebec'=>'QC',
  'saskatchewan'=>'SK',
  'yukon'=>'YT'
  );
  $name=trim($name);
  $name=str_replace("  "," ",$name);
  $name=strtolower($name);
  $code=$states[$name];
  if ($code=="")
    return($name);    
  return($code);
}

function getUniformCountryName($countrycode)
{
  $countries=array(
  "AF"=>"Afghanistan",
  "AFG"=>"Afghanistan",
  "AX"=>"Aland Islands",
  "ALB"=>"Albania",
  "DZ"=>"Algeria",
  "DZA"=>"Algeria",
  "AS"=>"American Samoa",
  "ASM"=>"American Samoa",
  "AD"=>"Andorra",
  "AND"=>"Andorra",
  "AO"=>"Angola",
  "AGO"=>"Angola",
  "AI"=>"Anguilla",
  "AIA"=>"Anguilla",
  "AQ"=>"Antarctica",
  "ATA"=>"Antarctica",
  "AG"=>"Antigua and Barbuda",
  "ATG"=>"Antigua and Barbuda",
  "AR"=>"Argentina",
  "ARG"=>"Argentina",
  "AM"=>"Armenia",
  "ARM"=>"Armenia",
  "AW"=>"Aruba",
  "ABW"=>"Aruba",
  "AU"=>"Australia",
  "AUS"=>"Australia",
  "AT"=>"Austria",
  "AUT"=>"Austria",
  "AZ"=>"Azerbaijan",
  "AZE"=>"Azerbaijan",
  "BS"=>"Bahamas",
  "BHS"=>"Bahamas",
  "BH"=>"Bahrain",
  "BHR"=>"Bahrain",
  "BD"=>"Bangladesh",
  "BGD"=>"Bangladesh",
  "BB"=>"Barbados",
  "BRB"=>"Barbados",
  "BY"=>"Belarus",
  "BLR"=>"Belarus",
  "BE"=>"Belgium",
  "BEL"=>"Belgium",
  "BZ"=>"Belize",
  "BLZ"=>"Belize",
  "BJ"=>"Benin",
  "BEN"=>"Benin",
  "BM"=>"Bermuda",
  "BMU"=>"Bermuda",
  "BT"=>"Bhutan",
  "BTN"=>"Bhutan",
  "BO"=>"Bolivia",
  "BOL"=>"Bolivia",
  "BA"=>"Bosnia",
  "BIH"=>"Bosnia",
  "BW"=>"Botswana",
  "BWA"=>"Botswana",
  "BV"=>"Bouvet Island",
  "BVT"=>"Bouvet Island",
  "BR"=>"Brazil",
  "BRA"=>"Brazil",
  "IO"=>"British Indian Ocean T",
  "IOT"=>"British Indian Ocean T",
  "BN"=>"Brunei Darussalam",
  "BRN"=>"Brunei Darussalam",
  "BG"=>"Bulgaria",
  "BGR"=>"Bulgaria",
  "BF"=>"Burkina Faso",
  "BFA"=>"Burkina Faso",
  "BI"=>"Burundi",
  "BDI"=>"Burundi",
  "KH"=>"Cambodia",
  "KHM"=>"Cambodia",
  "CM"=>"Cameroon",
  "CMR"=>"Cameroon",
  "CA"=>"Canada",
  "CAN"=>"Canada",
  "CV"=>"Cape Verde",
  "CPV"=>"Cape Verde",
  "KY"=>"Cayman Islands",
  "CYM"=>"Cayman Islands",
  "CF"=>"Central African Republic",
  "CAF"=>"Central African Republic",
  "TD"=>"Chad",
  "TCD"=>"Chad",
  "CL"=>"Chile",
  "CHL"=>"Chile",
  "CN"=>"China",
  "CHN"=>"China",
  "CX"=>"Christmas Island",
  "CXR"=>"Christmas Island",
  "CC"=>"Cocos (Keeling) Islands",
  "CCK"=>"Cocos (Keeling) Islands",
  "CO"=>"Colombia",
  "COM"=>"Colombia",
  "KM"=>"Comoros",
  "CG"=>"Congo",
  "COG"=>"Congo",
  "CD"=>"Democratic Republic of Congo",
  "COD"=>"Democratic Republic of Congo",
  "CK"=>"Cook Islands",
  "COK"=>"Cook Islands",
  "CR"=>"Costa Rica",
  "CR"=>"Costa Rica",
  "CRI"=>"Cote D'Ivoire",
  "CIV"=>"Cote D'Ivoire",
  "HR"=>"Croatia",
  "HRV"=>"Croatia",
  "CU"=>"Cuba",
  "CY"=>"Cyprus",
  "CYP"=>"Cyprus",
  "CZ"=>"Czech Republic",
  "CZE"=>"Czech Republic",
  "DK"=>"Denmark",
  "DNK"=>"Denmark",
  "DJ"=>"Djibouti",
  "DJI"=>"Djibouti",
  "DM"=>"Dominica",
  "DMA"=>"Dominica",
  "DO"=>"Dominican Republic",
  "DOM"=>"Dominican Republic",
  "EC"=>"Ecuador",
  "ECU"=>"Ecuador",
  "EG"=>"Egypt",
  "EGY"=>"Egypt",
  "SV"=>"El Salvador",
  "SLV"=>"El Salvador",
  "GQ"=>"Equatorial Guinea",
  "GNQ"=>"Equatorial Guinea",
  "ER"=>"Eritrea",
  "ERI"=>"Eritrea",
  "EE"=>"Estonia",
  "EST"=>"Estonia",
  "ET"=>"Ethiopia",
  "ETH"=>"Ethiopia",
  "FK"=>"Falkland Islands",
  "FLK"=>"Falkland Islands",
  "FO"=>"Faroe Islands",
  "FRO"=>"Faroe Islands",
  "FJ"=>"Fiji",
  "FJI"=>"Fiji",
  "FI"=>"Finland",
  "FIN"=>"Finland",
  "FR"=>"France",
  "FRA"=>"France",
  "GF"=>"French Guiana",
  "GUF"=>"French Guiana",
  "PF"=>"French Polynesia",
  "PYF"=>"French Polynesia",
  "TF"=>"French Southern Territories",
  "ATF"=>"French Southern Territories",
  "GA"=>"Gabon",
  "GAB"=>"Gabon",
  "GM"=>"Gambia",
  "GMB"=>"Gambia",
  "GE"=>"Georgia",
  "GEO"=>"Georgia",
  "DE"=>"Germany",
  "DEU"=>"Germany",
  "GH"=>"Ghana",
  "GHA"=>"Ghana",
  "GI"=>"Gibraltar",
  "GIB"=>"Gibraltar",
  "GR"=>"Greece",
  "GRC"=>"Greece",
  "GL"=>"Greenland",
  "GRL"=>"Greenland",
  "GD"=>"Grenada",
  "GRD"=>"Grenada",
  "GP"=>"Guadeloupe",
  "GLP"=>"Guadeloupe",
  "GU"=>"Guam",
  "GUM"=>"Guam",
  "GT"=>"Guatemala",
  "GTM"=>"Guatemala",
  "GG"=>"Guernsey",
  "GN"=>"Guinea",
  "GIN"=>"Guinea",
  "GW"=>"Guinea-Bissau",
  "GNB"=>"Guinea-Bissau",
  "GY"=>"Guyana",
  "GUY"=>"Guyana",
  "HT"=>"Haiti",
  "HTI"=>"Haiti",
  "HM"=>"Heard and Mc Donald Isls",
  "HMD"=>"Heard and Mc Donald Isls",
  "VA"=>"Holy See, Vatican City",
  "VAT"=>"Holy See, Vatican City",
  "HN"=>"Honduras",
  "HND"=>"Honduras",
  "HK"=>"Hong Kong",
  "HKG"=>"Hong Kong",
  "HU"=>"Hungary",
  "HUN"=>"Hungary",
  "IS"=>"Iceland",
  "ISL"=>"Iceland",
  "IN"=>"India",
  "IND"=>"India",
  "ID"=>"Indonesia",
  "IDN"=>"Indonesia",
  "IR"=>"Iran",
  "IQ"=>"Iraq",
  "IRQ"=>"Iraq",
  "IE"=>"Ireland",
  "IRL"=>"Ireland",
  "IM"=>"Isle of Man",
  "IL"=>"Israel",
  "ISR"=>"Israel",
  "IT"=>"Italy",
  "ITA"=>"Italy",
  "JM"=>"Jamaica",
  "JAM"=>"Jamaica",
  "JP"=>"Japan",
  "JPN"=>"Japan",
  "JE"=>"Jersey",
  "JO"=>"Jordan",
  "JOR"=>"Jordan",
  "KZ"=>"Kazakhstan",
  "KAZ"=>"Kazakhstan",
  "KE"=>"Kenya",
  "KEN"=>"Kenya",
  "KI"=>"Kiribati",
  "KIR"=>"Kiribati",
  "KP"=>"Korea Democratic Peoples R",
  "KR"=>"Korea Republic",
  "KOR"=>"Korea Republic",
  "KW"=>"Kuwait",
  "KWT"=>"Kuwait",
  "KG"=>"Kyrgyzstan",
  "KGZ"=>"Kyrgyzstan",
  "LA"=>"Lao People's Dem Repub",
  "LAO"=>"Lao People's Dem Repub",
  "LV"=>"Latvia",
  "LB"=>"Lebanon",
  "LBN"=>"Lebanon",
  "LS"=>"Lesotho",
  "LSO"=>"Lesotho",
  "LR"=>"Liberia",
  "LBR"=>"Liberia",
  "LY"=>"Libyan Arab Jamahiriya",
  "LBY"=>"Libyan Arab Jamahiriya",
  "LI"=>"Liechtenstein",
  "LIE"=>"Liechtenstein",
  "LT"=>"Lithuania",
  "LTU"=>"Lithuania",
  "LU"=>"Luxembourg",
  "LUX"=>"Luxembourg",
  "MO"=>"Macao",
  "MAC"=>"Macao",
  "MK"=>"Macedonia",
  "MKD"=>"Macedonia",
  "MG"=>"Madagascar",
  "MDG"=>"Madagascar",
  "MW"=>"Malawi",
  "MWI"=>"Malawi",
  "MY"=>"Malaysia",
  "MYS"=>"Malaysia",
  "MV"=>"Maldives",
  "MDV"=>"Maldives",
  "ML"=>"Mali",
  "MLI"=>"Mali",
  "MT"=>"Malta",
  "MLT"=>"Malta",
  "MH"=>"Marshall Islands",
  "MHL"=>"Marshall Islands",
  "MQ"=>"Martinique",
  "MTQ"=>"Martinique",
  "MR"=>"Mauritania",
  "MRT"=>"Mauritania",
  "MU"=>"Mauritius",
  "MUS"=>"Mauritius",
  "YT"=>"Mayotte",
  "MYT"=>"Mayotte",
  "MX"=>"Mexico",
  "MEX"=>"Mexico",
  "FM"=>"Micronesia",
  "FSM"=>"Micronesia",
  "MD"=>"Moldova",
  "MDA"=>"Moldova",
  "MC"=>"Monaco",
  "MCO"=>"Monaco",
  "MN"=>"Mongolia",
  "MNG"=>"Mongolia",
  "ME"=>"Montenegro",
  "MNE"=>"Montenegro",
  "MS"=>"Montserrat",
  "MSR"=>"Montserrat",
  "MA"=>"Morocco",
  "MAR"=>"Morocco",
  "MZ"=>"Mozambique",
  "MOZ"=>"Mozambique",
  "MM"=>"Myanmar",
  "MMR"=>"Myanmar",
  "NA"=>"Namibia",
  "NAM"=>"Namibia",
  "NR"=>"Nauru",
  "NRU"=>"Nauru",
  "NP"=>"Nepal",
  "NPL"=>"Nepal",
  "NL"=>"Netherlands",
  "NLD"=>"Netherlands",
  "AN"=>"Netherlands Antilles",
  "ANT"=>"Netherlands Antilles",
  "NC"=>"New Caledonia",
  "NCL"=>"New Caledonia",
  "NZ"=>"New Zealand",
  "NZL"=>"New Zealand",
  "NI"=>"Nicaragua",
  "NIC"=>"Nicaragua",
  "NE"=>"Niger",
  "NER"=>"Niger",
  "NG"=>"Nigeria",
  "NGA"=>"Nigeria",
  "NU"=>"Niue",
  "NIU"=>"Niue",
  "NF"=>"Norfolk Island",
  "NFK"=>"Norfolk Island",
  "MP"=>"Northern Mariana Islands",
  "MNP"=>"Northern Mariana Islands",
  "NO"=>"Norway",
  "NOR"=>"Norway",
  "OM"=>"Oman",
  "OMN"=>"Oman",
  "PK"=>"Pakistan",
  "PAK"=>"Pakistan",
  "PW"=>"Palau",
  "PLW"=>"Palau",
  "PS"=>"Palestinian Territory",
  "PSE"=>"Palestinian Territory",
  "PA"=>"Panama",
  "PAN"=>"Panama",
  "PG"=>"Papua New Guinea",
  "PNG"=>"Papua New Guinea",
  "PY"=>"Paraguay",
  "PRY"=>"Paraguay",
  "PE"=>"Peru",
  "PER"=>"Peru",
  "PH"=>"Philippines",
  "PHL"=>"Philippines",
  "PN"=>"Pitcairn Island",
  "PCN"=>"Pitcairn Island",
  "PL"=>"Poland",
  "POL"=>"Poland",
  "PT"=>"Portugal",
  "PRT"=>"Portugal",
  "PR"=>"Puerto Rico",
  "PRI"=>"Puerto Rico",
  "QA"=>"Qatar",
  "QAT"=>"Qatar",
  "RE"=>"Reunion",
  "REU"=>"Reunion",
  "RO"=>"Romania",
  "ROU"=>"Romania",
  "RU"=>"Russian Federation",
  "RUS"=>"Russian Federation",
  "RW"=>"Rwanda",
  "RWA"=>"Rwanda",
  "BL"=>"Saint Barthelemy",
  "SH"=>"Saint Helena",
  "SHN"=>"Saint Helena",
  "KN"=>"Saint Kitts and Nevis",
  "KNA"=>"Saint Kitts and Nevis",
  "LC"=>"Saint Lucia",
  "LCA"=>"Saint Lucia",
  "MF"=>"Saint Martin",
  "PM"=>"St. Pierre and Miquelon",
  "SPM"=>"St. Pierre and Miquelon",
  "VC"=>"Saint Vincent and Grenadines",
  "VCT"=>"Saint Vincent and Grenadines",
  "WS"=>"Samoa",
  "WSM"=>"Samoa",
  "SM"=>"San Marino",
  "SMR"=>"San Marino",
  "ST"=>"Sao Tome and Principe",
  "STP"=>"Sao Tome and Principe",
  "SA"=>"Saudi Arabia",
  "SAU"=>"Saudi Arabia",
  "SN"=>"Senegal",
  "SEN"=>"Senegal",
  "RS"=>"Serbia",
  "SRB"=>"Serbia",
  "SC"=>"Seychelles",
  "SYC"=>"Seychelles",
  "SL"=>"Sierra Leone",
  "SLE"=>"Sierra Leone",
  "SG"=>"Singapore",
  "SGP"=>"Singapore",
  "SK"=>"Slovakia",
  "SVK"=>"Slovakia",
  "SI"=>"Slovenia",
  "SVN"=>"Slovenia",
  "SB"=>"Solomon Islands",
  "SLB"=>"Solomon Islands",
  "SO"=>"Somalia",
  "SOM"=>"Somalia",
  "ZA"=>"South Africa",
  "ZAF"=>"South Africa",
  "GS"=>"South Georgia",
  "SGS"=>"South Georgia",
  "ES"=>"Spain",
  "ESP"=>"Spain",
  "LK"=>"Sri Lanka",
  "LKA"=>"Sri Lanka",
  "SD"=>"Sudan",
  "SR"=>"Suriname",
  "SUR"=>"Suriname",
  "SJ"=>"Svalbard and Jan Mayen Is",
  "SJM"=>"Svalbard and Jan Mayen Is",
  "SZ"=>"Swaziland",
  "SWZ"=>"Swaziland",
  "SE"=>"Sweden",
  "SWE"=>"Sweden",
  "CH"=>"Switzerland",
  "CHE"=>"Switzerland",
  "SY"=>"Syrian Arab Republic",
  "TW"=>"Taiwan",
  "TWN"=>"Taiwan",
  "TJ"=>"Tajkistan",
  "TJK"=>"Tajkistan",
  "TZ"=>"Tanzania ",
  "TZA"=>"Tanzania ",
  "TH"=>"Thailand",
  "THA"=>"Thailand",
  "TL"=>"Timor",
  "TLS"=>"Timor",
  "TG"=>"Togo",
  "TGO"=>"Togo",
  "TK"=>"Tokelau",
  "TKL"=>"Tokelau",
  "TO"=>"Tonga",
  "TON"=>"Tonga",
  "TT"=>"Trinidad and Tobago",
  "TTO"=>"Trinidad and Tobago",
  "TN"=>"Tunisia",
  "TUN"=>"Tunisia",
  "TR"=>"Turkey",
  "TUR"=>"Turkey",
  "TM"=>"Turkmenistan",
  "TKM"=>"Turkmenistan",
  "TC"=>"Turks and Caicos Islands",
  "TCA"=>"Turks and Caicos Islands",
  "TV"=>"Tuvalu",
  "TUV"=>"Tuvalu",
  "UG"=>"Uganda",
  "UGA"=>"Uganda",
  "UA"=>"Ukraine",
  "UKR"=>"Ukraine",
  "AE"=>"United Arab Emirates",
  "ARE"=>"United Arab Emirates",
  "GB"=>"United Kingdom",
  "GBR"=>"United Kingdom",
  "US"=>"United States",
  "USA"=>"United States",
  "UM"=>"United States Outlying Islands",
  "UMI"=>"United States Outlying Islands",
  "UY"=>"Uruguay",
  "URY"=>"Uruguay",
  "UZ"=>"Uzbekistan",
  "UZB"=>"Uzbekistan",
  "VU"=>"Vanuatu",
  "VUT"=>"Vanuatu",
  "VE"=>"Venezuela",
  "VEN"=>"Venezuela",
  "VN"=>"Viet Nam",
  "VNM"=>"Viet Nam",
  "VG"=>"Virgin Islands (British)",
  "VGB"=>"Virgin Islands (British)",
  "VI"=>"Virgin Islands (U.S.)",
  "VIR"=>"Virgin Islands (U.S.)",
  "WF"=>"Wallis and Futuna Islands",
  "WLF"=>"Wallis and Futuna Islands",
  "EH"=>"Western Sahara",
  "ESH"=>"Western Sahara",
  "YE"=>"Yemen",
  "YEM"=>"Yemen",
  "ZM"=>"Zambia",
  "ZMB"=>"Zambia",
  "ZW"=>"Zimbabwe",
  "ZWE"=>"Zimbabwe",
  // Other entries
  "UK"=>"United Kingdom",
  "ENGLAND"=>"United Kingdom",
  "SCOTLAND"=>"United Kingdom",
  "WALES"=>"United Kingdom",
  "EIRE"=>"United Kingdom",
  "NORTHERN IRELAND"=>"United Kingdom"
  );
  $countrycode=trim($countrycode);
  $countrycode=str_replace("  "," ",$countrycode);
//  $countrycode=strtoupper($countrycode);
  $code=$countries[$countrycode];
  if ($code=="")
    return($countrycode);    
  return($code);
}

function pl_validemail($email)
{
  return(preg_match("/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$/i", $email));
}


function pl_MailchimpSubscribe($mclistid,$prodnum)
{
  global $mailchimpapikey,$payer_email,$first_name,$last_name;
  $MailChimp = new MailChimp($mailchimpapikey);
  $result = $MailChimp->call('lists/subscribe', array(
                'id'                => $mclistid,
                'email'             => array('email'=>$payer_email),
                'merge_vars'        => array('FNAME'=>$first_name, 'LNAME'=>$last_name),
                'double_optin'      => false,
                'update_existing'   => false,
                'replace_interests' => false,
                'send_welcome'      => true,
            ));
  if ((isset($result['status'])) && ($result['status']=="error"))
    $mcerror=false;
  else
    $mcerror=true;
}

function pl_pdfhoneypot($pdf,$email,$ip,$secret,$url)
{
  $hash=md5($pdf.$email.$ip.$secret);
  $link=$url."/secure.php?pdf=".$pdf."&email=".$email."&ip=".$ip."&hash=".$hash;
  return($link);
}

function pl_rangeDownload($file) {
  global $fname, $txn_id, $expiry,$NotifyDownloadEmail,$item_number,$desc,$email,$downloadbuffer;
  $fp = @fopen($file, 'rb'); 
  $size   = filesize($file); // File size
  $length = $size;           // Content length
  $start  = 0;               // Start byte
  $end    = $size - 1;       // End byte
   /* Multiple ranges requires some more work to ensure it works correctly
   * and comply with the specifications: http://www.w3.org/Protocols/rfc2616/rfc2616-sec19.html#sec19.2
   *
   * Multirange support annouces itself with:
   * header('Accept-Ranges: bytes');
   *
   * Multirange content must be sent with multipart/byteranges mediatype,
   * (mediatype = mimetype)
   * as well as a boundry header to indicate the various chunks of data.
   */
//  header("Accept-Ranges: 0-$length");
  header("Accept-Ranges: bytes");
  // header('Accept-Ranges: bytes');
  // multipart/byteranges
  // http://www.w3.org/Protocols/rfc2616/rfc2616-sec19.html#sec19.2
  if (isset($_SERVER['HTTP_RANGE'])) {
 
    $c_start = $start;
    $c_end   = $end;
    // Extract the range string
    list(, $range) = explode('=', $_SERVER['HTTP_RANGE'], 2);
    // Make sure the client hasn't sent us a multibyte range
    if (strpos($range, ',') !== false) {
 
      // (?) Shoud this be issued here, or should the first
      // range be used? Or should the header be ignored and
      // we output the whole content?
      header('HTTP/1.1 416 Requested Range Not Satisfiable');
      header("Content-Range: bytes $start-$end/$size");
      // (?) Echo some info to the client?
      exit;
    }
    // If the range starts with an '-' we start from the beginning
    // If not, we forward the file pointer
    // And make sure to get the end byte if specified
    if ($range0 == '-') {
      if ($NotifyDownloadEmail != "")
        EmailDownloadNotify($fname, $item_number, $desc, $txn_id, trim(strtok($_SERVER['REMOTE_ADDR'],",")), $expiry, $email);
      // The n-number of the last bytes is requested
      $c_start = $size - substr($range, 1);
    }
    else {
 
      $range  = explode('-', $range);
      $c_start = $range[0];
      $c_end   = (isset($range[1]) && is_numeric($range[1])) ? $range[1] : $size;
    }
    /* Check the range and make sure it's treated according to the specs.
     * http://www.w3.org/Protocols/rfc2616/rfc2616-sec14.html
     */
    // End bytes can not be larger than $end.
    $c_end = ($c_end > $end) ? $end : $c_end;
    // Validate the requested range and return an error if it's not correct.
    if ($c_start > $c_end || $c_start > $size - 1 || $c_end >= $size) {
 
      header('HTTP/1.1 416 Requested Range Not Satisfiable');
      header("Content-Range: bytes $start-$end/$size");
      // (?) Echo some info to the client?
      exit;
    }
    $start  = $c_start;
    $end    = $c_end;
    $length = $end - $start + 1; // Calculate new content length
    fseek($fp, $start);
    header('HTTP/1.1 206 Partial Content');
  }
  // Notify the client the byte range we'll be outputting
  header("Content-Range: bytes $start-$end/$size");
  header("Content-Length: $length");
  // Start buffered download
  if ($downloadbuffer>0)
    $buffer=$downloadbuffer;
  else    
    $buffer = 1024 * 8;
  @set_time_limit(86400); 
  while(!feof($fp) && ($p = ftell($fp)) <= $end) {
 
    if ($p + $buffer > $end) {
 
      // In case we're only outputtin a chunk, make sure we don't
      // read past the length
      $buffer = $end - $p + 1;
    }
    echo fread($fp, $buffer);
    ob_flush();
    flush(); // Free up memory. Otherwise large files will trigger PHP's memory limit.
    if ($downloadbuffer>0)
      sleep(1);  
  }
  fclose($fp);
}

function pl_getmimetype($fn)
{
  $mt['.jpg']="image/jpeg";
  $mt['.gif']="image/gif";
  $mt['.cgm']="image/cgm";
  $mt['.flv']="video/x-flv";
  $mt['.gif']="image/gif";
  $mt['.htm']="text/html";
  $mt['.html']="text/html";
  $mt['.txt']="text/plain";
  $mt['.pdf']="application/pdf";
  $mt['.m4v']="video/x-m4v";
  $mt['.mov']="video/quicktime";
  $mt['.mp3']="audio/mpeg";
  $mt['.mp4']="video/mp4";
  $mt['.mpg']="video/mpeg";
  $mt['.mpeg']="video/mpeg";
  $mt['.pdf']="application/pdf";
  $mt['.png']="image/png";
  $mt['.rm']="audio/x-pn-realaudio";
  $mt['.wmv']="application/x-ms-wmv";
  $mt['.swf']="application/x-shockwave-flash";
  $mt['.mov']="video/quicktime";
  $mt['.asf']="video/x-ms-asf";
  $mt['.asx']="video/x-ms-asf";
  $mt['.rm']="audio/x-realaudio";
  $mt['.ram']="audio/x-pn-realaudio";
  $mt['.rar']="application/x-rar-compressed";
  $mt['.zip']="application/zip";
  $ext=fileextension($fn);
  if (isset($mt[$ext]))
    $mimetype=$mt[$ext];
  else
    $mimetype="";
  return("$mimetype");
}

function pl_get_magic_quotes_gpc()
{
  if (version_compare(PHP_VERSION, '5.4.0') < 0)
    return(get_magic_quotes_gpc());
  else
    return(0);  
}

function userfunction($data, $user1, $user2, $user3, $user4)
{
  global $first_name, $last_name, $payer_business_name, $custom;
  if (($data == "") || ($data == "NOTREQUIRED"))
    $key = "";
  // Place your code here. At the end of your code the string variable $key
  // should contain the value that will be sent to the user.
  $key = "123456";
  return (string)$key;
}

// Added to break this into its own function  -MY
function getManualFormProducts()
{
  global $Products, $ProductDelimiter, $DefaultLocation, $numberofproducts, $payer_email;
  
  $prods = '';
  
for ($i = 1;$i <= 20;$i++)
  {
    $fnum = "item_number" . $i;
    $prods .= "<tr>\n";
    $prods .= "<td style=\"width:100px\" class=\"text-right\"><label>Item $i</label></td>\n";
    if (($numberofproducts <= 500) && ((($DefaultLocation==""))))
    {
      
        $prods .= "<td><select name=\"item_number$i\" class=\"form-control\">\n";
        if (isset($$fnum) && $$fnum == "")
          $prods .= "<option selected value=\"\">Select Product</option>\n";
        else
          $prods .= "<option value=\"\">Select Product</option>\n";
        for ($k = 0;$k < $numberofproducts;$k++)
        {
          $in = strtok($Products[$k], $ProductDelimiter);
          $id = strtok($ProductDelimiter);
          if ((isset($$fnum)) && ($$fnum != "") && ($$fnum == $in))
            $prods .= "<option selected value=\"$in\">$in - $id</option>\n";
          else
            $prods .= "<option value=\"$in\">$in - $id</option>\n";
        }
        $prods .= "</select>\n";
        
    }
    else
    {
      $prods .= "<td><input type=\"text\" class=\"form-control\" name=\"item_number$i\" size=\"30\" value=\"" . $$fnum . "\">\n";
    }
    
    if (($payer_email == "") && (isset($$fnum)) && ($$fnum != ""))
    {
      $res = GetProductDetails($$fnum, "", $cost, $desc, $link, $size, $exp, $extra);
      if ($res != 0)
      {
        $combos = explode(":", $link);
        if ((count($combos) == 1) || (substr(strtolower($link), 0, 5) == "http:") || (substr($link, 1, 2) == ":/"))
        {        
          if ($newexpiry != -1)
            $exp = $newexpiry;
          if ($exp != 0)
          {
            if (strlen($exp) == 12)
            {
              $expiry = mktime(substr($exp, 8, 2), substr($exp, 10, 2), 0, substr($exp, 4, 2), substr($exp, 6, 2), substr($exp, 0, 4), -1);
              $exp = ($expiry - time()) / 60;
            }
            else
              $expiry = time() + ($exp * 60);
          }
          else
            $expiry = 0;
          $ipleveltouse = 0;
          if (isset($IPlock))
            $ipleveltouse = $IPlock;
          if ($manualiplevel != "-1")
            $ipleveltouse = $manualiplevel;
          else
          {
            $pos = strpos($extra, "IPLOCK=");
            if (is_integer($pos))
              $ipleveltouse = substr($extra, $pos + 7, 1);
          }
          $plink = GetSecureLink($link, $$fnum, $expiry, $txn_id, $manualipaddr, $ipleveltouse, $payer_email);
          $fnameonly = filename($link);
          $prods .= "&nbsp;&nbsp;&nbsp;<a href=\"$plink\" target=\"_linklok\">$fnameonly</a>";
        }
        else
          $prods .= "&nbsp;&nbsp;&nbsp;Bundle";                
      }
    }
    $prods .= "</td></tr>\n";
  }
  
  return $prods;
}


function setupPayloomDatabase()
{
  global $DbHostPayloom, $DbUserPayloom, $DbPasswordPayloom, $DbNamePayloom, $DbTableNameOrders, $mysql_payloom;
  global $Debug;
  
  if($Debug){ echo "# SETUPPAYLOOMDATABASE() CALLED<br>".PHP_EOL; }
  
  $result = pl_mysql_query("SHOW TABLES LIKE '".$DbTableNameOrders."'", $mysql_payloom);
  
  if(!$result->num_rows)
  {
      if($Debug){ echo "# CREATING $DbTableNameOrders.$DbTableNameOrders in MYSQL<br>".PHP_EOL; }
      
      $sql= "CREATE TABLE ".$DbTableNameOrders." (";
      $sql.="orderno VARCHAR( 255 ) NOT NULL ,";
      $sql.="parentorderno VARCHAR( 255 ) ,";
      $sql.="datetime DATETIME,";
      $sql.="processor VARCHAR( 255 ) ,";
      $sql.="name VARCHAR( 255 ) ,";
      $sql.="company VARCHAR( 255 ) ,";
      $sql.="street1 VARCHAR( 255 ) ,";
      $sql.="street2 VARCHAR( 255 ) ,";
      $sql.="city VARCHAR( 255 ) ,";
      $sql.="state VARCHAR( 255 ) ,";
      $sql.="zip VARCHAR( 255 ) ,";
      $sql.="country VARCHAR( 255 ) ,";
      $sql.="email VARCHAR( 255 ) ,";
      $sql.="telephone VARCHAR( 255 ) ,";
      $sql.="fax VARCHAR( 255 ) ,";
      $sql.="shipname VARCHAR( 255 ) ,";
      $sql.="shipcompany VARCHAR( 255 ) ,";
      $sql.="shipstreet1 VARCHAR( 255 ) ,";
      $sql.="shipstreet2 VARCHAR( 255 ) ,";
      $sql.="shipcity VARCHAR( 255 ) ,";
      $sql.="shipstate VARCHAR( 255 ) ,";
      $sql.="shipzip VARCHAR( 255 ) ,";
      $sql.="shipcountry VARCHAR( 255 ) ,";
      $sql.="shiptelephone VARCHAR( 255 ) ,";
      $sql.="message TEXT,";
      $sql.="invoice VARCHAR( 255) ,";
      $sql.="ip VARCHAR( 50 ) ,";
      $sql.="referrerfirst VARCHAR( 255 ) ,";
      $sql.="entryfirst VARCHAR( 255 ) ,";
      $sql.="referrernow VARCHAR( 255 ) ,";
      $sql.="entrynow VARCHAR( 255 ) ,";
      $sql.="total DECIMAL( 10,2 ) DEFAULT 0.00,";
      $sql.="tax DECIMAL( 10,2 ) DEFAULT 0.00,";
      $sql.="shipping DECIMAL( 10,2 ) DEFAULT 0.00,";
      $sql.="fee DECIMAL( 10,2 ) DEFAULT 0.00,";
      $sql.="currency VARCHAR( 4 ) ,";
      $sql.="method VARCHAR( 255 ) ,";
      $sql.="custom1 VARCHAR( 255 ) ,";
      $sql.="custom2 VARCHAR( 255 ) ,";
      $sql.="custom3 VARCHAR( 255 ) ,";
      $sql.="custom4 VARCHAR( 255 ) ,";
      $sql.="discount DECIMAL( 10,2 ) DEFAULT 0.00,";
      $sql.="numitems INT DEFAULT 0,";
      $sql.="itemnumber TEXT,";
      $sql.="itemname TEXT,";
      $sql.="itemoptions TEXT,";
      $sql.="quantity TEXT,";
      $sql.="price TEXT,";
      $sql.="ipn VARCHAR( 1 ) DEFAULT 'N',";
      $sql.="`return` VARCHAR( 1 ) DEFAULT 'N',";
      $sql.="orderstatus VARCHAR( 255 ) ,";
      $sql.="serialnumber TEXT,";
      $sql.="userfunction TEXT,";
      $sql.="PRIMARY KEY (orderno))";
      
      $rs = pl_mysql_query($sql, $mysql_payloom);
     
    if ($rs->error) { 
        return 'MySQL error '.$rs->error.' When executing: '.$sql;  
      }else{
        return 'good';
      }

    }
  
  
}

function getOrders()
{
  global $DbTableNameOrders, $mysql_payloom;
  
  $rs="";
  
  if ($DbTableNameOrders!="")
    {
      $query="SELECT * FROM ".$DbTableNameOrders. " ORDER BY datetime DESC";
      $mysql_result=pl_mysql_query($query,$mysql_payloom);
      while($row=pl_mysql_fetch_array_assoc($mysql_result))
      {
        $rs .= '<tr>
        <td>'.$row['orderno'].'</td>
        <td>'.$row['datetime'].'</td> 
        <td>'.$row['total'].'</td>
        <td>'.$row['name'].'</td> 
        <td>'.$row['email'].'</td>
    <td><button type="button" class="btn btn-primary" data-transid="'.$row['orderno'].'" data-toggle="modal" data-target="#order-modal">show</button></td>
        </tr>';    
      }
    }
    
    return $rs;
}

function getOrder($orderno)
{
  global $DbTableNameOrders, $mysql_payloom, $SellerEmail, $SellerCompany;
  global $custom1Title,$custom2Title,$custom3Title,$custom4Title;

  
  $rs='<div class="alert alert-danger">Order Not Found</div>';

  if ($DbTableNameOrders!="")
    {
      $query="SELECT * FROM ".$DbTableNameOrders." WHERE orderno = '". $orderno . "' LIMIT 1";
      $mysql_result=pl_mysql_query($query,$mysql_payloom);
      while($row=pl_mysql_fetch_array_assoc($mysql_result))
      {
        
        $rs = '<div class="container outer-section" style="max-width:100%;">
        
       <h2>'.$SellerCompany.'</h2>
        <div id="print-area">
          <hr>
            <div class="row text-center">
                <div class="col-sm-12">
                    This is an electronic generated receipt , for any issues please contact <strong> '. $SellerEmail. '</strong>

                </div>
            </div>
            <hr>

            <div class="row ">
              <div class="col-lg-6 col-md-6 col-sm-6">
                    <h4>Payment Details :</h4>
                    <strong>Transaction No: </strong>#'.$row['orderno'].'<br>
                    <strong>Method: </strong> '.$row['method'].'<br>
                    <strong>Processor: </strong> '.$row['processor'].'<br>
                    <strong>Date:</strong>  '.$row['datetime'].'<br>
                    <strong>Total : </strong>'.$row['total'].' '. $row['currency'].'<br>
                    <strong>Order Status : </strong>'. $row['orderstatus'] .'<br>
                </div>
                <div class="col-lg-6 col-md-6 col-sm-6">
                    <h4>Billing Details :</h4>
                    <strong>'.$row['name'].'</strong><br>';
                    if($row['company'])
                      $rs .= $row['company'].'<br>';
                    $rs .= $row['street1']. '<br>';
                    if($row['street2'])
                      $rs .= $row['street2'].'<br>';
                    $rs .= $row['city'].' , '.$row['country'].' '. $row['zip'].'<br>
                    '.$row['country']. '<br>
                    <strong>Email: </strong>'.$row['email'].'<br>';
                    if($row['telephone'])
                      $rs .= $row['telephone'].'<br>';
                $rs .= '</div>';

            $rs .= '</div>
            <hr>
            <br>
            <div class="row">
                <div class="col-lg-12 col-md-12 col-sm-12">
                <h3> '. $row['numitems'] .' Items Ordered</h3>
                    <div class="table-responsive">
                        <table class="table table-striped table-bordered table-hover">
                            <thead>
                                <tr>
                                    <th>No.</th>
                                    <th>Name</th>
                                    <th>Quantity.</th>
                                    <th>Price</th>
                                    <th>Sub Total</th>
                                </tr>
                            </thead>
                            <tbody>';
                            
                            $itemnumbers = explode('|', $row['itemnumber']);
                            $itemnames = explode('|', $row['itemname']);
                            $itemoptions = explode('|', $row['itemoptions']);
                            $qty = explode('|', $row['quantity']);
                            $prices = explode('|', $row['price']);
                            
                            for ($i = 0; $i < count($itemnumbers); $i++) {
                                $rs .= '<tr>';
                                $rs .= '<td>'.$itemnumbers[$i].'</td>';
                                $rs .= '<td>'.$itemnames[$i].'<br><em class="text-muted">'.nl2br($itemoptions[$i]).'</em></td>';
                                $rs .= '<td>'.$qty[$i].'</td>';
                                $rs .= '<td>'.$prices[$i].' '.$row['currency'].'</td>';
                                $rs .= '<td>'.($prices[$i]*$qty[$i]).' '.$row['currency'].'</td>';
                                $rs .= '</tr>';
                            }

                        $rs .='    </tbody>
                        </table>
                    </div>
                </div>
            </div>
            <hr>
            <div class="row">
            
              <div class="col-lg-9 col-md-9 col-sm-9" style="text-align: right; padding-right: 30px;">
                    Discount Amount : 
                </div>
                <div class="col-lg-3 col-md-3 col-sm-3 text-danger">
                    - '.$row['discount'].' '. $row['currency'].'
                </div>
                
              <div class="col-lg-9 col-md-9 col-sm-9" style="text-align: right; padding-right: 30px;">
                    Tax Amount : 
                </div>
                <div class="col-lg-3 col-md-3 col-sm-3">
                    '.$row['tax'].' '. $row['currency'].'
                </div>
                
                <div class="col-lg-9 col-md-9 col-sm-9" style="text-align: right; padding-right: 30px;">
                    Shipping Amount : 
                </div>
                <div class="col-lg-3 col-md-3 col-sm-3">
                    '.$row['shipping'].' '. $row['currency'].'
                </div>
                
                <div class="col-lg-9 col-md-9 col-sm-9" style="text-align: right; padding-right: 30px;">
                    Fee Amount : 
                </div>
                <div class="col-lg-3 col-md-3 col-sm-3">
                    '.$row['fee'].' '. $row['currency'].'
                </div>
                
                
                <div class="col-lg-9 col-md-9 col-sm-9" style="text-align: right; padding-right: 30px;">
                    Total Amount : 
                </div>
                <div class="col-lg-3 col-md-3 col-sm-3">
                    <strong>'.$row['total'].' '. $row['currency'].' </strong>
                </div>
            </div>';
            
            if($row['message'])
            {
            $rs .= '<hr>
	            <div class="row">
	                <div class="col-sm-12">
	                    <strong>Message:</strong>
	                    <p>'. $row['message']. '</p>
	                </div>
	            </div>';
            }
            
            // Custom 1
			if($row['custom1'])
            {
	            $rs .= '<hr>
	            <div class="row">
	                <div class="col-sm-12">
	                    <strong>'.$custom1Title.':</strong>
	                    <p>'. $row['custom1']. '</p>
	                </div>
	            </div>';
            }
            
            // Custom 2
            if($row['custom2'])
            {
	            $rs .= '<hr>
	            <div class="row">
	                <div class="col-sm-12">
	                    <strong>'.$custom2Title.':</strong>
	                    <p>'. $row['custom2']. '</p>
	                </div>
	            </div>';
            }
            
             // Custom 3
            if($row['custom3'])
            {
	            $rs .= '<hr>
	            <div class="row">
	                <div class="col-sm-12">
	                    <strong>'.$custom3Title.':</strong>
	                    <p>'. $row['custom3']. '</p>
	                </div>
	            </div>';
            }
            
             // Custom 4
            if($row['custom4'])
            {
	            $rs .= '<hr>
	            <div class="row">
	                <div class="col-sm-12">
	                    <strong>'.$custom4Title.':</strong>
	                    <p>'. $row['custom4']. '</p>
	                </div>
	            </div>';
            }
            
            
        $rs .= '</div>
    </div>';
   
      }
    }
    
    return $rs;
}

// DRY NAVBAR
function getNavbar($logged_in=false)
{

  $nav = '<p>
  <div class="btn-group btn-group-justified" role="group" aria-label="Payloom Navigation">
      <!-- <a href="?testform=1" class="btn btn-default">Test Form</a> -->
    <a href="?orderform=1" class="btn btn-default">Manual Form</a>
    <a href="?vieworders=1" class="btn btn-default">View Orders</a>';
  
  if($logged_in)
    $nav .= '<a href="?logout=1" class="btn btn-default">Logout</a>';
  
  $nav .= '</div></p>';

  return $nav;

}

?>